package com.pallas.ogsa.extensions;

import javax.xml.namespace.QName;

import org.gridforum.www.ogsi.ReferenceType;

/**
 *@author     Ralf Ratering
 *@created    12. Mrz 2003
 *@version    $Id: ServiceReferenceType.java,v 1.2 2003/06/30 06:50:42 rrate Exp $
 */
public class ServiceReferenceType extends ReferenceType {
	private QName qName;
	private String wsdlURL;

	/**
	 *  Constructor for the SiteReferenceType object
	 */
	public ServiceReferenceType() {
		this("", null);
	}

	/**
	 *  Constructor for the ServiceReferenceType object
	 *
	 *@param  wsdlURL  Description of the Parameter
	 *@param  qName    Description of the Parameter
	 */
	public ServiceReferenceType(String wsdlURL, QName qName) {
		this.wsdlURL = wsdlURL;
		this.qName = qName;
	}

	/**
	 *  Gets the qName attribute of the ServiceReferenceType object
	 *
	 *@return    The qName value
	 */
	public QName getQName() {
		return qName;
	}

	/**
	 *  Gets the uRL attribute of the ServiceReferenceType object
	 *
	 *@return    The uRL value
	 */
	public String getWsdlURL() {
		return wsdlURL;
	}

	/**
	 *  Sets the qName attribute of the ServiceReferenceType object
	 *
	 *@param  qName  The new qName value
	 */
	public void setQName(QName qName) {
		this.qName = qName;
	}

	/**
	 *  Sets the URL attribute of the ServiceReferenceType object
	 *
	 *@param  wsdlURL  The new wsdlURL value
	 */
	public void setWsdlURL(String wsdlURL) {
		this.wsdlURL = wsdlURL;
	}
}
