package com.pallas.ogsa.registry;

import java.rmi.Remote;
import java.rmi.RemoteException;

import org.gridforum.www.ogsi.HandleType;
import org.gridforum.www.ogsi.LocatorType;

/**
 *@author     Ralf Ratering
 *@created    11. Mrz 2003
 *@version    $Id: ISiteRegistry.java,v 1.3 2003/07/03 06:48:31 rrate Exp $
 */
public interface ISiteRegistry extends Remote {
	/**
	 *  Description of the Method
	 *
	 *@param  siteLocator          Description of the Parameter
	 *@exception  RemoteException  Description of the Exception
	 */
	public void add(LocatorType siteLocator) throws RemoteException;

	/**
	 *  Gets the sites attribute of the ISiteRegistry object
	 *
	 *@return                      The sites value
	 *@exception  RemoteException  Description of the Exception
	 */
	public LocatorType[] getSites() throws RemoteException;

	/**
	 *  Description of the Method
	 *
	 *@param  serviceHandle        Description of the Parameter
	 *@exception  RemoteException  Description of the Exception
	 */
	public void remove(HandleType serviceHandle) throws RemoteException;
}
