package com.pallas.ogsa.server;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.io.OutputStream;
import java.net.URL;
import java.text.ParseException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;
import javax.swing.text.MaskFormatter;
import javax.xml.namespace.QName;

import org.apache.axis.client.Service;
import org.apache.axis.types.URI;
import org.gridforum.www.ogsi.HandleType;
import org.gridforum.www.ogsi.LocatorType;
import org.gridforum.www.ogsi.ReferenceType;

import com.pallas.ogsa.extensions.ServiceReferenceType;
import com.pallas.ogsa.registry.ISiteRegistry;
import com.pallas.ogsa.registry.SiteRegistry;
import com.pallas.ogsa.registry.SiteRegistryStub;
import com.pallas.ogsa.services.caservice.CAService;
import com.pallas.ogsa.services.caservice.ICAService;
import com.pallas.ogsa.services.uplstatic.IUPL;
import com.pallas.ogsa.services.uplstatic.UPLServiceSoapBindingImpl;

/**
 *@author     Ralf Ratering
 *@created    11. M?rz 2003
 *@version    $Id: ServerFrame.java,v 1.5 2003/07/02 15:35:25 thomas Exp $
 */
public class ServerFrame extends JFrame {

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    11. M?rz 2003
	 */
	private class LogStream extends OutputStream {
		/**
		 *  Description of the Method
		 *
		 *@param  i  Description of the Parameter
		 */
		public void write(int i) {
			byte[] bytes = {(byte) i };
			logArea.append(new String(bytes));
		}
	}

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    11. M?rz 2003
	 */
	private class StartAction extends AbstractAction {
		/**
		 *  Constructor for the ExitAction object
		 */
		public StartAction() {
			super("Start");
		}

		/**
		 *  Description of the Method
		 *
		 *@param  e  Description of the Parameter
		 */
		public void actionPerformed(ActionEvent e) {
			/*            Thread serverThread =
			                new Thread() {
			  
			                    public void run() {
			                        log("Starting server...");
			                        // String[] args = {"-p", portField.getText()};
						String [] args = {"../etc/httpconfig.xml", "HTTP_Connector_1"};
			                        server = new Server(args);
			                        server.setLogStream(new PrintStream(new LogStream()));
			                        try {
			                            deployService();
			                            server.start();
			                        }
			                        catch(Exception ex) {
			                            log("Could not initialize server.");
			                            log(ex.toString());
			                            logger.log(Level.SEVERE, "Could not initialize server.", ex);
			                        }
			                    }
			                };
			            serverThread.start(); */

			ServerStartup serverStartup = new ServerStartup();
			try {
				String[] args1 = { "../etc/httpconfig2.xml" };
				httpServer =
					serverStartup.attachServer(args1, "HTTP_Connector_1");
				String[] args2 = { "../etc/httpsconfig2.xml" };
				httpsServer =
					serverStartup.attachServer(args2, "HTTPS_Connector_1");

				// registry service  HTTP now
/*				httpServer.getDeployment().deploy(
					SiteRegistry.class.getName(),
					"SiteRegistry",
					"unicore/services",
					ISiteRegistry.class);

				// CA service for testgrid HTTP
				String caServiceName = "CAService";
				String caServiceDir = "unicore/services";
				httpServer.getDeployment().deploy(
					CAService.class.getName(),
					caServiceName,
					caServiceDir,
					ICAService.class);

				// UPL service HTTPS
				String uplServiceName = "UPLService";
				String uplServiceDir = "unicore/services";
				String url =
					httpServer.getURL()
						+ "/"
						+ uplServiceDir
						+ "/"
						+ uplServiceName;
				QName uplQname =
					new QName("http://services.ogsa.pallas.com", "UPLService");
				httpsServer.getDeployment().deploy(
					UPLServiceSoapBindingImpl.class.getName(),
					uplServiceName,
					uplServiceDir,
					IUPL.class); */
					deployService();

			} catch (Exception exp) {
				logger.log(Level.SEVERE, "Could not start server.", exp);
			}

		}
	}

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    11. M?rz 2003
	 */
	private class StopAction extends AbstractAction {
		/**
		 *  Constructor for the ExitAction object
		 */
		public StopAction() {
			super("Stop");
		}

		/**
		 *  Description of the Method
		 *
		 *@param  e  Description of the Parameter
		 */
		public void actionPerformed(ActionEvent e) {
			try {
				log("Stopping server...");
				httpServer.stop();
				httpsServer.stop();
				log("Server stopped.");
			} catch (Exception ex) {
				log("Could not stop server.");
				log(ex.toString());
			}
		}
	}
	/**
	 *  Description of the Field
	 */
	protected static Logger logger =
		Logger.getLogger("com.pallas.ogsa.service");

	/**
	 *  The main program for the ServerFrame class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		ServerFrame serverFrame = new ServerFrame();
		serverFrame.setSize(800, 600);
		serverFrame.setVisible(true);
	}
	/**
	 *  Description of the Field
	 */
	protected JPanel controlPanel;
	/**
	 *  Description of the Field
	 */
	protected JTextArea logArea;
	/**
	 *  Description of the Field
	 */
	protected JFormattedTextField portField;
	/**
	 *  Description of the Field
	 */
	protected LocatorType registryLocator;
	/**
	 *  Description of the Field
	 */
	protected Server httpServer;
	protected Server httpsServer;
	protected Server server;

	/**
	 *  Constructor for the ServerFrame object
	 */
	public ServerFrame() {
		setTitle("UNICOREpro Server");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		buildComponents();
		addComponents();
		setRegistry(
			"http://www.unicore.org/SiteRegistry",
			"http://localhost:9001/unicore/services/SiteRegistry?WSDL",
			new QName("http://services.ogsa.pallas.com", "SiteRegistry"));
	}

	/**
	 *  Adds a feature to the Components attribute of the ServerFrame object
	 */
	protected void addComponents() {
		getContentPane().add(new JScrollPane(logArea), BorderLayout.CENTER);
		getContentPane().add(controlPanel, BorderLayout.SOUTH);
	}

	/**
	 *  Description of the Method
	 */
	protected void buildComponents() {

		logArea = new JTextArea();
		logArea.setFont(new Font("monospaced", Font.PLAIN, 11));
		logArea.setBorder(new TitledBorder("Log"));
		logArea.setLineWrap(true);
		logArea.setEditable(false);

		try {
			portField = new JFormattedTextField(new MaskFormatter("#####"));
			portField.setText("9000");
		} catch (ParseException e) {
			logger.log(Level.SEVERE, "Could not parse port text field.", e);
		}

		JLabel portLabel = new JLabel("Port:");
		portLabel.setLabelFor(portField);
		JPanel portPanel = new JPanel();
		portPanel.add(portLabel);
		portPanel.add(portField);

		controlPanel = new JPanel();
		controlPanel.add(portPanel);
		controlPanel.add(new JButton(new StartAction()));
		controlPanel.add(new JButton(new StopAction()));
	}

	/**
	 *  Constructor for the deployService object
	 */
	protected void deployService() {
		logger.info("Overwrite this method to deploy your service.");
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of the Parameter
	 */
	protected void log(String message) {
		logArea.append(message + "\n");
	}

	/**
	 *  Description of the Method
	 *
	 *@param  locator        Description of the Parameter
	 *@exception  Exception  Description of the Exception
	 */
	public void registerService(LocatorType locator) throws Exception {
		HandleType handle = registryLocator.getServiceHandle();
		ServiceReferenceType reference =
			(ServiceReferenceType) registryLocator.getServiceReference();
		Service service =
			new Service(reference.getWsdlURL(), reference.getQName());
		ISiteRegistry registry =
			new SiteRegistryStub(new URL(reference.getWsdlURL()), service);
		registry.add(locator);
	}

	/**
	 *  Sets the registry attribute of the ServerFrame object
	 *
	 *@param  registryAddress  The new registry value
	 *@param  registryQName    The new registry value
	 *@param  registryHandle   The new registry value
	 */
	public void setRegistry(
		String registryHandle,
		String registryAddress,
		QName registryQName) {
		registryLocator = new LocatorType();

		//      ArrayList handles = new ArrayList();
		//          handles.add(new HandleType(new URI(registryHandle)));
		try {
			registryLocator.setServiceHandle(
				new HandleType(new URI(registryHandle)));
		} catch (URI.MalformedURIException e) {
			logger.log(
				Level.SEVERE,
				"Malformed Handle URI: " + registryHandle,
				e);
		}

		ReferenceType reference =
			new ServiceReferenceType(registryAddress, registryQName);
		registryLocator.setServiceReference(reference);

	}

	/**
	 *  Sets the registryLocator attribute of the ServerFrame object
	 *
	 *@param  registryLocator  The new registryLocator value
	 */
	public void setRegistryLocator(LocatorType registryLocator) {
		this.registryLocator = registryLocator;
	}

}
