package com.pallas.ogsa.services.caservice;

import javax.xml.namespace.QName;

import com.pallas.ogsa.server.Deployment;
import com.pallas.ogsa.server.ServerFrame;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    7. April 2003
 *@version    $Id: CAServiceServerFrame.java,v 1.5 2003/07/08 09:52:36 thomas Exp $
 */
public class CAServiceServerFrame extends ServerFrame {

	/**
	 *  The main program for the ServerFrame class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		CAServiceServerFrame serverFrame = new CAServiceServerFrame();
		serverFrame.setSize(600, 250);
		serverFrame.setVisible(true);
	}
	/**
	 *  Constructor for the ServerFrame object
	 */
	public CAServiceServerFrame() {
		setTitle("UNICOREpro CA Service Server");
	}

	/**
	 *  Description of the Method
	 */
	protected void deployService() {
		String serviceName = "CAService";
		String serviceDir = "unicore/services";
		String url =
			server.getURL() + "/" + serviceDir + "/" + serviceName + "?WSDL";
		QName qname = new QName("http://services.ogsa.pallas.com", "CAService");

		Deployment deployment = new Deployment(server.getAxisServer());
		deployment.deploy(
			CAService.class.getName(),
			serviceName,
			serviceDir,
			ICAService.class, "per-access");
	}

}
