package com.pallas.ogsa.services.caservice;

import java.rmi.RemoteException;

import javax.xml.namespace.QName;
import javax.xml.rpc.Service;

import org.apache.axis.AxisFault;
import org.apache.axis.client.Call;
import org.apache.axis.description.OperationDesc;
import org.apache.axis.description.ParameterDesc;

import com.pallas.ogsa.util.OGSIStub;
import com.pallas.ogsa.util.ObjectWrapperBean;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    21. Februar 2003
 *@version    $Id: CAServiceStub.java,v 1.2 2003/06/30 06:51:08 rrate Exp $
 */
public class CAServiceStub extends OGSIStub implements ICAService {
	/**
	 *  Constructor for the IUPLSoapBindingStub object
	 *
	 *@exception  AxisFault  Description of the Exception
	 */
	public CAServiceStub() throws AxisFault {
		this(null);
	}

	/**
	 *  Constructor for the IUPLSoapBindingStub object
	 *
	 *@param  endpointURL    Description of the Parameter
	 *@param  service        Description of the Parameter
	 *@exception  AxisFault  Description of the Exception
	 */
	public CAServiceStub(java.net.URL endpointURL, Service service)
		throws AxisFault {
		this(service);
		super.cachedEndpoint = endpointURL;
	}

	/**
	 *  Constructor for the IUPLSoapBindingStub object
	 *
	 *@param  service        Description of the Parameter
	 *@exception  AxisFault  Description of the Exception
	 */
	public CAServiceStub(Service service) throws AxisFault {
		if (service == null) {
			super.service = new org.apache.axis.client.Service();
		} else {
			super.service = service;
		}
		init();
		setPortName("ICAService");
	}

	/**
	 *  Description of the Method
	 *
	 *@return                      Description of the Return Value
	 *@exception  RemoteException  Description of the Exception
	 */
	public ObjectWrapperBean getCACertificate() throws RemoteException {
		if (super.cachedEndpoint == null) {
			throw new org.apache.axis.NoEndPointException();
		}
		Call call = createCall();
		call.setOperation((OperationDesc) operations.get("getCACertificate"));
		call.setOperationName(
			new QName(
				"http://caservice.services.ogsa.pallas.com",
				"getCACertificate"));

		Object resp = call.invoke(new Object[0]);
		return getResponse(call, resp);
	}

	/**
	 *  Description of the Method
	 */
	protected void init() {

		operations.clear();

		Class wrapperClass = ObjectWrapperBean.class;

		// consign
		OperationDesc desc = new OperationDesc();
		desc.setName("getCACertificate");
		desc.setReturnType(
			new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.setReturnClass(wrapperClass);
		desc.setReturnQName(new QName("", "getCACertificateReturn"));
		desc.setStyle(org.apache.axis.enum.Style.RPC);
		desc.setUse(org.apache.axis.enum.Use.LITERAL);

		operations.put(desc.getName(), desc);

		desc = new OperationDesc();
		desc.setName("signRequest");

		ParameterDesc param =
			new ParameterDesc(
				new QName("", "csr"),
				ParameterDesc.IN,
				new QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
		desc.addParameter(param);

		desc.setReturnType(
			new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.setReturnClass(wrapperClass);
		desc.setReturnQName(new QName("", "signRequestReturn"));
		desc.setStyle(org.apache.axis.enum.Style.RPC);
		desc.setUse(org.apache.axis.enum.Use.LITERAL);

		operations.put(desc.getName(), desc);

	}

	/**
	 *  Description of the Method
	 *
	 *@param  request              Description of the Parameter
	 *@return                      Description of the Return Value
	 *@exception  RemoteException  Description of the Exception
	 */
	public ObjectWrapperBean signRequest(byte[] csr) throws RemoteException {
		if (super.cachedEndpoint == null) {
			throw new org.apache.axis.NoEndPointException();
		}
		Call call = createCall();
		call.setOperation((OperationDesc) operations.get("signRequest"));
		call.setOperationName(
			new QName(
				"http://caservice.services.ogsa.pallas.com",
				"signRequest"));

		Object resp = call.invoke(new Object[] { csr });
		return getResponse(call, resp);
	}

}
