package com.pallas.ogsa.services.upl;

import java.util.logging.Logger;

import org.unicore.AJOIdentifier;
import org.unicore.upl.ConsignJob;
import org.unicore.upl.Reply;
import org.unicore.upl.UnicoreResponse;

import com.pallas.ogsa.util.ObjectWrapperBean;

/**
 *@author     Ralf Ratering
 *@created    29. Januar 2003
 *@version    $Id: UPL.java,v 1.2 2003/06/30 06:51:16 rrate Exp $
 */
public class UPL implements IUPL {
	private static Logger logger =
		Logger.getLogger("com.pallas.ogsa.services.upl");

	/**
	 *  Description of the Method
	 *
	 *@param  consignJobWrapper  Description of the Parameter
	 *@return                    Description of the Return Value
	 */
	public ObjectWrapperBean consign(ObjectWrapperBean consignJobWrapper) {
		//    public ObjectWrapperBean consign(String job) {
		ConsignJob job = (ConsignJob) consignJobWrapper.deserialize();
		Reply reply = new Reply();
		reply.addTraceEntry(
			new UnicoreResponse(123, "Successfully consigned job: " + job));
		return new ObjectWrapperBean(reply);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  ajoIdWrapper  Description of the Parameter
	 *@return               Description of the Return Value
	 */
	public ObjectWrapperBean retrieveOutcome(ObjectWrapperBean ajoIdWrapper) {
		AJOIdentifier job = (AJOIdentifier) ajoIdWrapper.deserialize();
		Reply reply = new Reply();
		reply.addTraceEntry(
			new UnicoreResponse(
				123,
				"Successfully retrieved outcome for job: " + job));
		return new ObjectWrapperBean(reply);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  ajoIdWrapper  Description of the Parameter
	 *@return               Description of the Return Value
	 */
	public ObjectWrapperBean retrieveOutcomeAck(ObjectWrapperBean ajoIdWrapper) {
		AJOIdentifier job = (AJOIdentifier) ajoIdWrapper.deserialize();
		Reply reply = new Reply();
		reply.addTraceEntry(
			new UnicoreResponse(
				123,
				"Successfully sent retrieve outcome acknowledge for job: "
					+ job));
		return new ObjectWrapperBean(reply);
	}

}
