package com.pallas.ogsa.services.upl;

import java.util.logging.Level;

import javax.xml.namespace.QName;

import org.apache.axis.types.URI;
import org.gridforum.www.ogsi.HandleType;
import org.gridforum.www.ogsi.LocatorType;
import org.gridforum.www.ogsi.ReferenceType;

import com.pallas.ogsa.extensions.ServiceReferenceType;
import com.pallas.ogsa.server.Deployment;
import com.pallas.ogsa.server.ServerFrame;

/**
 *@author     Ralf Ratering
 *@created    11. M?rz 2003
 *@version    $Id: UPLServerFrame.java,v 1.4 2003/07/08 09:52:41 thomas Exp $
 */
public class UPLServerFrame extends ServerFrame {

	/**
	 *  The main program for the ServerFrame class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		UPLServerFrame serverFrame = new UPLServerFrame();
		serverFrame.setSize(800, 600);
		serverFrame.setVisible(true);
	}
	/**
	 *  Constructor for the ServerFrame object
	 */
	public UPLServerFrame() {
		setTitle("UNICOREpro Site Server");
	}

	/**
	 *  Description of the Method
	 */
	protected void deployService() {
		try {
			String serviceName = "UPLService";
			String serviceDir = "unicore/services";
			String url =
				server.getURL()
					+ "/"
					+ serviceDir
					+ "/"
					+ serviceName
					+ "?WSDL";
			QName qname =
				new QName("http://services.ogsa.pallas.com", "UPLService");

			Deployment deployment = new Deployment(server.getAxisServer());
			deployment.deploy(
				UPL.class.getName(),
				serviceName,
				serviceDir,
				IUPL.class, "per-access");

			LocatorType locator = new LocatorType();
			//      ArrayList handles = new ArrayList();
			try {
				HandleType handle =
					new HandleType(new URI("http://www.pallas.com/fender"));
				locator.setServiceHandle(handle);
			} catch (URI.MalformedURIException e) {
				logger.log(Level.SEVERE, "Malformed Handle URI.", e);
			}

			ReferenceType reference = new ServiceReferenceType(url, qname);
			locator.setServiceReference(reference);

			registerService(locator);
		} catch (Exception e) {
			log("Could not register service.");
			logger.log(Level.WARNING, "Could not register service.", e);
		}

	}

}
