package com.pallas.ogsa.services.upl;

import java.rmi.RemoteException;

import javax.xml.namespace.QName;
import javax.xml.rpc.Service;

import org.apache.axis.AxisFault;
import org.apache.axis.client.Call;
import org.apache.axis.description.OperationDesc;
import org.apache.axis.description.ParameterDesc;

import com.pallas.ogsa.util.OGSIStub;
import com.pallas.ogsa.util.ObjectWrapperBean;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    21. Februar 2003
 *@version    $Id: UPLStub.java,v 1.2 2003/06/30 06:51:15 rrate Exp $
 */
public class UPLStub extends OGSIStub implements IUPL {
	/**
	 *  Constructor for the IUPLSoapBindingStub object
	 *
	 *@exception  AxisFault  Description of the Exception
	 */
	public UPLStub() throws AxisFault {
		this(null);
	}

	/**
	 *  Constructor for the IUPLSoapBindingStub object
	 *
	 *@param  endpointURL    Description of the Parameter
	 *@param  service        Description of the Parameter
	 *@exception  AxisFault  Description of the Exception
	 */
	public UPLStub(java.net.URL endpointURL, Service service)
		throws AxisFault {
		this(service);
		super.cachedEndpoint = endpointURL;
	}

	/**
	 *  Constructor for the IUPLSoapBindingStub object
	 *
	 *@param  service        Description of the Parameter
	 *@exception  AxisFault  Description of the Exception
	 */
	public UPLStub(Service service) throws AxisFault {
		if (service == null) {
			super.service = new org.apache.axis.client.Service();
		} else {
			super.service = service;
		}
		init();
		setPortName("IUPL");
	}

	/**
	 *  Description of the Method
	 *
	 *@param  consignJobWrapper    Description of the Parameter
	 *@return                      Description of the Return Value
	 *@exception  RemoteException  Description of the Exception
	 */
	public ObjectWrapperBean consign(ObjectWrapperBean consignJobWrapper)
		throws RemoteException {
		if (super.cachedEndpoint == null) {
			throw new org.apache.axis.NoEndPointException();
		}
		Call call = createCall();
		call.setOperation((OperationDesc) operations.get("consign"));
		call.setOperationName(
			new QName("http://upl.services.ogsa.pallas.com", "consign"));

		Object resp = call.invoke(new Object[] { consignJobWrapper });
		return getResponse(call, resp);
	}

	/**
	 *  Description of the Method
	 */
	protected void init() {

		operations.clear();

		Class wrapperClass = ObjectWrapperBean.class;

		// consign
		OperationDesc desc = new OperationDesc();
		desc.setName("consign");

		ParameterDesc param =
			new ParameterDesc(
				new QName("", "consignJobWrapper"),
				ParameterDesc.IN,
				new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.addParameter(param);

		desc.setReturnType(
			new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.setReturnClass(wrapperClass);
		desc.setReturnQName(new QName("", "consignReturn"));
		desc.setStyle(org.apache.axis.enum.Style.RPC);
		desc.setUse(org.apache.axis.enum.Use.LITERAL);

		operations.put(desc.getName(), desc);

		// retrieveOutcome
		desc = new OperationDesc();
		desc.setName("retrieveOutcome");

		param =
			new ParameterDesc(
				new QName("", "ajoIDWrapper"),
				ParameterDesc.IN,
				new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.addParameter(param);

		desc.setReturnType(
			new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.setReturnClass(wrapperClass);
		desc.setReturnQName(new QName("", "retrieveReturn"));
		desc.setStyle(org.apache.axis.enum.Style.RPC);
		desc.setUse(org.apache.axis.enum.Use.LITERAL);

		operations.put(desc.getName(), desc);

		// retrieveOutcomeAck
		desc = new OperationDesc();
		desc.setName("retrieveOutcomeAck");
		param =
			new ParameterDesc(
				new QName("", "ajoIDWrapper"),
				ParameterDesc.IN,
				new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.addParameter(param);

		desc.setReturnType(
			new QName("http://util.ogsa.pallas.com", "ObjectWrapperBean"));
		desc.setReturnClass(wrapperClass);
		desc.setReturnQName(new QName("", "retrieveAckReturn"));
		desc.setStyle(org.apache.axis.enum.Style.RPC);
		desc.setUse(org.apache.axis.enum.Use.LITERAL);

		operations.put(desc.getName(), desc);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  ajoIdWrapper         Description of the Parameter
	 *@return                      Description of the Return Value
	 *@exception  RemoteException  Description of the Exception
	 */
	public ObjectWrapperBean retrieveOutcome(ObjectWrapperBean ajoIdWrapper)
		throws RemoteException {
		if (super.cachedEndpoint == null) {
			throw new org.apache.axis.NoEndPointException();
		}
		Call call = createCall();
		call.setOperation((OperationDesc) operations.get("retrieveOutcome"));
		call.setOperationName(
			new QName(
				"http://upl.services.ogsa.pallas.com",
				"retrieveOutcome"));

		Object resp = call.invoke(new Object[] { ajoIdWrapper });
		return getResponse(call, resp);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  ajoIdWrapper         Description of the Parameter
	 *@return                      Description of the Return Value
	 *@exception  RemoteException  Description of the Exception
	 */
	public ObjectWrapperBean retrieveOutcomeAck(ObjectWrapperBean ajoIdWrapper)
		throws RemoteException {
		if (super.cachedEndpoint == null) {
			throw new org.apache.axis.NoEndPointException();
		}
		Call call = createCall();
		call.setOperation((OperationDesc) operations.get("retrieveOutcomeAck"));
		call.setOperationName(
			new QName(
				"http://upl.services.ogsa.pallas.com",
				"retrieveOutcomeAck"));

		Object resp = call.invoke(new Object[] { ajoIdWrapper });
		return getResponse(call, resp);
	}

}
