/**
 * UPLServiceSoapBindingImpl.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis WSDL2Java emitter.
 */

package com.pallas.ogsa.services.uplstatic;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.rmi.RemoteException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.Vector;
import java.util.Hashtable;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.FileHandler;
import org.unicore.AJOIdentifier;
import org.unicore.Ulogin;
import org.unicore.upl.ConsignJob;
import org.unicore.upl.Reply;
import org.unicore.upl.RetrieveOutcomeReply;
import org.unicore.upl.ServerRequest;
import org.unicore.upl.UnicoreResponse;
import org.unicore.utility.PacketisedInputStream;
import org.unicore.utility.PacketisedOutputStream;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.Parser;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.ParserAdapter;
import org.xml.sax.helpers.ParserFactory;
import org.xml.sax.helpers.XMLReaderFactory;

import com.pallas.ogsa.util.ObjectWrapperBean;
import com.pallas.util.queues.WorkerThread;

public class UPLServiceSoapBindingImpl
	implements com.pallas.ogsa.services.uplstatic.IUPL {

	/**
	 *  Description of the Class
	 *
	 *@author     thomas
	 *@created    September 27, 2001
	 */
	private class ServiceSaxHandler extends DefaultHandler {
		Vector foundSites = new Vector();

		/**
		 *  Description of the Method
		 *
		 *@param  buf               Description of Parameter
		 *@param  offset            Description of Parameter
		 *@param  len               Description of Parameter
		 *@exception  SAXException  Description of Exception
		 */
		public void characters(char[] buf, int offset, int len)
			throws SAXException {
		}

		/**
		 *  Description of the Method
		 *
		 *@exception  SAXException  Description of Exception
		 */
		public void endDocument() throws SAXException {
		}

		/**
		 *  Description of the Method
		 *
		 *@param  namespaceURI      Description of Parameter
		 *@param  sName             Description of Parameter
		 *@param  qName             Description of Parameter
		 *@exception  SAXException  Description of Exception
		 */
		public void endElement(String namespaceURI, String sName, String qName)
			throws SAXException {
			// qualified name
		}

		//===========================================================
		// SAX DocumentHandler methods
		//===========================================================

		/**
		 *  Description of the Method
		 *
		 *@exception  SAXException  Description of Exception
		 */
		public void startDocument() throws SAXException {
		}

		/**
		 *  Description of the Method
		 *
		 *@param  namespaceURI      Description of Parameter
		 *@param  lName             Description of Parameter
		 *@param  qName             Description of Parameter
		 *@param  attrs             Description of Parameter
		 *@exception  SAXException  Description of Exception
		 */
		public void startElement(
			String namespaceURI,
			String lName,
			String qName,
			Attributes attrs)
			throws SAXException {
			String elementName = lName;
			if ("".equals(elementName)) {
				elementName = qName;

				// namespaceAware = false
			}

			// read keystore information

			if (elementName.equals("vsite")) {
				if (attrs != null) {
					String name = null;
					String host = null;
					String port = null;
					int intPort = 0;
					String type = null;

					for (int i = 0; i < attrs.getLength(); i++) {
						String aName = attrs.getLocalName(i);

						// Attr name
						if ("".equals(aName)) {
							aName = attrs.getQName(i);
						}
						if (aName.equals("name")) {
							name = attrs.getValue(i);
						}
						if (aName.equals("host")) {
							host = attrs.getValue(i);
						}

						if (aName.equals("port")) {
							port = attrs.getValue(i);
							intPort = Integer.parseInt(port);
						}
						if (aName.equals("type")) {
							type = attrs.getValue(i);
						}

					}

					if (host != null
						&& port != null
						&& name != null
						&& type != null) {
						try {
							System.out.println(
								">>>>>>>>> New: " + host + " " + port);
							VsiteConnection vsiteConnection =
								new VsiteConnection(name, host, intPort, type);
							vsites.put(name, vsiteConnection);
						} catch (Exception e) {
							logger.log(Level.SEVERE, "Error parsing XML.", e);
						}
					}

				}
			}

		}
	}

	private int instance = 0;
	private static Logger logger =
		Logger.getLogger("com.pallas.ogsa.services.uplstatic");
	private byte[] buffer = new byte[16 * 1024];
	private final static String CONFIG_FILE_NAME =
		".." + File.separator + "etc" + File.separator + "uplservice.xml";
	private static FileHandler filePlainHandler = null;

	private Hashtable vsites = new Hashtable();

	public UPLServiceSoapBindingImpl() {
		try {
			readServiceConfiguration();
		} catch (Exception e) {
			logger.log(
				Level.SEVERE,
				"Could not read config" + e.getLocalizedMessage());
			return;
		} 
	}

	public com.pallas.ogsa.util.ObjectWrapperBean consign(
		com.pallas.ogsa.util.ObjectWrapperBean in0)
		throws java.rmi.RemoteException {
		ServerRequest job = null;

		X509Certificate peerCertificate = null;
		UPLWrapper uplWrapper = null;
		Reply reply = new Reply();
		WorkerThread worker = null;
		try {
			worker = (WorkerThread) Thread.currentThread();

		} catch (ClassCastException ce) {
			logger.severe(
				"ServiceRequest must be invoked by WorkerThread class");

			reply.addTraceEntry(
				new UnicoreResponse(
					123,
					"Internal server error: ServiceRequest must be invoked by WorkerThread class"));
			return new ObjectWrapperBean(reply);
		}

		peerCertificate = worker.getPeerCertificate();
		if (peerCertificate != null) {
			//System.out.println("Peer:\n" + peerCertificate.getSubjectDN());

		} else {
			reply.addTraceEntry(
				new UnicoreResponse(
					123,
					"Missing peer certificate. Unauthenticated session?"));
			return new ObjectWrapperBean(reply);
		}

		try {
			uplWrapper = (UPLWrapper) in0.deserialize();
			job = uplWrapper.getJob();
			X509Certificate[] chain = { peerCertificate };
			job.setConsignor(new Ulogin(chain));
		} catch (ClassCastException ce) {
			logger.severe(
				"Method consignJob  must be invoked with UPLWrapper class");

			reply.addTraceEntry(
				new UnicoreResponse(
					123,
					"Method consignJob  must be invoked with UPLWrapper class"));
			return new ObjectWrapperBean(reply);
		} catch (CertificateException e) {
			logger.log(Level.SEVERE, "Invalid Consignor." + e);
			reply.addTraceEntry(
				new UnicoreResponse(
					123,
					"Invalid consignor"));
			return new ObjectWrapperBean(reply);
		}

		VsiteConnection vsiteConnection =
			(VsiteConnection) vsites.get(job.getVsite().getName());

		if (vsiteConnection == null) {
			logger.log(
				Level.SEVERE,
				"Invalid vsite name: " + job.getVsite().getName());
			reply.addTraceEntry(
				new UnicoreResponse(
					123,
					"Invalid vsite name: " + job.getVsite().getName()));
			return new ObjectWrapperBean(reply);
		}

		try {
			logger.info(
				"New socket: "
					+ vsiteConnection.getHost()
					+ " "
					+ vsiteConnection.getPort());
			Socket outgoing =
				new Socket(
					vsiteConnection.getHost(),
					vsiteConnection.getPort());
			ObjectOutputStream oos =
				new ObjectOutputStream(outgoing.getOutputStream());
			oos.reset();
			oos.writeObject(job);
			if ((job instanceof ConsignJob)
				&& ((ConsignJob) job).hasStreamed()) {
				writeAllStreamedBytes(
					new ByteArrayInputStream(uplWrapper.getStreamedBytes()),
					outgoing.getOutputStream());
			}
			oos.flush();
			logger.info("Sent request.");
			ObjectInputStream ooi =
				new ObjectInputStream(outgoing.getInputStream());
			reply = (Reply) ooi.readObject();

			uplWrapper.setReply(reply);
			logger.info("Got reply.");
			if (reply instanceof RetrieveOutcomeReply) {
				RetrieveOutcomeReply ror = (RetrieveOutcomeReply) reply;
				if (ror.hasStreamed()) {
					byte[] allStreamedBytes =
						getAllStreamedBytes(outgoing.getInputStream());
					uplWrapper.setStreamedBytes(allStreamedBytes);
				}
			}

		} catch (Exception e) {
			logger.log(Level.SEVERE, "Sending request to vsite failed." + e);
			// e.printStackTrace();
			reply.addTraceEntry(
				new UnicoreResponse(
					123,
					"Sending request to vsite failed."
						+ e.getLocalizedMessage()));
			return new ObjectWrapperBean(reply);
		}
		logger.info("Got reply.");
		ObjectWrapperBean wrapper = new ObjectWrapperBean(uplWrapper);
		logger.info("Return wrapper");
		return wrapper;
	}

	public com.pallas.ogsa.util.ObjectWrapperBean retrieveOutcome(
		com.pallas.ogsa.util.ObjectWrapperBean in0)
		throws java.rmi.RemoteException {
		AJOIdentifier job = (AJOIdentifier) in0.deserialize();
		Reply reply = new Reply();
		reply.addTraceEntry(
			new UnicoreResponse(
				123,
				"Successfully 	retrieved outcome for job: " + job));
		return new ObjectWrapperBean(reply);
	}

	public com.pallas.ogsa.util.ObjectWrapperBean retrieveOutcomeAck(
		com.pallas.ogsa.util.ObjectWrapperBean in0)
		throws java.rmi.RemoteException {
		AJOIdentifier job = (AJOIdentifier) in0.deserialize();
		Reply reply = new Reply();
		reply.addTraceEntry(
			new UnicoreResponse(
				123,
				"Successfully 	sent retrieve outcome acknowledge for job: "
					+ job));
		return new ObjectWrapperBean(reply);
	}

	private byte[] getAllStreamedBytes(InputStream is) throws IOException {
		//BufferedInputStream bis = new BufferedInputStream(in, 16*1024);
		ByteArrayOutputStream baos = new ByteArrayOutputStream();

		// Build the Packetised streams
		PacketisedInputStream from = new PacketisedInputStream(is);
		PacketisedOutputStream to = new PacketisedOutputStream(baos);

		// >>>>>>>>>>>> Read first packet

		int read;
		read = from.read(buffer);
		logger.info("Read streamed bytes: " + read);
		while (read > 0) {

			// >>>>>>>>>>>> Write packet

			to.write(buffer, 0, read);

			// >>>>>>>>>>>> Read next packet (up to buffer size)

			read = from.read(buffer);

		}

		try {
			to.finish();
		} catch (Exception ex) {
		}
		return baos.toByteArray();

	}

	private void writeAllStreamedBytes(InputStream is, OutputStream os)
		throws IOException {
		// Build the Packetised streams
		PacketisedInputStream from = new PacketisedInputStream(is);
		PacketisedOutputStream to = new PacketisedOutputStream(os);

		// >>>>>>>>>>>> Read first packet

		int read;
		read = from.read(buffer);

		while (read > 0) {

			// >>>>>>>>>>>> Write packet

			to.write(buffer, 0, read);

			// >>>>>>>>>>>> Read next packet (up to buffer size)

			read = from.read(buffer);

		}

	}

	/**
	 *  Description of the Method
	 *
	 *@exception  Exception  Description of the Exception
	 */
	private void readServiceConfiguration() throws Exception {
		XMLReader parser = null;
		try {
			parser =
				XMLReaderFactory.createXMLReader(
					"org.apache.xerces.parsers.SAXParser");
		} catch (Exception e) {
			Parser sax1Parser =
				ParserFactory.makeParser("org.apache.xerces.parsers.SAXParser");
			parser = new ParserAdapter(sax1Parser);
			logger.warning(
				"Features and Properties not supported by SAX1 parsers");
		}
		ServiceSaxHandler handler = new ServiceSaxHandler();
		parser.setContentHandler(handler);
		parser.setErrorHandler(handler);
		File configFile = new File(CONFIG_FILE_NAME);
		if (!configFile.exists()) {
			throw new FileNotFoundException(
				"Config file " + CONFIG_FILE_NAME + " not found.");
		}
		FileInputStream fis = new FileInputStream(configFile);

		InputSource source = new InputSource(fis);
		parser.parse(source);

	}

}
