package com.pallas.ogsa.services.uplstatic;

import javax.xml.namespace.QName;
import com.pallas.ogsa.server.*;

import java.util.logging.*;

import com.pallas.ogsa.services.caservice.*;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    7. April 2003
 *@version    $Id: UPLServiceStartup.java,v 1.3 2003/07/08 09:52:36 thomas Exp $
 */
public class UPLServiceStartup extends ServerStartup {

	/**
	 *  Constructor for the ServerFrame object
	 */
	public UPLServiceStartup() {
		super();
	}

	/**
	 *  The main program for the ServerFrame class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		UPLServiceStartup serverStartup = new UPLServiceStartup();
		try {
			String[] args1 = { "../etc/httpconfig.xml" };
			Server httpServer =
				serverStartup.attachServer(args1, "HTTP_Connector_1");
			String[] args2 = { "../etc/httpsconfig.xml" };
			Server httpsServer =
				serverStartup.attachServer(args2, "HTTPS_Connector_1");

			String uplServiceName = "UPLService";
			String uplServiceDir = "unicore/services";
			httpsServer.getDeployment().deploy(
				UPLServiceSoapBindingImpl.class.getName(),
				uplServiceName,
				uplServiceDir,
				IUPL.class,
				"per-access");

			String caServiceName = "CAService";
			String caServiceDir = "unicore/services";
			httpServer.getDeployment().deploy(
				CAService.class.getName(),
				caServiceName,
				caServiceDir,
				ICAService.class, "per-access");

		} catch (Exception e) {
			logger.log(Level.SEVERE, "Could not start server.", e);
		}
	}

}
