package com.pallas.ogsa.util;

import javax.xml.namespace.QName;

import org.apache.axis.encoding.DeserializerFactory;
import org.apache.axis.encoding.SerializerFactory;

/**
 *@author     Ralf Ratering
 *@created    17. Mrz 2003
 *@version    $Id: OGSIMapping.java,v 1.2 2003/06/30 06:51:23 rrate Exp $
 */
public class OGSIMapping {
	private DeserializerFactory deserializerFactory;
	private Class mappedClass;
	private QName qname;
	private SerializerFactory serializerFactory;

	/**
	 *  Constructor for the OGSIMapping object
	 *
	 *@param  qname                Description of the Parameter
	 *@param  serializerFactory    Description of the Parameter
	 *@param  deserializerFactory  Description of the Parameter
	 *@param  mappedClass          Description of the Parameter
	 */
	public OGSIMapping(
		Class mappedClass,
		QName qname,
		SerializerFactory serializerFactory,
		DeserializerFactory deserializerFactory) {
		this.mappedClass = mappedClass;
		this.qname = qname;
		this.serializerFactory = serializerFactory;
		this.deserializerFactory = deserializerFactory;
	}

	/**
	 *  Gets the deserializerFactory attribute of the OGSIMapping object
	 *
	 *@return    The deserializerFactory value
	 */
	public DeserializerFactory getDeserializerFactory() {
		return deserializerFactory;
	}

	/**
	 *  Gets the class attribute of the OGSIMapping object
	 *
	 *@return    The class value
	 */
	public Class getMappedClass() {
		return mappedClass;
	}

	/**
	 *  Gets the qName attribute of the OGSIMapping object
	 *
	 *@return    The qName value
	 */
	public QName getQName() {
		return qname;
	}

	/**
	 *  Gets the serializerFactory attribute of the OGSIMapping object
	 *
	 *@return    The serializerFactory value
	 */
	public SerializerFactory getSerializerFactory() {
		return serializerFactory;
	}
}
