package com.pallas.unicore.client.controls;

import java.awt.BorderLayout;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Logger;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *@author     Ralf Ratering
 *@created    14. September 2001
 *@version    $Id: IndeterminateProgressMonitor.java,v 1.2 2003/06/30 06:52:10 rrate Exp $
 */
public class IndeterminateProgressMonitor extends JDialog {
	private static Logger logger =
		Logger.getLogger("com.pallas.unicore.client.controls");

	/**
	 *  Description of the Method
	 *
	 *@param  args  Description of Parameter
	 */
	public static void main(String args[]) {
		final IndeterminateProgressMonitor progressMonitor =
			new IndeterminateProgressMonitor(new Frame());
		progressMonitor.setLabel("Unknown process in unknown progress.....");

		JButton startButton = new JButton("Start");
		startButton.addActionListener(new ActionListener() {
			/**
			 *  Description of the Method
			 *
			 *@param  evt  Description of Parameter
			 */
			public void actionPerformed(ActionEvent evt) {
				progressMonitor.show();
			}
		});

		JButton stopButton = new JButton("Stop");
		stopButton.addActionListener(new ActionListener() {
			/**
			 *  Description of the Method
			 *
			 *@param  evt  Description of Parameter
			 */
			public void actionPerformed(ActionEvent evt) {
				progressMonitor.dispose();
			}
		});

		final JSlider fpsSlider = new JSlider(1, 30, 3);
		final JLabel fpsLabel = new JLabel("FPS: ");
		final JFrame frame = new JFrame("Test ProgressMonitor");

		fpsSlider.addChangeListener(new ChangeListener() {
			/**
			 *  Description of the Method
			 *
			 *@param  e  Description of Parameter
			 */
			public void stateChanged(ChangeEvent e) {
				fpsLabel.setText("FPS: " + fpsSlider.getValue());
				frame.pack();

				if (fpsSlider.getValueIsAdjusting()) {
					return;
				}
			}
		});

		JPanel buttonPanel = new JPanel();
		buttonPanel.add(startButton);
		buttonPanel.add(stopButton);
		JPanel sliderPanel = new JPanel();
		sliderPanel.add(fpsLabel);
		sliderPanel.add(fpsSlider);

		frame.getContentPane().add(buttonPanel, BorderLayout.CENTER);
		frame.getContentPane().add(sliderPanel, BorderLayout.SOUTH);
		frame.pack();
		frame.show();
	}

	private JProgressBar progressBar = new JProgressBar();

	/**
	 *  Constructor for the UnknownProgressMonitor object
	 *
	 *@param  parent  Description of Parameter
	 */
	public IndeterminateProgressMonitor(Dialog parent) {
		super(parent, false);

		initComponents();
	}

	/**
	 *  Constructor for the UnknownProgressMonitor object
	 *
	 *@param  parent  Description of Parameter
	 */
	public IndeterminateProgressMonitor(Frame parent) {
		super(parent, false);

		initComponents();
	}

	/**
	 *  Description of the Method
	 */
	private void initComponents() {
		progressBar.setIndeterminate(true);
		progressBar.setStringPainted(true);

		getContentPane().add(progressBar, BorderLayout.CENTER);

		pack();
	}

	/**
	 *  Description of the Method
	 */
	public void pack() {
		super.pack();
		setLocationRelativeTo(getParent());
	}

	/**
	 *  Sets the Label attribute of the UnknownProgressMonitor object
	 *
	 *@param  message  The new Label value
	 */
	public void setLabel(String message) {
		progressBar.setString(message);
		pack();
	}

}
