package com.pallas.unicore.client.controls;

import org.unicore.resources.AlternativeUspace;
import org.unicore.resources.Home;
import org.unicore.resources.Resource;
import org.unicore.resources.Root;
import org.unicore.resources.Spool;
import org.unicore.resources.StorageServer;
import org.unicore.resources.Temp;
import org.unicore.resources.USpace;

/**
 *@author     Ralf Ratering
 *@created    21. Februar 2002
 *@version    $Id: ResourceEntry.java,v 1.2 2003/06/30 06:52:08 rrate Exp $
 */

public class ResourceEntry {

	/**
	 *  Description of the Method
	 */
	public static String getName(Resource resource) {
		if (resource instanceof Home) {
			return "Home";
		} else if (resource instanceof USpace) {
			return "Job Directory";
		} else if (resource instanceof StorageServer) {
			StorageServer server = (StorageServer) resource;
			return server.getName();
		} else if (resource instanceof Spool) {
			return "Spool";
		} else if (resource instanceof AlternativeUspace) {
			return "Alternative Job Directory";
		} else if (resource instanceof Root) {
			return "Root";
		} else if (resource instanceof Temp) {
			return "Temporary";
		} else {
			return resource.toString();
		}
	}
	private String entry = "Unknown";

	private Resource resource;

	/**
	 *  Constructor for the DescriptionEntry object
	 *
	 *@param  resource  Description of Parameter
	 */
	public ResourceEntry(Resource resource) {
		this.resource = resource;

		entry = getName(resource);
	}

	public boolean equals(Object obj) {
		if (obj instanceof ResourceEntry) {
			return getResource().equals(((ResourceEntry) obj).getResource());
		} else {
			return false;
		}
	}

	/**
	 *  Gets the Resource attribute of the DescriptionEntry object
	 *
	 *@return    The Resource value
	 */
	public Resource getResource() {
		return resource;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public String toString() {
		return entry;
	}
}
