package com.pallas.unicore.client.controls;

import java.awt.Component;

import javax.swing.BoxLayout;
import javax.swing.JToolBar;

/**
 *@author     Ralf Ratering
 *@created    26. Februar 2002
 *@version    $Id: SimpleToolBar.java,v 1.2 2003/06/30 06:52:08 rrate Exp $
 */

public class SimpleToolBar extends JToolBar {

	/**
	 *  Constructor for the SimpleToolBar object
	 */
	public SimpleToolBar() {
		super();
		setBorderPainted(false);
		setFloatable(false);
		setVertical(false);
	}

	/**
	 *  Constructor for the SimpleToolBar object
	 *
	 *@param  one  Description of the Parameter
	 */
	public SimpleToolBar(Component one) {
		this();
		one.setName("");
		add(one);
	}

	/**
	 *  Constructor for the SimpleToolBar object
	 *
	 *@param  one  Description of the Parameter
	 *@param  two  Description of the Parameter
	 */
	public SimpleToolBar(Component one, Component two) {
		this(one);
		add(two);
	}

	/**
	 *  Constructor for the SimpleToolBar object
	 *
	 *@param  one    Description of the Parameter
	 *@param  two    Description of the Parameter
	 *@param  three  Description of the Parameter
	 */
	public SimpleToolBar(Component one, Component two, Component three) {
		this(one, two);
		add(three);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  component  Description of the Parameter
	 *@return            Description of the Return Value
	 */
	public Component add(Component component) {
		return super.add(component);
	}

	/**
	 *  Sets the vertical attribute of the SimpleToolBar object
	 *
	 *@param  vertical  The new vertical value
	 */
	public void setVertical(boolean vertical) {
		if (vertical) {
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		} else {
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		}
	}
}
