package com.pallas.unicore.client.dialogs;
import java.awt.BorderLayout;
import java.awt.Color;
import java.util.ResourceBundle;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

import com.pallas.unicore.client.graphs.DependencyEditor;
import com.pallas.unicore.container.GroupContainer;

/**
 *  Simple dialog to display a dependency graph
 *
 *@author     Ralf Ratering
 *@created    24. August 2001
 *@version    $Id: DependencyViewer.java,v 1.2 2003/06/30 06:53:29 rrate Exp $
 */
public class DependencyViewer extends GenericDialog {

	static ResourceBundle res =
		ResourceBundle.getBundle(
			"com.pallas.unicore.client.dialogs.ResourceStrings");
	private DependencyEditor dependencyDisplay;

	/**
	 *  Constructor
	 *
	 *@param  parentFrame  reference to parent JFrame
	 *@param  container    Description of the Parameter
	 */
	public DependencyViewer(JFrame parentFrame, GroupContainer container) {
		super(parentFrame, res.getString("UNICORE_JMC"), true, OK);

		dependencyDisplay = new DependencyEditor(container);
		dependencyDisplay.setBackground(new Color(0, 100, 200));
		dependencyDisplay.setColor(Color.white);
		dependencyDisplay.setSelectionColor(Color.green);
		dependencyDisplay.updateValues();

		JScrollPane scrollPane = new JScrollPane(dependencyDisplay);

		getContentPane().add(scrollPane, BorderLayout.CENTER);

		setResizable(true);
		setSize(400, 400);
	}

	/**
	 *  React to OK button
	 *
	 *@return    true always
	 */
	protected boolean applyValues() {
		return true;
	}

	/**
	 *  Overwrite method from super class
	 *
	 *@return    true always
	 */
	protected boolean cancelValues() {
		return true;
	}
}
