package com.pallas.unicore.client.dialogs;

import java.awt.BorderLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.ResourceBundle;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

import com.pallas.unicore.client.panels.ResourceEditPanel;
import com.pallas.unicore.extensions.NamedResourceSet;

/**
 *  Dialog that displays site resources for a vsite
 *
 *@author     Ralf Ratering
 *@created    21. August 2001
 *@version    $Id: ResourceEditDialog.java,v 1.3 2003/06/30 06:53:26 rrate Exp $
 */
public class ResourceEditDialog extends GenericDialog {
	static ResourceBundle res =
		ResourceBundle.getBundle(
			"com.pallas.unicore.client.dialogs.ResourceStrings");
	private ResourceEditPanel editPanel;

	/**
	 *  Constructor builds gui
	 *
	 *@param  owner          parent frame
	 *@param  request        Description of Parameter
	 *@param  siteResources  Description of Parameter
	 */
	public ResourceEditDialog(
		JFrame owner,
		NamedResourceSet request,
		NamedResourceSet siteResources) {
		super(owner, "", true, OK_CANCEL);

		editPanel = new ResourceEditPanel(request, siteResources);

		JScrollPane scrollPane = new JScrollPane(editPanel);
		scrollPane.scrollRectToVisible(new Rectangle(new Point(0, 0)));

		// add to main panel
		getContentPane().add(scrollPane, BorderLayout.CENTER);

		setStatusMessage("Editing resource set " + request.getName());
		String title =
			"UNICOREpro: Resource Editor <" + request.getName() + ">";
		if (siteResources.getVsite() != null) {
			title += " at site " + siteResources.getVsite();
		}
		setTitle(title);

		pack();

	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	protected boolean applyValues() {
		editPanel.applyValues();
		return true;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	protected boolean cancelValues() {
		return true;
	}

	/**
	 *  Overwrite show() method to position dialog
	 */
	public void show() {
		setSize(800, 600);
		setLocationRelativeTo(getParent());
		super.show();
	}

}
