package com.pallas.unicore.client.dialogs;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import com.pallas.unicore.client.panels.ResourceInfoPanel;
import com.pallas.unicore.client.panels.ResourceRequestInfoPanel;
import com.pallas.unicore.extensions.NamedResourceSet;

/**
 *  Dialog that displays site resources for a vsite
 *
 *@author     Ralf Ratering
 *@created    21. August 2001
 *@version    $Id: ResourceInfoDialog.java,v 1.2 2003/06/30 06:53:26 rrate Exp $
 */
public class ResourceInfoDialog extends JDialog {

	/**
	 *  Listen to close button
	 *
	 *@author     rrate
	 *@created    21. August 2001
	 */
	private class ButtonListener implements ActionListener {
		/**
		 *  Description of the Method
		 *
		 *@param  event  Description of Parameter
		 */
		public void actionPerformed(ActionEvent event) {
			dispose();
		}
	}
	static ResourceBundle res =
		ResourceBundle.getBundle(
			"com.pallas.unicore.client.dialogs.ResourceStrings");
	private JButton closeButton;

	/**
	 *  Constructor builds gui
	 *
	 *@param  owner      parent frame
	 *@param  resources  Description of Parameter
	 */
	public ResourceInfoDialog(
		Frame owner,
		NamedResourceSet resources,
		boolean showRequests) {
		super(owner, res.getString("RESOURCEINFO_TITLE"), false);

		JPanel infoPanel;
		if (resources == null || resources.isEmpty()) {
			infoPanel = new JPanel(new BorderLayout());
			infoPanel.add(
				new JLabel("Resource set is empty."),
				BorderLayout.CENTER);
		} else {
			if (showRequests) {
				infoPanel = new ResourceRequestInfoPanel(resources);
			} else {
				infoPanel = new ResourceInfoPanel(resources);
			}
		}

		closeButton = new JButton(res.getString("CLOSE"));
		closeButton.setToolTipText(res.getString("CLOSE_TIP"));
		closeButton.addActionListener(new ButtonListener());

		JScrollPane scrollPane = new JScrollPane(infoPanel);

		// add to main panel
		getContentPane().add(scrollPane, BorderLayout.CENTER);
		getContentPane().add(closeButton, BorderLayout.SOUTH);

		pack();
	}

	/**
	 *  Overwrite show() method to position dialog
	 */
	public void show() {
		setSize(600, 450);
		setLocationRelativeTo(getParent());
		super.show();
	}

}
