package com.pallas.unicore.client.dialogs;

import java.util.*;

/**
 *  Strings for dialogs
 *
 *@author     Ralf Ratering
 *@created    24. September 2001
 *@version    $Id: ResourceStrings.java,v 1.9 2003/07/09 08:55:07 rrate Exp $
 */
public class ResourceStrings extends java.util.ListResourceBundle {
    final static Object[][] contents = new String[][]{
            {"UNKNOWN_TITLE", "UNICOREpro: Unknown plugin signer"},
            {"LOADING_PLUGIN", "You are trying to load the plugin: <"},
            {"SIGNED_BY", "This plugin was signed by "},
            {"ADDING_SIGNER", "If you add the signer\'s certificate as a trusted certificate to your " +
            "UNICOREpro keystore,\nthis dialog will not appear when you try to load " +
            "the plugin the next time.\nYou can also accept the plugin only for " +
            "this session."},
            {"SHOW_DETAILS", "Show details"},
            {"SHOW_DETAILS_EXPLICIT", "Show details of plugin signer\'s certificate"},
            {"ACCEPT_FOR_SESSION", "Accept for this session"},
            {"ACCEPT_TIP", "Signer certificate will be accepted only\nfor this session and the " +
            "dialog will appear again next time"},
            {"ADD", "Add to keystore"},
            {"ADD_TIP", "The plugin signer\'s certificate will be added to your UNICOREpro keystore"},
            {"NOT_ACCEPT", "Do not accept"},
            {"NOT_ACCEPT_TIP", "Click here if you do not trust the plugin signer and do not want to load the plugin"},
            {"VERIFICATION_FAILED", "New password verification not correct"},
            {"OLD_PASSWORD", "Enter Old Password: "},
            {"NEW_PASSWORD", "Enter New Password: "},
            {"VERIFY_PASSWORD", "Verify New Password: "},
            {"UNICORE_JMC", "UNICOREpro: Job Monitor - Dependencies"},
            {"USERNAME", "Username: "},
            {"PASSWORD", "Password: "},
            {"WEAK_PASSWORD", "You have chosen a weak password.\n" +
            "Passwords should be at least 8 characters long and\n" +
            "should contain upper and lower case characters, numbers and punctuation."},
            {"ENFORCEPASSWORD_LABEL", "Enforce strong passwords: "},
            {"EXPORT_TITLE", "UNICOREpro: Download to local file system"},
            {"OVERWRITE", "Exported file(s): \n"},
            {"OVERWRITE_TITLE", "Exported File(s): Confirm"},
            {"COPYING_FILES", "Copying files to local file system"},
            {"CHOOSE_FILES", "Select files to be exported"},
            {"SELECT_FILES", "Select spooled files"},
            {"ENTER_PASSWORD", "Enter Password: "},
            {"RESOURCE_EDITOR_TITLE", "UNICOREpro: Resource Editor"},
            {"EDIT_RESOURCES", "Edit resources for task "},
            {"SET_RESOURCES", "Trying to set resources!"},
            {"NO_VSITE", "You did not select a virtual site, cannot access site defaults!"},
            {"NO_RESOURCES", "Could not load resources from virtual site: "},
            {"APPLY_VALUES", "Apply changes to current job and close window"},
            {"APPLY_VALUES_EXPLICIT", "Use values for current job"},
            {"RESET_VALUES", "Reset values"},
            {"CLOSE_WINDOW", "Close window and dismiss changes"},
            {"BUILD_REQUEST", "Build resource request..."},
            {"TEST_RESOURCES", "Test resources for availability..."},
            {"NO_VSITE2", "You did not select a virtual site, cannot check resources!"},
            {"CHECKING_FINISHED", "Checking resources finished!"},
            {"SMALLER_THAN", " is smaller than available resource at site\n"},
            {"SET_TO_MIN", ".\n Set it to minimum value: "},
            {"REQUEST_FOR", "Request for "},
            {"LARGER_THAN", "\nis larger than available resource at site\n"},
            {"SET_TO_MAX", ".\n Set it to maximum value: "},
            {"REQUEST_TITLE", "UNICOREpro: Request for task "},
            {"RESOURCES_NOT_AVAILABLE", "The following resources are not available at site "},
            {"DISABLE_RESOURCES", "These resources will be disabled now..."},
            {"USER_DEFAULTS", "Set to user defaults"},
            {"USER_DEFAULTS_TIP", "Set current values to user defaults"},
            {"SITE_DEFAULTS", "Set to site defaults"},
            {"SITE_DEFAULTS_TIP", "Set current values to site defaults"},
            {"CHECK_VALUES", "Check values"},
            {"COMPARE_VALUES", "Compare current values to site resources"},
            {"PRIORITIES_FOUND", "Found more than one Priority: "},
            {"RESOURCEINFO_TITLE", "UNICOREpro: Resource Info"},
            {"CLOSE", "Close"},
            {"CLOSE_TIP", "Close window"},
            {"IMPORTING_CERT", "Importing user certificate..."},
            {"IMPORT_FAILED", "Certificate import failed: "},
            {"SET_NEW_USER", "Set new user alias "},
            {"SET_DEFAULT_TITLE", "UNICOREpro: Set Default Alias"},
            {"ALIAS", "Alias: "},
            {"CERTIFICATES_TITLE", "UNICOREpro: Certificates"},
            {"CHECKING_CRL", "SPE: Checking Certificate Revocation List"},
            {"COULD_NOT_READ_CRL", "Could not read Certificate Revocation List\nPossible reasons:\n- wrong URL\n- wrong configuration " +
            "of proxy server"},
            {"PROBLEMS_READING", "Problems reading Certificate Revocation List."},
            {"WAIT_WHILE_UPDATING", "Please wait while updating keystore."},
            {"TEMPORARY_KEYSTORE", "Creating temporary keystore with default certificate..."},
            {"SETTING_DEFAULT", "Setting selected identity as default succeeded."},
            {"CHANGE_PASSWORD_TITLE", "UNICOREpro: Change keystore password"},
            {"PASSWORD_CHANGED", "Keystore password successfully changed!"},
            {"WRONG_PASSWORD", "Wrong keystore password!"},
            {"COULD_NOT_CHANGE", "Could not change keystore password!"},
            {"FETCHING_CERT", "SPE: Fetching user certificate..."},
            {"OPEN_CERT", "UNICOREpro: Open user certificate"},
            {"CERT_NAME", "User\'s cert file name: \'"},
            {"UNLOCK_TITLE", "UNICOREpro: Unlock User Certificate"},
            {"WAIT_WHILE_PROCESSING", "Please wait while processing certificates..."},
            {"OPEN_TITLE", "UNICOREpro: Open certificate"},
            {"CANNOT_LOAD", "Cannot load certificate: "},
            {"KEYSTORE_INVALID", "Keystore invalid or not initialized."},
            {"EXPORTING_KEY", "Exporting public key"},
            {"EXPORTING_KEY_TITLE", "UNICOREpro: Export Public Key"},
            {"ADD_CERT_TIP", "Add a certificate in PEM format."},
            {"DETAILS", "Details"},
            {"DETAILS_TIP", "Show the selected certificate"},
            {"REMOVE", "Remove"},
            {"REMOVE_CERT", "Remove a certificate from the keystore"},
            {"TRUSTED_CERT", "Trusted certificates"},
            {"ADD_PKCS12_TIP", "Add a user certificate in PKCS12 format."},
            {"REMOVE_TIP", "Remove a user certificate from the keystore"},
            {"SHOW_TIP", "Show details about the selected user certificate"},
            {"SET_DEFAULT", "Set as Default"},
            {"SET_DEFAULT_TIP", "Set the selected identity as new default identity."},
            {"CHECK_CRL", "Check CRL"},
            {"CHECK_CRL_TIP", "Check the selected certificate against the Certificate Revocation " +
            "List "},
            {"USER_CERTS", "User certificates"},
            {"CHANGE_PASSWORD", "Change Password"},
            {"CHANGE_ALIAS", "Change Alias"},
            {"EXPORTS", "Exports"},
            {"KEYSTORE", "Keystore"},
            {"CERT_REVOKED", "The selected certificate has been revoked.\nPlease contact your administrator " +
            "for more details."},
            {"CERT_NOT_REVOKED", "The selected certificate has not been revoked."},
            {"AS_DEFAULT", " as default?"},
            {"EXPORT_PUBLIC", "Export Public Key"},
            {"EXPORT_PUBLIC_TIP", "Export the public key of the selected certificate in DER format"},
            {"SAVE", "Save"},
            {"CERTIFICATE", "Certificate"},
            {"SUBJECT", "Subject"},
            {"EMAIL", "EmailAddress="},
            {"INFO", "Info"},
            {"SERIAL", "Serial number: "},
            {"VALID", "Valid from "},
            {"TO", " to "},
            {"SAVE_TITLE", "UNICOREpro: Save certificate to file"},
            {"LOG_TITLE", "UNICOREpro: Log for "},
            {"SAVE_LOG_TITLE", "UNICOREpro: Save log to file"},
            {"SYNTAX_ERROR", "Syntax error in URL!"},
            {"PASSWORD_ALIAS", "Password and alias must be specified!"},
            {"ENTER_PASSWORD_DETAILED", "Enter the password protecting the certificate: "},
            {"ENTER_ALIAS", "Alias for this Certificate: "},
            {"OPTIONAL_PASSOWRD", "Optional password to protect the private key: "},
            {"ALIASES_LOWER_CASE", "Aliases will be automatically converted to lower case"},
            {"SELECT_JOB_DIR", "UNICOREpro: Select Job Directory"},
            {"SELECT_RESOURCE_DIR", "UNICOREpro: Select Resource Directory"},
            {"SELECT_IMPORT_DIR", "UNICOREpro: Select Import Directory"},
            {"SELECT_EXPORT_DIR", "UNICOREpro: Select Export Directory"},
            {"SELECT_PLUGIN_DIR", "UNICOREpro: Select Plugin Directory"},
            {"SELECT_KEYSTORE", "UNICOREpro: Select Keystore File"},
            {"SELECT_LOG_DIR", "UNICOREpro: Select Directory for Stdout/Stderr and Logs"},
            {"SELECT_TMP_DIR", "UNICOREpro: Select Directory for tmp files"},
            {"USERDEFAULT_TITLE", "UNICOREpro: User Defaults"},
            {"COULD_NOT_WRITE", "Could not write user defaults to file"},
            {"SUCESSFULLY_STORED", "Successfully stored user defaults."},
            {"GENERAL", "General"},
            {"PATHS", "Paths"},
            {"DEFAULT_RESOURCES", "Default Resources"},
            {"SYSTEM_SETTINGS", "System Settings"},
            {"USER_INTERFACE", "User Interface"},
            {"LOGGING_SETTINGS", "Logging Settings"},
            {"ON_OFF", "On/Off: "},
            {"USITE_URL", "URL(s) for UNICORE Site Server: "},
            {"CRL", "Certificate Revocation List: "},
            {"PROXY_ADDRESS", "Proxy Server Address: "},
            {"REDIRECT", "Send client log to file: "},
            {"JOB_DIR", "Select a directory for storing jobs."},
            {"RESOURCE_DIR", "Select a directory for storing resource sets."},
            {"IMPORT_DIR", "Select a directory for file imports."},
            {"EXPORT_DIR", "Select a directory for file exports."},
            {"PLUGIN_DIR", "Select plugin directory."},
            {"KEYSTORE_FILE", "Select keystore file."},
            {"LOG_DIR", "Select directory for stdout/stderr and job logs"},
            {"TMP_DIR", "Select directory for tmp files"},
            {"JOB_DIR_TOOLTIP", "Browse local file system for job directory"},
            {"RESOURCE_DIR_TOOLTIP", "Browse local file system for resource set directory"},
            {"IMPORT_DIR_TOOLTIP", "Browse local file system for file import directory"},
            {"EXPORT_DIR_TOOLTIP", "Browse local file system for file export directory"},
            {"PLUGIN_DIR_TOOLTIP", "Browse local file system for plugin directory"},
            {"KEYSTORE_TOOLTIP", "Browse local file system for keystore"},
            {"LOG_DIR_TOOLTIP", "Browse local file system for log directory"},
            {"TMP_DIR_TOOLTIP", "Browse local file system for tmp directory"},
            {"KEYSTORE_LABEL", "Keystore location: "},
            {"PLUGIN_LABEL", "Plugin directory: "},
            {"JOB_LABEL", "Job directory: "},
            {"RESOURCE_LABEL", "Resource directory: "},
            {"IMPORT_LABEL", "Import directory: "},
            {"EXPORT_LABEL", "Export directory: "},
            {"LOG_LABEL", "Log directory: "},
            {"TMP_LABEL", "Scratch directory: "},
            {"PLAF_LABEL", "GUI Look and Feel: "},
            {"PLAF_TIP", "Themes are only available with Look and Feel set to "},
            {"THEME_LABEL", "GUI Theme: "},
            {"TIMEOUT_LABEL", "Timeout for socket connections (s): "},
            {"LOADXML_LABEL", "Load/Store jobs in XML format"},
            {"AUTOFETCH_LABEL", "Automatically download exported files"},
            {"DETAILEDJOBSTATUS_LABEL", "Show detailed job status"},
            {"OK_TIP", "Store the current settings as defaults to disk and close dialog"},
            {"CLOSE_DEFAULTS_TIP", "Close dialog and dismiss changes"},
            {"SELECT", "Select"},
            {"YES_STRING", "Yes"},
            {"NO_STRING", "No"},
            {"ALL_STRING", "All"},
            {"FILE_EXISTS", "File Exists"},
            {"CSR_DIALOG_TIP_TIP", "Generate a CSR"},
            {"DOWNLOAD_1", "Download file: "},
            {"DOWNLOAD_2", " exists.\nDownload anyway?"},
            {"LOGGING_LEVEL", "Logging Level:"},
            {"NO_PLUGIN_CERT", "For this plugin you have to import one of the following issuer certificates"},
            {"OPEN_KEYSTORE_EDITOR","using Settings->Keystore Editor"},
            {"LOGGING_FORMAT", "Logging Format:"},
            {"SETIDENTITY_TITLE", "UNICOREpro: Set Identity"},
            {"PREEMPTIVE_SELECTORDIALOG_MODE", "Preemptive file chooser mode"},
            {"NO_DEFAULT_CERT", "Cannot display all identities.\nFirst you have to select a new default" +
            "identity using Settings->Keystore Editor"}};


    /**
     *  Gets the Contents attribute of the ResourceStrings object
     *
     *@return    The Contents value
     */
    public Object[][] getContents() {
        return contents;
    }
}

