package com.pallas.unicore.client.explorer;

import java.awt.*;
import java.io.*;
import javax.swing.*;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    16. Mai 2002
 *@version    $Id: Explorer.java,v 1.1.1.1 2003/04/08 09:03:17 rrate Exp $
 */
public class Explorer extends JFrame {
    private ExplorerPanel panel;
    private File currentDir;


    /**
     *  Constructor for the ExplorerTree object
     */
    public Explorer() {
        this(null);
    }


    /**
     *  Constructor for the Explorer object
     *
     *@param  currentDir  Description of the Parameter
     */
    public Explorer(File currentDir) {
        this.currentDir = currentDir;
        buildComponents();
    }


    /**
     *  Sets the dividerLocation attribute of the Explorer object
     *
     *@param  value  The new dividerLocation value
     */
    public void setDividerLocation(double value) {
        panel.setDividerLocation(value);
    }


    /**
     *  The main program for the Explorer class
     *
     *@param  args  The command line arguments
     */
    public static void main(String[] args) {
        Explorer explorer = new Explorer();
        explorer.setTitle("JExplorer");
        explorer.pack();
        int xsize = 800;
        int ysize = 600;
        Dimension screen = explorer.getToolkit().getScreenSize();
        double xcenter = screen.getWidth() / 2;
        double ycenter = screen.getHeight() / 2;
        explorer.setSize(xsize, ysize);
        explorer.setLocation((int)(xcenter - xsize / 2), (int)(ycenter - ysize / 2));
        explorer.setDividerLocation(0.382);
        explorer.setVisible(true);
    }


    /**
     *  Description of the Method
     */
    private void buildComponents() {
        panel = new ExplorerPanel(currentDir);
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(panel, BorderLayout.CENTER);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}
