package com.pallas.unicore.client.explorer;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    16. Mai 2002
 *@version    $Id: FileCellRenderer.java,v 1.2 2003/06/30 06:53:50 rrate Exp $
 */
public class FileCellRenderer extends DefaultTreeCellRenderer {

	/**
	 *  Sets the value of the current tree cell to value.
	 *
	 *@param  tree      is the JTree the receiver is being configured for
	 *@param  object    is the current tree node
	 *@param  selected  if true, the cell will be drawn as if selected.
	 *@param  expanded  if true, the node is currently expanded
	 *@param  leaf      if true, the node represets a leaf
	 *@param  row
	 *@param  hasFocus  if true, the node currently has focus
	 *@return           the Component that the renderer uses to draw the value
	 */
	public Component getTreeCellRendererComponent(
		JTree tree,
		Object object,
		boolean selected,
		boolean expanded,
		boolean leaf,
		int row,
		boolean hasFocus) {

		Component c =
			super.getTreeCellRendererComponent(
				tree,
				object,
				selected,
				expanded,
				leaf,
				row,
				hasFocus);

		JLabel label = (JLabel) c;

		if (object instanceof DirNode) {
			DirNode fileNode = (DirNode) object;
			label.setIcon(fileNode.getIcon());
		}
		return this;
	}
}
