package com.pallas.unicore.client.explorer;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.File;

/**
 *  Description of the Class
 *
 *@author     rrate
 *@created    17. Mai 2002
 */
public class FileEntry implements Comparable, Transferable {
	private static DataFlavor flavor;
	private File file;
	private DataFlavor[] supportedFlavors = { flavor };
	private String systemName;

	/**
	 *  Constructor for the FileEntry object
	 *
	 *@param  file        Description of the Parameter
	 *@param  systemName  Description of the Parameter
	 */
	public FileEntry(File file, String systemName) {
		this.file = file;
		this.systemName = systemName;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  object  Description of the Parameter
	 *@return         Description of the Return Value
	 */
	public int compareTo(Object object) {
		return file.compareTo(((FileEntry) object).getFile());
	}

	/**
	 *  Gets the file attribute of the FileEntry object
	 *
	 *@return    The file value
	 */
	public File getFile() {
		return file;
	}

	/**
	 *  Transferable interface:
	 *
	 *@param  flavor                          Description of Parameter
	 *@return                                 The TransferData value
	 *@exception  UnsupportedFlavorException  Description of Exception
	 */
	public synchronized Object getTransferData(DataFlavor flavor)
		throws UnsupportedFlavorException {

		if (flavor.equals(flavor)) {
			return this;
		} else {
			throw new UnsupportedFlavorException(flavor);
		}
	}

	/**
	 *  Transferable interface:
	 *
	 *@return    The TransferDataFlavors value
	 */
	public synchronized DataFlavor[] getTransferDataFlavors() {
		return (supportedFlavors);
	}

	/**
	 *  Transferable interface:
	 *
	 *@param  flavor  Description of Parameter
	 *@return         The DataFlavorSupported value
	 */
	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return (flavor.equals(flavor));
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		return systemName;
	}
}
