package com.pallas.unicore.client.explorer;

import java.io.File;
import java.util.Date;
import java.util.Vector;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    22. Mai 2002
 *@version    $Id: RowData.java,v 1.2 2003/06/30 06:53:49 rrate Exp $
 */
public class RowData extends Vector implements Comparable {
	private static int compareIndex = 0;

	/**
	 *  Sets the sortingIndex attribute of the RowData object
	 *
	 *@param  _compareIndex  The new compareIndex value
	 */
	public static void setCompareIndex(int _compareIndex) {
		compareIndex = _compareIndex;
	}

	/**
	 *  Constructor for the RowData object
	 *
	 *@param  file         Description of the Parameter
	 *@param  description  Description of the Parameter
	 *@param  systemName   Description of the Parameter
	 */
	public RowData(File file, String systemName, String description) {
		add(new FileEntry(file, systemName));
		add(new SizeEntry(file.length()));
		// description may be null on UNIX systems
		if (description == null) {
			description = "";
		}
		add(description);
		add(new Date(file.lastModified()));
	}

	/**
	 *  Description of the Method
	 *
	 *@param  i  Description of the Parameter
	 *@return    Description of the Return Value
	 */
	public Comparable comparableAt(int i) {
		return (Comparable) elementAt(i);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  object  Description of the Parameter
	 *@return         Description of the Return Value
	 */
	public int compareTo(Object object) {
		int value =
			comparableAt(compareIndex).compareTo(
				((RowData) object).comparableAt(compareIndex));
		// if equal use filenames for second comparison
		if (value == 0 && compareIndex != 0) {
			value =
				comparableAt(0).compareTo(((RowData) object).comparableAt(0));
		}
		return value;
	}

	/**
	 *  Gets the file attribute of the RowData object
	 *
	 *@return    The file value
	 */
	public File getFile() {
		return ((FileEntry) firstElement()).getFile();
	}

}
