package com.pallas.unicore.client.explorer;

import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.*;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    16. Mai 2002
 *@version    $Id: Selector.java,v 1.1.1.1 2003/04/08 09:03:17 rrate Exp $
 */
public class Selector extends JFrame {
    /**
     *  Description of the Field
     */
    protected SelectorPanel panel;

    /**
     *  Description of the Field
     */
    protected File currentDir;


    /**
     *  Constructor for the ExplorerTree object
     */
    public Selector() {
        this(null);
    }


    /**
     *  Constructor for the Explorer object
     *
     *@param  currentDir  Description of the Parameter
     */
    public Selector(File currentDir) {
        this.currentDir = currentDir;
        buildComponents();

        int xsize = 800;
        int ysize = 600;
        Dimension screen = getToolkit().getScreenSize();
        double xcenter = screen.getWidth() / 2;
        double ycenter = screen.getHeight() / 2;
        setSize(xsize, ysize);
        setLocation((int)(xcenter - xsize / 2), (int)(ycenter - ysize / 2));
        setDividerLocation(0.382);

    }


    /**
     *  Sets the dividerLocation attribute of the Explorer object
     *
     *@param  value  The new dividerLocation value
     */
    public void setDividerLocation(double value) {
        panel.setDividerLocation(value);
    }




    /**
     *  The main program for the Explorer class
     *
     *@param  args  The command line arguments
     */
    public static void main(String[] args) {
        Selector selector = new Selector(null);
        selector.setTitle("JSelector");
        selector.pack();

        selector.setVisible(true);
    }


    /**
     *  Description of the Method
     */
    protected void buildComponents() {
        panel = new SelectorPanel(currentDir, true);
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(panel, BorderLayout.CENTER);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}
