package com.pallas.unicore.client.explorer;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Hashtable;
import java.util.Vector;
import java.util.logging.Logger;

import javax.swing.AbstractAction;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileSystemView;

import org.unicore.Vsite;

import com.pallas.unicore.client.UserDefaults;
import com.pallas.unicore.client.remotefilechooser.RemoteFile;
import com.pallas.unicore.client.remotefilechooser.RemoteFileSystemView;
import com.pallas.unicore.extensions.FileStorage;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    16. Mai 2002
 *@version    $Id: SelectorDialog.java,v 1.5 2003/06/30 06:53:49 rrate Exp $
 */
public class SelectorDialog extends JDialog {

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    18. Juni 2002
	 */
	class CancelAction extends AbstractAction {
		/**
		 *  Constructor for the cancelAction object
		 */
		public CancelAction() {
			super("Cancel");
		}

		/**
		 *  Description of the Method
		 *
		 *@param  e  Description of the Parameter
		 */
		public void actionPerformed(ActionEvent e) {
			returnCode = CANCEL_OPTION;
			selectedFile = currentPanel.getSelectedFile();
			setVisible(false);
		}
	}

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    8. August 2002
	 */
	private class FileSelectedListener implements PropertyChangeListener {
		/**
		 *  Description of the Method
		 *
		 *@param  evt  Description of the Parameter
		 */
		public void propertyChange(PropertyChangeEvent evt) {
			logger.finest("Property Changed: " + evt);
			if (evt
				.getPropertyName()
				.equals(SelectorPanel.FILE_SELECTED_PROPERTY)) {
				logger.finest("File Selected Property Changed: " + evt);
				performOK();
			}
		}
	}

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    18. Juni 2002
	 */
	class OkAction extends AbstractAction {
		/**
		 *  Constructor for the okAction object
		 */
		public OkAction() {
			super("Ok");
		}

		/**
		 *  Description of the Method
		 *
		 *@param  e  Description of the Parameter
		 */
		public void actionPerformed(ActionEvent e) {
			performOK();
		}
	}

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    11. Juli 2002
	 */
	class VsiteChangeAction extends AbstractAction {
		/**
		 *  Description of the Method
		 *
		 *@param  e  Description of the Parameter
		 */
		public void actionPerformed(ActionEvent e) {
			selectedFile = null;
			rememberLayout();
			SelectorPanel oldPanel = currentPanel;
			currentPanel = buildPanel(vsiteBox.getSelectedItem());
			updateFileFilters(oldPanel, currentPanel);
			updateCurrentPanel();
		}
	}

	/**
	 *  Description of the Field
	 */
	public static int APPROVE_OPTION = JFileChooser.APPROVE_OPTION,
		CANCEL_OPTION = JFileChooser.CANCEL_OPTION,
		DIRECTORIES_ONLY = JFileChooser.DIRECTORIES_ONLY,
		FILES_ONLY = JFileChooser.FILES_ONLY,
		FILES_AND_DIRECTORIES = JFileChooser.FILES_AND_DIRECTORIES;
	private static int dividerLocation;
	private static boolean initialized = false;
	private static Logger logger =
		Logger.getLogger("com.pallas.unicore.client.explorer");
	private static Point position;
	private static Dimension size;

	/**
	 *  The main program for the Explorer class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		JFrame frame = new JFrame("Selector Dialog Test");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		String startDir = System.getProperty("user.home");
		//String startDir ="C:/src/java/euklid/src/euklid/Euklid.java";
		SelectorDialog selector =
			new SelectorDialog(frame, new File(startDir), new Vector(), true);
		selector.setTitle("SelectorDialog");
		/*
		 *  try {
		 *  selector.setSelectedFile(new File("c:/tmp/NotExisting.txt"));
		 *  }
		 *  catch(FileNotFoundException e) {
		 *  try {
		 *  selector.setSelectedFile(new File("c:/tmp"));
		 *  selector.setFilename("NotExisting2.txt");
		 *  }
		 *  catch(FileNotFoundException e2) {
		 *  logger.log(Level.SEVERE, "" , e2);
		 *  }
		 *  }
		 *  GenericFileFilter filter = new GenericFileFilter(".ajo");
		 *  filter.setDescription("TestFilter");
		 *  selector.addFileFilter(filter);
		 *  selector.pack();
		 */
		int result = selector.showDialog();

		System.err.println(
			"SELECTED: " + selector.getSelectedFile() + ", Code: " + result);

		System.exit(0);
	}
	private JPanel centerPanel;

	private SelectorPanel currentPanel;
	/**
	 *  Description of the Field
	 */
	protected FileSelectedListener fileSelectedListener =
		new FileSelectedListener();
	private int fileSelectionMode;
	private boolean localEnabled = true;
	private Hashtable panelTable;
	private boolean preemptiveMode;
	private int returnCode;
	private File selectedFile;
	private JComboBox vsiteBox;
	private Vector vsites;

	/**
	 *  Constructor for the SelectorDialog object
	 *
	 *@param  owner  Description of the Parameter
	 */
	public SelectorDialog(Frame owner) {
		this(
			owner,
			(File) null,
			(Vsite) null,
			new UserDefaults().getPreemptiveFileSelectorMode());
	}

	/**
	 *  Constructor for the ExplorerTree object
	 *
	 *@param  owner           Description of the Parameter
	 *@param  preemptiveMode  Description of the Parameter
	 */
	protected SelectorDialog(Frame owner, boolean preemptiveMode) {
		this(owner, (File) null, (Vsite) null, preemptiveMode);

	}

	/**
	 *  Constructor for the SelectorDialog object
	 *
	 *@param  owner       Description of the Parameter
	 *@param  currentDir  Description of the Parameter
	 */
	public SelectorDialog(Frame owner, File currentDir) {
		this(
			owner,
			currentDir,
			new Vector(),
			new UserDefaults().getPreemptiveFileSelectorMode());
	}

	/**
	 *  Constructor for the SelectorDialog object
	 *
	 *@param  owner           Description of the Parameter
	 *@param  currentDir      Description of the Parameter
	 *@param  preemptiveMode  Description of the Parameter
	 */
	protected SelectorDialog(
		Frame owner,
		File currentDir,
		boolean preemptiveMode) {
		this(owner, currentDir, new Vector(), preemptiveMode);
	}

	/**
	 *  Constructor for the SelectorDialog object
	 *
	 *@param  owner         Description of the Parameter
	 *@param  selectedFile  Description of the Parameter
	 *@param  vsites        Description of the Parameter
	 */
	public SelectorDialog(Frame owner, File selectedFile, Vector vsites) {
		this(
			owner,
			selectedFile,
			vsites,
			new UserDefaults().getPreemptiveFileSelectorMode());
	}

	/**
	 *  Constructor for the Explorer object
	 *
	 *@param  owner           Description of the Parameter
	 *@param  vsites          Description of the Parameter
	 *@param  selectedFile    Description of the Parameter
	 *@param  preemptiveMode  Description of the Parameter
	 */
	protected SelectorDialog(
		Frame owner,
		File selectedFile,
		Vector vsites,
		boolean preemptiveMode) {
		super(owner, true);
		this.selectedFile = selectedFile;
		this.vsites = vsites;
		this.preemptiveMode = preemptiveMode;

		init();
	}

	/**
	 *  Constructor for the SelectorDialog object
	 *
	 *@param  owner         Description of the Parameter
	 *@param  selectedFile  Description of the Parameter
	 *@param  vsite         Description of the Parameter
	 */
	public SelectorDialog(Frame owner, File selectedFile, Vsite vsite) {
		this(
			owner,
			selectedFile,
			vsite,
			new UserDefaults().getPreemptiveFileSelectorMode());
	}

	/**
	 *  Constructor for the SelectorDialog object
	 *
	 *@param  owner           Description of the Parameter
	 *@param  vsite           Description of the Parameter
	 *@param  selectedFile    Description of the Parameter
	 *@param  preemptiveMode  Description of the Parameter
	 */
	protected SelectorDialog(
		Frame owner,
		File selectedFile,
		Vsite vsite,
		boolean preemptiveMode) {
		super(owner, true);
		this.selectedFile = selectedFile;
		this.preemptiveMode = preemptiveMode;
		vsites = new Vector();
		if (vsite != null) {
			vsites.add(vsite);
		}
		init();
	}

	/**
	 *  Sets the fileFilter attribute of the SelectorDialog object
	 *
	 *@param  filter  The new fileFilter value
	 */
	public void addFileFilter(FileFilter filter) {
		currentPanel.addFileFilter(filter);
	}

	/**
	 *  Description of the Method
	 */
	protected void buildComponents() {
		panelTable = new Hashtable();
		Object startLocation = null;
		// analyze, if we want to start remote
		if (selectedFile instanceof RemoteFile) {
			RemoteFile file = (RemoteFile) selectedFile;
			currentPanel = buildPanel(file.getVsite());
			startLocation = file.getVsite();
		} else {
			currentPanel = buildPanel(FileStorage.NSPACE_STRING);
			startLocation = FileStorage.NSPACE_STRING;
		}

		JButton okButton = new JButton(new OkAction());
		okButton.setDefaultCapable(true);
		getRootPane().setDefaultButton(okButton);

		JPanel buttonPanel = new JPanel(new GridLayout(1, 2, 10, 10));
		buttonPanel.add(okButton);
		buttonPanel.add(new JButton(new CancelAction()));

		JPanel southPanel = new JPanel();
		southPanel.add(buttonPanel);

		centerPanel = new JPanel(new BorderLayout());
		centerPanel.add(currentPanel);

		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(centerPanel, BorderLayout.CENTER);
		getContentPane().add(southPanel, BorderLayout.SOUTH);

		// only add vsite box if vsites are available
		if (!vsites.isEmpty()) {
			vsiteBox = new JComboBox();
			vsiteBox.addItem(FileStorage.NSPACE_STRING);
			for (int i = 0; i < vsites.size(); i++) {
				vsiteBox.addItem(vsites.elementAt(i));
			}
			vsiteBox.setSelectedItem(startLocation);
			vsiteBox.setAction(new VsiteChangeAction());

			JLabel locationLabel = new JLabel("Location: ");
			locationLabel.setLabelFor(vsiteBox);

			JPanel northPanel = new JPanel();
			northPanel.setLayout(new BoxLayout(northPanel, BoxLayout.X_AXIS));
			northPanel.add(locationLabel);
			northPanel.add(vsiteBox);
			getContentPane().add(northPanel, BorderLayout.NORTH);
		}
	}

	/**
	 *  Description of the Method
	 *
	 *@param  location  Description of the Parameter
	 *@return           Description of the Return Value
	 */
	private SelectorPanel buildPanel(Object location) {
		SelectorPanel panel = (SelectorPanel) panelTable.get(location);
		if (panel != null) {
			return panel;
		}

		if (location.equals(FileStorage.NSPACE_STRING)) {
			panel = new SelectorPanel(selectedFile, preemptiveMode);
		} else if (location instanceof Vsite) {
			Vsite vsite = (Vsite) location;
			FileSystemView view = new RemoteFileSystemView(vsite, this);
			panel = new SelectorPanel(selectedFile, view, preemptiveMode);
		}
		panel.addPropertyChangeListener(
			SelectorPanel.FILE_SELECTED_PROPERTY,
			fileSelectedListener);
		panelTable.put(location, panel);
		return panel;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  file  Description of the Parameter
	 *@return       Description of the Return Value
	 */
	private boolean checkFileType(File file) {
		// if file not exists make sure the parent directory does.
		if (!file.exists()) {
			File parent = file.getParentFile();
			// in directory mode create file itself
			if (fileSelectionMode == DIRECTORIES_ONLY) {
				parent = file;
			}
			if (parent == null || !parent.exists()) {
				if (file instanceof RemoteFile) {
					JOptionPane.showMessageDialog(
						this,
						"Remote directory "
							+ parent
							+ " does not exist.\nPlease select an existing directory.",
						"UNICOREpro: Info",
						JOptionPane.INFORMATION_MESSAGE);
					return false;
				}
				if (JOptionPane
					.showConfirmDialog(
						(JFrame) getParent(),
						"Directory "
							+ parent
							+ " does not exist."
							+ "\nCreate it?",
						"UNICOREpro: Create Directory?",
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE)
					== JOptionPane.YES_OPTION) {
					// create dirs
					parent.mkdirs();
					return true;
				}
				// dir does not exist and we do not want to create it.
				return false;
			}
			// dir already exists
			return true;
		}

		if (fileSelectionMode == DIRECTORIES_ONLY && !file.isDirectory()) {
			JOptionPane.showMessageDialog(
				this,
				file
					+ " is a file."
					+ "\nPlease, select a directory, not a file.",
				"UNICOREpro: Info",
				JOptionPane.INFORMATION_MESSAGE);
			return false;
		}
		if (fileSelectionMode == FILES_ONLY && !file.isFile()) {
			JOptionPane.showMessageDialog(
				this,
				file
					+ " is a directory."
					+ "\nPlease, select a file, not a directory.",
				"UNICOREpro: Info",
				JOptionPane.INFORMATION_MESSAGE);
			return false;
		}
		return true;
	}

	/**
	 *  Gets the localEnabled attribute of the SelectorDialog object
	 *
	 *@return    The localEnabled value
	 */
	public boolean getLocalEnabled() {
		return localEnabled;
	}

	/**
	 *  Gets the selectedFile attribute of the SelectorDialog object
	 *
	 *@return    The selectedFile value
	 */
	public File getSelectedFile() {
		return selectedFile;
	}

	/**
	 *  Gets the selectedFileFilter attribute of the SelectorDialog object
	 *
	 *@return    The selectedFileFilter value
	 */
	public FileFilter getSelectedFileFilter() {
		return currentPanel.getSelectedFileFilter();
	}

	/**
	 *  Gets the selectorTable attribute of the SelectorDialog object
	 *
	 *@return    The selectorTable value
	 */
	public SelectorTable getSelectorTable() {
		return this.currentPanel.getSelectorTable();
	}

	/**
	 *  Description of the Method
	 */
	private void init() {
		// make dialog closing appear as cancel
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				returnCode = CANCEL_OPTION;
			}

		});

		for (int i = 0; i < vsites.size(); i++) {
			Vsite vsite = (Vsite) vsites.elementAt(i);
			if (!ResourceManager.isVsiteAvailable(vsite)) {
				vsites.remove(vsite);
			}
		}

		buildComponents();

		int xsize = 800;
		int ysize = 600;
		Dimension screen = getToolkit().getScreenSize();
		double xcenter = screen.getWidth() / 2;
		double ycenter = screen.getHeight() / 2;
		setSize(xsize, ysize);
		setLocation((int) (xcenter - xsize / 2), (int) (ycenter - ysize / 2));
		pack();
		currentPanel.setDividerLocation(250);
	}

	/**
	 *  Description of the Method
	 */
	private void performOK() {
		returnCode = APPROVE_OPTION;
		selectedFile = currentPanel.getSelectedFile();
		if (checkFileType(selectedFile)) {
			setVisible(false);
		}
	}

	/**
	 *  Description of the Method
	 */
	public void rememberLayout() {
		position = getLocation();
		size = getSize();
		dividerLocation = currentPanel.getDividerLocation();
	}

	/**
	 *  Description of the Method
	 */
	public void removeFileFilters() {
		currentPanel.removeFileFilters();
	}

	/**
	 *  Description of the Method
	 */
	public void resetLayout() {
		if (position == null || size == null) {
			return;
		}
		setLocation(position);
		setSize(size);
		currentPanel.setDividerLocation(dividerLocation);
	}

	/**
	 *  Sets the filename attribute of the SelectorDialog object
	 *
	 *@param  filename  The new filename value
	 */
	public void setFilename(String filename) {
		currentPanel.setFilename(filename);
	}

	/**
	 *  Constructor for the setFileSelectionMode object
	 *
	 *@param  fileSelectionMode  Description of the Parameter
	 */
	public void setFileSelectionMode(int fileSelectionMode) {
		this.fileSelectionMode = fileSelectionMode;
	}

	/**
	 *  Sets the localEnabled attribute of the SelectorDialog object
	 *
	 *@param  enabled  The new localEnabled value
	 */
	public void setLocalEnabled(boolean localEnabled) {
		this.localEnabled = localEnabled;
		if (vsiteBox == null) {
			return;
		}
		if (!localEnabled) {
			vsiteBox.removeItem(FileStorage.NSPACE_STRING);
			vsiteBox.setSelectedIndex(0);
		} else {
			vsiteBox.removeItem(FileStorage.NSPACE_STRING);
			vsiteBox.addItem(FileStorage.NSPACE_STRING);
		}
	}

	/**
	 *  Sets the currentDirectory attribute of the SelectorDialog object
	 *
	 *@param  selectedFile               The new selectedFile value
	 *@exception  FileNotFoundException  Description of the Exception
	 */
	public void setSelectedFile(File selectedFile)
		throws FileNotFoundException {
		if (selectedFile == null) {
			selectedFile =
				FileSystemView.getFileSystemView().getDefaultDirectory();
		}
		this.selectedFile = selectedFile;
		if (vsiteBox != null) {
			Object location = null;
			if (selectedFile instanceof RemoteFile) {
				location = ((RemoteFile) selectedFile).getVsite();
			} else {
				location = FileStorage.NSPACE_STRING;
			}
			vsiteBox.setSelectedItem(location);
		}
		currentPanel.setSelectedFile(selectedFile);
	}

	/**
	 *  Sets the selectedFileFilter attribute of the SelectorDialog object
	 *
	 *@param  filter  The new selectedFileFilter value
	 */
	public void setSelectedFileFilter(FileFilter filter) {
		currentPanel.setSelectedFileFilter(filter);
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public int showDialog() {
		if (initialized) {
			resetLayout();
		}
		currentPanel.refresh();
		setVisible(true);
		rememberLayout();
		initialized = true;
		return returnCode;
	}

	/**
	 *  Description of the Method
	 */
	private void updateCurrentPanel() {
		centerPanel.removeAll();
		centerPanel.add(currentPanel);
		currentPanel.revalidate();
		resetLayout();
	}

	/**
	 *  Description of the Method
	 *
	 *@param  oldPanel  Description of the Parameter
	 *@param  newPanel  Description of the Parameter
	 */
	private void updateFileFilters(
		SelectorPanel oldPanel,
		SelectorPanel newPanel) {
		Vector newFilters = oldPanel.getFileFilters();
		Vector oldFilters = newPanel.getFileFilters();
		for (int i = 0; i < newFilters.size(); i++) {
			FileFilter filter = (FileFilter) newFilters.elementAt(i);
			if (!oldFilters.contains(filter)) {
				newPanel.addFileFilter(filter);
			}
		}
		for (int i = 0; i < oldFilters.size(); i++) {
			FileFilter filter = (FileFilter) oldFilters.elementAt(i);
			if (!newFilters.contains(filter)) {
				newPanel.removeFileFilter(filter);
			}
		}
		newPanel.setSelectedFileFilter(oldPanel.getSelectedFileFilter());
	}
}
