package com.pallas.unicore.client.explorer;

/**
 *  Description of the Class
 *
 *@author     Ralf Ratering
 *@created    22. Mai 2002
 *@version $Id: SizeEntry.java,v 1.2 2003/06/30 06:53:47 rrate Exp $
 */
public class SizeEntry implements Comparable {
	private long bytes;
	private String stringRep = "";

	/**
	 *  Constructor for the SizeEntry object
	 *
	 *@param  bytes  Description of the Parameter
	 */
	public SizeEntry(long bytes) {
		this.bytes = bytes;
		if (bytes > 0) {
			stringRep = (long) (Math.ceil(bytes / 1000.0)) + " KB";
		}
	}

	/**
	 *  Description of the Method
	 *
	 *@param  object  Description of the Parameter
	 *@return         Description of the Return Value
	 */
	public int compareTo(Object object) {
		long bytes2 = ((SizeEntry) object).bytes;
		if (bytes > bytes2) {
			return 1;
		}
		if (bytes < bytes2) {
			return -1;
		}
		return 0;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		return stringRep;
	}
}
