package com.pallas.unicore.client.graphics;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

/**
 *@author     Ralf Ratering
 *@created    16. August 2001
 *@version    $Id: ClipRectangle.java,v 1.2 2003/06/30 06:53:58 rrate Exp $
 */

public class ClipRectangle extends Rectangle {

	/**
	 *  The main program for the ClipRectangle class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		ClipRectangle clipRectangle1 = new ClipRectangle();
	}

	/**
	 *  Constructor for the ClipRectangle object
	 */
	public ClipRectangle() {
	}

	/**
	 *  Constructor for the ClipRectangle object
	 *
	 *@param  d  Description of Parameter
	 */
	public ClipRectangle(Dimension d) {
		super(d);
	}

	/**
	 *  Constructor for the ClipRectangle object
	 *
	 *@param  width   Description of Parameter
	 *@param  height  Description of Parameter
	 */
	public ClipRectangle(int width, int height) {
		super(width, height);
	}

	/**
	 *  Constructor for the ClipRectangle object
	 *
	 *@param  x       Description of Parameter
	 *@param  y       Description of Parameter
	 *@param  width   Description of Parameter
	 *@param  height  Description of Parameter
	 */
	public ClipRectangle(int x, int y, int width, int height) {
		super(x, y, width, height);
	}

	/**
	 *  Constructor for the ClipRectangle object
	 *
	 *@param  p  Description of Parameter
	 */
	public ClipRectangle(Point p) {
		super(p);
	}

	/**
	 *  Constructor for the ClipRectangle object
	 *
	 *@param  p  Description of Parameter
	 *@param  d  Description of Parameter
	 */
	public ClipRectangle(Point p, Dimension d) {
		super(p, d);
	}

	/**
	 *  Constructor for the ClipRectangle object
	 *
	 *@param  r  Description of Parameter
	 */
	public ClipRectangle(Rectangle r) {
		super(r);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  line  Description of Parameter
	 *@return       Description of the Returned Value
	 */
	public Point2D findIntersection(Line2D line) {
		if (!intersectsLine(line)) {
			return null;
		}

		// x1==x and y1==y
		double x2 = x + width;
		double y2 = y + height;
		double lx1 = line.getX1();
		double ly1 = line.getY1();
		double lx2 = line.getX2();
		double ly2 = line.getY2();

		if (line.intersectsLine(new Line2D.Double(x, y, x2, y))) {
			double sy = y;
			double sx = lx1 + (lx2 - lx1) * (sy - ly1) / (ly2 - ly1);
			return new Point2D.Double(sx, sy);
		}

		if (line.intersectsLine(new Line2D.Double(x2, y, x2, y2))) {
			double sx = x2;
			double sy = ly1 + (ly2 - ly1) * (sx - lx1) / (lx2 - lx1);
			return new Point2D.Double(sx, sy);
		}

		if (line.intersectsLine(new Line2D.Double(x2, y2, x, y2))) {
			double sy = y2;
			double sx = lx1 + (lx2 - lx1) * (sy - ly1) / (ly2 - ly1);
			return new Point2D.Double(sx, sy);
		}

		if (line.intersectsLine(new Line2D.Double(x, y2, x, y))) {
			double sx = x;
			double sy = ly1 + (ly2 - ly1) * (sx - lx1) / (lx2 - lx1);
			return new Point2D.Double(sx, sy);
		}

		return null;
	}
}
