package com.pallas.unicore.client.graphics;

import java.awt.Color;
import java.awt.Point;

/**
 *@author     Ralf Ratering
 *@created    21. August 2001
 *@version    $Id: Selectable.java,v 1.2 2003/06/30 06:53:58 rrate Exp $
 */
public interface Selectable {

	/**
	 *  Gets the Center attribute of the Selectable object
	 *
	 *@return    The Center value
	 */
	public Point getCenter();

	/**
	 *  Gets the SelectionColor attribute of the Selectable object
	 *
	 *@return    The SelectionColor value
	 */
	public Color getSelectionColor();

	/**
	 *  Gets the Selected attribute of the Selectable object
	 *
	 *@return    The Selected value
	 */
	public boolean isSelected();

	/**
	 *  Sets the Center attribute of the Selectable object
	 *
	 *@param  center  The new Center value
	 */
	public void setCenter(Point center);
	/**
	 *  Sets the Selected attribute of the Selectable object
	 *
	 *@param  selected  The new Selected value
	 */
	public void setSelected(boolean selected);

	/**
	 *  Sets the SelectionColor attribute of the Selectable object
	 *
	 *@param  selectionColor  The new SelectionColor value
	 */
	public void setSelectionColor(Color selectionColor);

}
