package com.pallas.unicore.client.graphs;

import javax.swing.ImageIcon;

import com.pallas.unicore.container.ActionContainer;

/**
 *  Class representing a UNICOREpro ActionContainer in a dependency graph
 *
 *@author     Ralf Ratering
 *@created    15. August 2001
 *@version    $Id: ContainerVertex.java,v 1.3 2003/06/30 06:54:11 rrate Exp $
 */
public class ContainerVertex extends DAGVertex {

	private ActionContainer container;

	/**
	 *  Constructor for the ContainerVertex object
	 *
	 *@param  container  container represented by this vertex
	 */
	public ContainerVertex(ActionContainer container) {
		super(container.getName());

		this.container = container;
	}

	/**
	 *  Gets the Container attribute of the ContainerVertex object
	 *
	 *@return    The Container value
	 */
	public ActionContainer getContainer() {
		return container;
	}

	/**
	 *  Gets the Icon attribute of the ContainerVertex object
	 *
	 *@return    The Icon value
	 */
	public ImageIcon getImageIcon() {
		if (container != null) {
			return container.getStatusIcon();
		}
		return null;
	}
}
