package com.pallas.unicore.client.panels;

import java.util.logging.Logger;

import javax.swing.JComboBox;
import javax.swing.JPanel;

import com.pallas.unicore.container.ActionContainer;
import com.pallas.unicore.extensions.AbstractTest;

/**
 *@author     Ralf Ratering
 *@created    17. Juli 2002
 *@version    $Id: AbstractTestPanel.java,v 1.3 2003/06/30 06:54:45 rrate Exp $
 */
public abstract class AbstractTestPanel extends JPanel {
	/**
	 *  Description of the Field
	 */
	protected static Logger logger =
		Logger.getLogger("com.pallas.unicore.client.panels");

	/**
	 *  Description of the Field
	 */
	protected ActionContainer container;

	/**
	 *  Description of the Field
	 */
	protected JComboBox testBox;

	/**
	 *  Constructor for the AbstractTestPanel object
	 *
	 *@param  container  Description of the Parameter
	 */
	public AbstractTestPanel(ActionContainer container) {
		this.container = container;
	}

	/**
	 *  Description of the Method
	 */
	public abstract void applyValues();

	/**
	 *  Gets the testBox attribute of the AbstractTestPanel object
	 *
	 *@return    The testBox value
	 */
	public JComboBox getTestBox() {
		return testBox;
	}

	/**
	 *  Description of the Method
	 */
	public abstract void resetValues();

	/**
	 *  Sets the enabled attribute of the AbstractTestPanel object
	 *
	 *@param  enabled  The new enabled value
	 */
	public void setEnabled(boolean enabled) {
		if (!enabled) {
			testBox.setSelectedItem(AbstractTest.DISABLED);
		}
	}

	/**
	 *  Description of the Method
	 *
	 *@param  vsiteChanged  Description of the Parameter
	 */
	public abstract void updateValues(boolean vsiteChanged);

}
