package com.pallas.unicore.client.panels;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.pallas.unicore.client.controls.IntTextField;
import com.pallas.unicore.container.DoNContainer;

/**
 *@author     Ralf Ratering
 *@author     Sven Haubold
 *@created    21. August 2001
 *@version    $Id: DoNPanel.java,v 1.2 2003/06/30 06:54:43 rrate Exp $
 */
public class DoNPanel extends GroupDependencyPanel {

	private IntTextField nTextField;

	/**
	 *  Constructor
	 *
	 *@param  parentFrame  reference to main JFrame
	 *@param  container    Description of the Parameter
	 */
	public DoNPanel(JFrame parentFrame, DoNContainer container) {
		super(parentFrame, container);
	}

	/**
	 *  Apply values from gui to JobContainer
	 */
	public void applyValues() {
		DoNContainer doNContainer = (DoNContainer) container;
		doNContainer.setIterations(nTextField.getValue());
		super.applyValues();
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	protected JPanel buildControlPanel() {
		nTextField = new IntTextField(1, 0, 10000);
		nTextField.setToolTipText("Repeat the belonging job task n times.");

		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		JLabel label = new JLabel("Number of iterations:");
		label.setToolTipText("Repeat the belonging job task n times.");
		panel.add(label);
		panel.add(nTextField);

		JPanel controlPanel = new JPanel();
		controlPanel.add(panel);

		return controlPanel;
	}

	/**
	 *  Fill values from JobContainer into gui
	 */
	public void resetValues() {
		DoNContainer doNContainer = (DoNContainer) container;
		nTextField.setValue(doNContainer.getIterations());
		super.resetValues();
	}

}
