package com.pallas.unicore.client.panels;

import java.awt.event.ActionEvent;
import java.util.Vector;

import javax.swing.AbstractAction;

import org.unicore.resources.Storage;

import com.pallas.unicore.container.TaskContainer;
import com.pallas.unicore.extensions.FileStorage;
import com.pallas.unicore.extensions.NamedResourceSet;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Ralf Ratering
 *@created    11. September 2001
 *@version    $Id: FileStoragePanel.java,v 1.2 2003/06/30 06:54:40 rrate Exp $
 */
public abstract class FileStoragePanel extends FilePanel {

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    4. Juni 2002
	 */
	class BrowseAction extends AbstractAction {
		/**
		 *  Constructor for the RemoveAction object
		 */
		public BrowseAction() {
			super("Browse", ResourceManager.getIcon(ResourceManager.OPEN));
		}

		/**
		 *  Description of the Method
		 *
		 *@param  e  Description of the Parameter
		 */
		public void actionPerformed(ActionEvent e) {
			if (table.getCellEditor() != null) {
				table.getCellEditor().stopCellEditing();
			}
			showBrowser();
		}
	}

	/**
	 *  Description of the Field
	 */
	protected BrowseAction browseAction = new BrowseAction();
	//protected StorageComboBox storages = new StorageComboBox();

	/**
	 *  Description of the Field
	 */
	protected String currentDirectory;

	/**
	 *  file storage sources
	 */
	protected Vector storages;

	/**
	 *  Constructor
	 *
	 *@param  container         Description of Parameter
	 *@param  currentDirectory  Description of the Parameter
	 */
	public FileStoragePanel(TaskContainer container, String currentDirectory) {
		super(container);
		this.currentDirectory = currentDirectory;
		popup.add(browseAction);
		toolbar.add(browseAction);
	}

	/**
	 *  Gets the fileStorageAt attribute of the FileExportPanel object
	 *
	 *@param  row    Description of the Parameter
	 *@return        The fileStorageAt value
	 *@deprecated    use getFileOperationAt instead
	 */
	protected FileStorage getFileStorageAt(int row) {
		return (FileStorage) getFileOperationAt(row);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  fileStorage  Description of the Parameter
	 *@deprecated          use removeFileOperation instead
	 */
	protected void removeFileStorage(FileStorage fileStorage) {
		removeFileOperation(fileStorage);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  col  Description of Parameter
	 */
	protected void replaceStorageResources(int col) {
		for (int i = 0; i < table.getRowCount(); i++) {
			Object storage = tableModel.getValueAt(i, col);
			// do not replace "Local"
			if (storage instanceof Storage) {
				//ResourceEntry siteStorage = storages.findResourceEntry(((ResourceEntry)storage).getResource());
				NamedResourceSet siteResources =
					ResourceManager.getResourceSet(container.getVsite());
				Storage siteStorage =
					(Storage) siteResources.findResource((Storage) storage);
				// Only replace storages found at current Vsite; keep "wrong" storage from other Vsite
				if (siteStorage != null) {
					tableModel.setValueAt(siteStorage, i, col);
				}
			}
		}
		// apply new entries
		applyValues();
	}

	/**
	 *  Description of the Method
	 */
	protected abstract void showBrowser();

	/**
	 *  Get current storage resources from ResourceManager
	 */
	public void updateStorageResources() {
		/*
		Vector alsoResourceEntries = new Vector();
		alsoResourceEntries.add(ResourceEntry.LOCAL);
		storages.update(container.getVsite(), alsoResourceEntries);
		*/
		if (storages == null) {
			storages = new Vector();
		}
		storages.removeAllElements();
		storages.add(FileStorage.NSPACE_STRING);

		NamedResourceSet resourceSet =
			ResourceManager.getResourceSet(container.getVsite());
		if (resourceSet == null) {
			return;
		}
		resourceSet.addStorageResources(storages);

		Vector cloned = (Vector) storages.clone();
		for (int i = 0; i < cloned.size(); i++) {
			if (cloned.elementAt(i) instanceof org.unicore.resources.Spool
				|| cloned.elementAt(i)
					instanceof org.unicore.resources.AlternativeUspace) {
				storages.remove(cloned.elementAt(i));
			}
		}
		cloned.clear();
	}
}
