package com.pallas.unicore.client.panels;

import javax.swing.JPanel;

/**
 *  Interface for objects that provide one or more panels.
 *
 *@author     Ralf Ratering
 *@created    22. Januar 2002
 *@version    $Id: IPanelProvider.java,v 1.2 2003/06/30 06:54:34 rrate Exp $
 */

public interface IPanelProvider {

	/**
	 *  When the panel is removed from the gui, there may be some finalization
	 *  neccessary (e.g. stopping threads). This will be done in this method.
	 */
	public void finalizePanel();

	/**
	 *  Get number of panels provided by thhis object
	 *
	 *@return    nr of panels
	 */
	public int getNrOfPanels();

	/**
	 *  Get ith panel
	 *
	 *@param  i  panel index
	 *@return    ith panel
	 */
	public JPanel getPanel(int i);

	/**
	 *  Get title for ith panel. The title can be used to put the panel into a
	 *  tabbed pane for instance
	 *
	 *@param  i  panel index
	 *@return    title string
	 */
	public String getPanelTitle(int i);
}
