package com.pallas.unicore.client.plugins.autoupdate;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;

import com.pallas.unicore.client.util.ExtensionPlugable;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Thomas Kentemich
 *@created    17. September 2001
 *@version    $Id: AutoUpdatePlugin.java,v 1.2 2003/06/30 06:55:07 rrate Exp $
 */
public class AutoUpdatePlugin extends ExtensionPlugable {

	/**
	 *  Listener class for settings menu entry
	 *
	 *@author     rrate
	 *@created    17. September 2001
	 */
	private class CustomListener implements ActionListener {
		/**
		 *  Description of the Method
		 *
		 *@param  event  Description of Parameter
		 */
		public void actionPerformed(ActionEvent event) {
			watcher = new WatchFrame(ResourceManager.getCurrentInstance());
			SwingUtilities.updateComponentTreeUI(watcher);
			watcher.show();
		}
	}

	private WatchFrame watcher;

	/**
	 *  Used to add menus to main frame
	 *
	 *@return    The CustomMenu value
	 */
	public JMenuItem getCustomMenu() {
		JMenu returnMenu = new JMenu("Watch jobs");
		JMenuItem threadMonitor = new JMenuItem("Show list");

		threadMonitor.addActionListener(new CustomListener());
		returnMenu.add(threadMonitor);
		return returnMenu;
	}

	/**
	 *  Get a short info message for the plugin
	 *
	 *@return    String with info message
	 */
	public String getPluginInfo() {
		return "Autoupdate JMC entries\n" + "(C)2001 Pallas GmbH";
	}

	/**
	 *  Called to inititialize the plugin
	 *
	 */
	public void startPlugin() {
	}

	/**
	 *  Called when terminating
	 */
	public void stopPlugin() {
		// do nothing
	}

}
