package com.pallas.unicore.client.tables;

import java.awt.Component;
import java.text.DateFormat;
import java.util.Date;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Ralf Ratering
 *@created    27. September 2002
 *@version    $Id: DateTableCellRenderer.java,v 1.2 2003/06/30 06:56:02 rrate Exp $
 */
public class DateTableCellRenderer extends DefaultTableCellRenderer {
	private static DateFormat formatter =
		ResourceManager.getCompleteFormatter();

	/**
	 *  Constructor for the DateTableCellRenderer object
	 *
	 *@param  formatter  Description of the Parameter
	 */
	public DateTableCellRenderer(DateFormat _formatter) {
		formatter = _formatter;
	}

	/**
	 *  Gets the tableCellRendererComponent attribute of the
	 *  DateTableCellRenderer object
	 *
	 *@param  value     Description of the Parameter
	 *@param  hasFocus  Description of the Parameter
	 *@param  row       Description of the Parameter
	 *@param  column    Description of the Parameter
	 *@param  table     Description of the Parameter
	 *@param  selected  Description of the Parameter
	 *@return           The tableCellRendererComponent value
	 */
	public Component getTableCellRendererComponent(
		JTable table,
		Object value,
		boolean selected,
		boolean hasFocus,
		int row,
		int column) {

		JLabel label =
			(JLabel) super.getTableCellRendererComponent(
				table,
				value,
				selected,
				hasFocus,
				row,
				column);

		if (!(value instanceof Date)) {
			return label;
		}

		Date date = (Date) value;
		label.setText(formatter.format(date));
		return label;
	}

}
