package com.pallas.unicore.client.tables;

import java.io.Serializable;

/**
 *  Class to keep file permissions
 *  Used to start Renderer and Editor in tables depending on the value type
 *
 *@author     Klaus-Dieter Oertel
 *@created    13. August 2002
 *@version $Id: FilePermission.java,v 1.2 2003/06/30 06:56:02 rrate Exp $
 */
public class FilePermission implements Serializable {
	private boolean executePermission = false;
	private boolean readPermission = false;
	private boolean writePermission = false;

	/**
	 *  Constructor for the FilePermissionPanel object
	 */
	public FilePermission() {
	}

	public boolean getExecutePermission() {
		return executePermission;
	}

	public boolean getReadPermission() {
		return readPermission;
	}

	public boolean getWritePermission() {
		return writePermission;
	}

	public void setExecutePermission(boolean executePermission) {
		this.executePermission = executePermission;
	}

	/**
	 *  Construct from String representation
	 *
	 *  Valid Strings are only substrings of "rwx"
	 */
	public FilePermission setPermission(String perm) {
		int pos = 0;
		if (perm.indexOf("r", pos) == pos) {
			readPermission = true;
			pos++;
		}
		if (perm.indexOf("w", pos) == pos) {
			writePermission = true;
			pos++;
		}
		if (perm.indexOf("x", pos) == pos) {
			executePermission = true;
			pos++;
		}
		if (pos != perm.length()) {
			System.err.println(
				"INVALID FILE PERMISSION: "
					+ perm
					+ "(pos "
					+ pos
					+ ", length "
					+ perm.length());
		}
		System.out.println(
			"Mapped string permission "
				+ perm
				+ " to FilePermission "
				+ this.toString());
		//	new Exception().printStackTrace();
		return this;
	}

	public void setReadPermission(boolean readPermission) {
		this.readPermission = readPermission;
	}

	public void setWritePermission(boolean writePermission) {
		this.writePermission = writePermission;
	}

	public String toString() {
		/*
		int perm = 0;
		
		if (readPermission)    perm += 4;
		if (writePermission)   perm += 2;
		if (executePermission) perm += 1;
		
		return (new Integer(perm)).toString();
		*/

		String permission = "";
		if (readPermission)
			permission += "r";
		if (writePermission)
			permission += "w";
		if (executePermission)
			permission += "x";
		return permission;
	}
}
