package com.pallas.unicore.client.tables;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;

public class FilePermissionCellEditor extends DefaultCellEditor {

	public FilePermissionCellEditor(final FilePermissionPanel permPanel) {
		super(new JCheckBox());
		editorComponent = permPanel;
		this.clickCountToStart = 1;
		delegate = new EditorDelegate() {

			public Object getCellEditorValue() {
				FilePermission permissions =
					((FilePermissionPanel) editorComponent).getFilePermission();
				return permissions;
			}
			public void setValue(Object value) {
				FilePermissionPanel permPanel =
					(FilePermissionPanel) editorComponent;
				if (value != null) {
					if (value instanceof FilePermission) {
						permPanel.setFilePermission((FilePermission) value);
					} else {
						// this should never happen ...
						permPanel.setFilePermission(
							new FilePermission().setPermission(
								value.toString()));
					}
				} else {
					permPanel.setFilePermission(new FilePermission());
				}
			}
		};
		((FilePermissionPanel) editorComponent).addActionListener(delegate);

		//Must do this so that editing stops when appropriate.
		/*
		    editorComponent.addActionListener(new ActionListener() {
		        public void actionPerformed(ActionEvent e) {
		            fireEditingStopped();
		        }
		    });
		*/
	}
}
