package com.pallas.unicore.client.themes;

import java.awt.SystemColor;

import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.metal.DefaultMetalTheme;
import javax.swing.plaf.metal.MetalLookAndFeel;

/**
 *  This class describes a theme using system colors.
 *
 *@author     Ralf Ratering
 *@created    17. September 2001
 *@version    $Id: SystemTheme.java,v 1.2 2003/06/30 06:56:11 rrate Exp $
 */
public class SystemTheme extends DefaultMetalTheme {

	/**
	 *  Description of the Method
	 *
	 *@param  args  Description of Parameter
	 */
	public static void main(String args[]) {

		SystemTheme c = new SystemTheme();
		System.err.println("PRIMARY1: " + c.getPrimary1());
		System.err.println("PRIMARY2: " + c.getPrimary2());
		System.err.println("PRIMARY3: " + c.getPrimary3());
		System.err.println("SECONDARY1: " + c.getSecondary1());
		System.err.println("SECONDARY2: " + c.getSecondary2());
		System.err.println("SECONDARY3: " + c.getSecondary3());

		MetalLookAndFeel.setCurrentTheme(c);

	}

	// labels & borders
	private final ColorUIResource primary1 =
		new ColorUIResource(SystemColor.controlText);

	// selected menus, scrollbars, progress bars
	private final ColorUIResource primary2 =
		new ColorUIResource(SystemColor.controlShadow);

	// title background, selected text
	private final ColorUIResource primary3 =
		new ColorUIResource(SystemColor.controlHighlight);

	// 3D border effects
	private final ColorUIResource secondary1 =
		new ColorUIResource(SystemColor.controlDkShadow);

	// pushed buttons, disabled button text, inactive borders
	private final ColorUIResource secondary2 =
		new ColorUIResource(SystemColor.controlShadow);

	// background canvas, inactive titles
	private final ColorUIResource secondary3 =
		new ColorUIResource(SystemColor.menu);

	/**
	 *  Gets the Name attribute of the SystemTheme object
	 *
	 *@return    The Name value
	 */
	public String getName() {
		return "System";
	}

	/**
	 *  Gets the Primary1 attribute of the SystemTheme object
	 *
	 *@return    The Primary1 value
	 */
	protected ColorUIResource getPrimary1() {
		return primary1;
	}

	/**
	 *  Gets the Primary2 attribute of the SystemTheme object
	 *
	 *@return    The Primary2 value
	 */
	protected ColorUIResource getPrimary2() {
		return primary2;
	}

	/**
	 *  Gets the Primary3 attribute of the SystemTheme object
	 *
	 *@return    The Primary3 value
	 */
	protected ColorUIResource getPrimary3() {
		return primary3;
	}

	/**
	 *  Gets the Secondary1 attribute of the SystemTheme object
	 *
	 *@return    The Secondary1 value
	 */
	protected ColorUIResource getSecondary1() {
		return secondary1;
	}

	/**
	 *  Gets the Secondary2 attribute of the SystemTheme object
	 *
	 *@return    The Secondary2 value
	 */
	protected ColorUIResource getSecondary2() {
		return secondary2;
	}

	/**
	 *  Gets the Secondary3 attribute of the SystemTheme object
	 *
	 *@return    The Secondary3 value
	 */
	protected ColorUIResource getSecondary3() {
		return secondary3;
	}

}
