package com.pallas.unicore.client.themes;

import java.awt.Color;
import java.awt.Font;

import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;
import javax.swing.plaf.metal.DefaultMetalTheme;

/**
 *  A theme that can be modified by the user.
 *
 *@author     Ralf Ratering
 *@created    17. September 2001
 *@version    $Id: UserTheme.java,v 1.2 2003/06/30 06:56:11 rrate Exp $
 */
public class UserTheme extends DefaultMetalTheme {

	/**
	 *  Description of the Field
	 */
	protected FontUIResource controlFont = super.getControlTextFont(),
		systemFont = super.getSystemTextFont(),
		userFont = super.getUserTextFont(),
		menuFont = super.getMenuTextFont(),
		titleFont = super.getWindowTitleFont(),
		subFont = super.getSubTextFont();

	private String name = "User Defined";

	private ColorUIResource primary1 = super.getPrimary1(),
		primary2 = super.getPrimary2(),
		primary3 = super.getPrimary3(),
		secondary1 = super.getSecondary1(),
		secondary2 = super.getSecondary2(),
		secondary3 = super.getSecondary3(),
		black = super.getBlack(),
		white = super.getWhite();

	/**
	 *  Gets the Black attribute of the UserTheme object
	 *
	 *@return    The Black value
	 */
	protected ColorUIResource getBlack() {
		return black;
	}

	/**
	 *  Gets the BlackColor attribute of the UserTheme object
	 *
	 *@return    The BlackColor value
	 */
	public Color getBlackColor() {
		return black;
	}

	/**
	 *  Gets the ControlTextFont attribute of the UserTheme object
	 *
	 *@return    The ControlTextFont value
	 */
	public FontUIResource getControlTextFont() {
		return controlFont;
	}

	/**
	 *  Gets the MenuTextFont attribute of the UserTheme object
	 *
	 *@return    The MenuTextFont value
	 */
	public FontUIResource getMenuTextFont() {
		return menuFont;
	}

	/**
	 *  Gets the Name attribute of the UserTheme object
	 *
	 *@return    The Name value
	 */
	public String getName() {
		return name;
	}

	/**
	 *  Gets the Primary1 attribute of the UserTheme object
	 *
	 *@return    The Primary1 value
	 */
	protected ColorUIResource getPrimary1() {
		return primary1;
	}

	/**
	 *  Gets the Primary1Color attribute of the UserTheme object
	 *
	 *@return    The Primary1Color value
	 */
	public Color getPrimary1Color() {
		return primary1;
	}

	/**
	 *  Gets the Primary2 attribute of the UserTheme object
	 *
	 *@return    The Primary2 value
	 */
	protected ColorUIResource getPrimary2() {
		return primary2;
	}

	/**
	 *  Gets the Primary2Color attribute of the UserTheme object
	 *
	 *@return    The Primary2Color value
	 */
	public Color getPrimary2Color() {
		return primary2;
	}

	/**
	 *  Gets the Primary3 attribute of the UserTheme object
	 *
	 *@return    The Primary3 value
	 */
	protected ColorUIResource getPrimary3() {
		return primary3;
	}

	/**
	 *  Gets the Primary3Color attribute of the UserTheme object
	 *
	 *@return    The Primary3Color value
	 */
	public Color getPrimary3Color() {
		return primary3;
	}

	/**
	 *  Gets the Secondary1 attribute of the UserTheme object
	 *
	 *@return    The Secondary1 value
	 */
	protected ColorUIResource getSecondary1() {
		return secondary1;
	}

	/**
	 *  Gets the Secondary1Color attribute of the UserTheme object
	 *
	 *@return    The Secondary1Color value
	 */
	public Color getSecondary1Color() {
		return secondary1;
	}

	/**
	 *  Gets the Secondary2 attribute of the UserTheme object
	 *
	 *@return    The Secondary2 value
	 */
	protected ColorUIResource getSecondary2() {
		return secondary2;
	}

	/**
	 *  Gets the Secondary2Color attribute of the UserTheme object
	 *
	 *@return    The Secondary2Color value
	 */
	public Color getSecondary2Color() {
		return secondary2;
	}

	/**
	 *  Gets the Secondary3 attribute of the UserTheme object
	 *
	 *@return    The Secondary3 value
	 */
	protected ColorUIResource getSecondary3() {
		return secondary3;
	}

	/**
	 *  Gets the Secondary3Color attribute of the UserTheme object
	 *
	 *@return    The Secondary3Color value
	 */
	public Color getSecondary3Color() {
		return secondary3;
	}

	/**
	 *  Gets the SubTextFont attribute of the UserTheme object
	 *
	 *@return    The SubTextFont value
	 */
	public FontUIResource getSubTextFont() {
		return subFont;
	}

	/**
	 *  Gets the SystemTextFont attribute of the UserTheme object
	 *
	 *@return    The SystemTextFont value
	 */
	public FontUIResource getSystemTextFont() {
		return systemFont;
	}

	/**
	 *  Gets the UserTextFont attribute of the UserTheme object
	 *
	 *@return    The UserTextFont value
	 */
	public FontUIResource getUserTextFont() {
		return userFont;
	}

	/**
	 *  Gets the White attribute of the UserTheme object
	 *
	 *@return    The White value
	 */
	protected ColorUIResource getWhite() {
		return white;
	}

	/**
	 *  Gets the WhiteColor attribute of the UserTheme object
	 *
	 *@return    The WhiteColor value
	 */
	public Color getWhiteColor() {
		return white;
	}

	/**
	 *  Gets the WindowTitleFont attribute of the UserTheme object
	 *
	 *@return    The WindowTitleFont value
	 */
	public FontUIResource getWindowTitleFont() {
		return titleFont;
	}

	/**
	 *  Sets the BlackColor attribute of the UserTheme object
	 *
	 *@param  b  The new BlackColor value
	 */
	public void setBlackColor(Color b) {
		this.black = new ColorUIResource(b);
	}

	/**
	 *  Sets the Font attribute of the UserTheme object
	 *
	 *@param  font  The new Font value
	 */
	public void setFont(Font font) {
		controlFont = new FontUIResource(font);
		systemFont = new FontUIResource(font);
		userFont = new FontUIResource(font);
		menuFont = new FontUIResource(font);
		titleFont = new FontUIResource(font);
		subFont = new FontUIResource(font);
	}

	/**
	 *  Sets the Name attribute of the UserTheme object
	 *
	 *@param  name  The new Name value
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 *  Sets the Primary1Color attribute of the UserTheme object
	 *
	 *@param  p1  The new Primary1Color value
	 */
	public void setPrimary1Color(Color p1) {
		this.primary1 = new ColorUIResource(p1);
	}

	/**
	 *  Sets the Primary2Color attribute of the UserTheme object
	 *
	 *@param  p2  The new Primary2Color value
	 */
	public void setPrimary2Color(Color p2) {
		this.primary2 = new ColorUIResource(p2);
	}

	/**
	 *  Sets the Primary3Color attribute of the UserTheme object
	 *
	 *@param  p3  The new Primary3Color value
	 */
	public void setPrimary3Color(Color p3) {
		this.primary3 = new ColorUIResource(p3);
	}

	/**
	 *  Sets the Secondary1Color attribute of the UserTheme object
	 *
	 *@param  s1  The new Secondary1Color value
	 */
	public void setSecondary1Color(Color s1) {
		this.secondary1 = new ColorUIResource(s1);
	}

	/**
	 *  Sets the Secondary2Color attribute of the UserTheme object
	 *
	 *@param  s2  The new Secondary2Color value
	 */
	public void setSecondary2Color(Color s2) {
		this.secondary2 = new ColorUIResource(s2);
	}

	/**
	 *  Sets the Secondary3Color attribute of the UserTheme object
	 *
	 *@param  s3  The new Secondary3Color value
	 */
	public void setSecondary3Color(Color s3) {
		this.secondary3 = new ColorUIResource(s3);
	}

	/**
	 *  Sets the WhiteColor attribute of the UserTheme object
	 *
	 *@param  w  The new WhiteColor value
	 */
	public void setWhiteColor(Color w) {
		this.white = new ColorUIResource(w);
	}

}
