package com.pallas.unicore.client.xml;

import java.nio.charset.Charset;
import java.util.logging.Handler;
import java.util.logging.XMLFormatter;

/**
 *  Format a LogRecord into a standard XML format similar to the
 *  XMLFormatter.
 *
 *@author     Kirsten Foerster
 *@created    13. August 2002
 *@version    $Id: NewXMLFormatter.java,v 1.2 2003/06/30 06:56:47 rrate Exp $
 */

public class NewXMLFormatter extends XMLFormatter {

	/**
	 *  Return the header string for a set of XML formatted records.
	 *
	 *@param  h  The target handler.
	 *@return    header string
	 */
	public String getHead(Handler h) {
		StringBuffer sb = new StringBuffer();
		sb.append("<?xml version=\"1.0\"");
		String encoding = h.getEncoding();
		if (encoding == null) {
			// Figure out the default encoding.
			encoding = sun.io.Converters.getDefaultEncodingName();
		}
		// Try to map the encoding name to a canonical name.
		try {
			Charset cs = Charset.forName(encoding);
			encoding = cs.name();
		} catch (Exception ex) {
			// We hit problems finding a canonical name.
			// Just use the raw encoding name.
		}

		sb.append(" encoding=\"");
		sb.append(encoding);
		sb.append("\"");
		sb.append(" standalone=\"no\"?>\n");
		sb.append("<log>\n");
		return sb.toString();
	}
}
