package com.pallas.unicore.client.xml;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InvalidClassException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Reader;
import java.lang.reflect.Array;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.URL;
import java.security.AccessController;
import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import sun.misc.BASE64Decoder;
import sun.reflect.ReflectionFactory;

import com.pallas.unicore.client.Client;
import com.pallas.unicore.client.util.PluginObjectInputStream;
import com.pallas.unicore.resourcemanager.ResourceManager;
import com.pallas.unicore.utility.UserMessages;

/**
 *
 *@author
 *@created    April 10, 2002
 *@version    $Id: XMLObjectReader.java,v 1.6 2003/06/30 06:56:45 rrate Exp $
 */

public class XMLObjectReader extends XMLObjectIO {

	//------------------------------------------------------------------

	// Lesson learned from JSX
	//
	// simplest way to circumnavigate the ".equals" instead of identity test
	// of Hashtable (in Java 1.2)
	/**
	 *  Description of the Class
	 *
	 *@author     kdoertel
	 *@created    April 10, 2002
	 */
	static class HashObject {
		Object obj;
		int objID;

		/**
		 *  Constructor for the HashObject object
		 *
		 *@param  obj    Description of the Parameter
		 *@param  objID  Description of the Parameter
		 */
		public HashObject(Object obj, int objID) {
			this.obj = obj;
			this.objID = objID;
		}
		/*
		 *  public int hashCode() {
		 *  return System.identityHashCode(o);
		 *  }
		 *  public boolean equals(Object x) {	//essense
		 *  return ((HashObject)x).o == this.o;	//assumption that used by Hashtable,
		 *  /and that the tested part (key) will always be an IdObject
		 *  }
		 */
	}

	protected static Logger logger =
		Logger.getLogger("com.pallas.unicore.client.xml");
	private static Method newObjectMethod;
	private static ReflectionFactory reflFactory =
		(ReflectionFactory) AccessController.doPrivileged(
			new ReflectionFactory.GetReflectionFactoryAction());

	/**
	 *  Description of the Method
	 *
	 *@param  clazz  Description of the Parameter
	 *@return        Description of the Return Value
	 */
	private static Object newObjectInstance(Class clazz) {
		if (newObjectMethod != null) {
			try {
				return newObjectMethod.invoke(
					null,
					new Class[] { clazz, Object.class });
			} catch (Exception e) {
				UserMessages.error(e.toString());
				logger.log(Level.SEVERE, "", e);
			}
		} else {
			try {
				Object obj = clazz.newInstance();
				return obj;
			} catch (Exception e) {
				if (DEBUG >= 3) {
					logger.log(Level.SEVERE, "", e);
				}
				logger.warning(
					"=================== NO noarg-Constructor for class "
						+ clazz.getName());
				try {
					Object obj = newObjInstance(clazz);
					return obj;
				} catch (Exception ee) {
					logger.log(Level.SEVERE, "", ee);
				}
			}
		}
		return null;
	}

	public static Object newObjInstance(Class cl) throws Exception {
		Class initCl = Object.class; //my silly default
		Constructor cons = initCl.getDeclaredConstructor(new Class[0]);
		cons = reflFactory.newConstructorForSerialization(cl, cons);
		cons.setAccessible(true);

		return cons.newInstance(new Object[0]);
	}
	private DocumentBuilder builder;
	private DocumentBuilderFactory builderfactory;

	DebugMessages debug = new DebugMessages("|", " |");
	private BASE64Decoder decoder = new BASE64Decoder();
	private Document doc;
	private InputStream in;

	private Hashtable objTable;
	private Reader reader;
	static {
		newObjectMethod = null;
		try {
			newObjectMethod =
				getDeclaredMethod(
					java.io.ObjectInputStream.class,
					"allocateNewObject",
					new Class[] { Class.class, Class.class });
			if (newObjectMethod != null) {
				newObjectMethod.setAccessible(true);
				if (DEBUG >= 2) {
					logger.fine(newObjectMethod.toString());
				}
			}
		} catch (Exception e) {
			logger.log(Level.SEVERE, "", e);
		}
	}
	//    static Class[] OOS_ARGS = {ObjectOutputStream.class};
	//    public static Object[] writeObjectArglist;

	/**
	 *  constructor for XMLObjectWriter
	 *
	 *@exception  TransformerConfigurationException  Description of the
	 *      Exception
	 */
	private XMLObjectReader() throws TransformerConfigurationException {

		// Create Hashtable to store information about XML writtem objects
		objTable = new Hashtable();

		builderfactory = DocumentBuilderFactory.newInstance();
		//builderfactory.setValidating(true);
		//builderfactory.setNamespaceAware(true);
		//builderfactory.setIgnoringElementContentWhitespace(true);
		try {
			builder = builderfactory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			logger.log(Level.SEVERE, "", e);
		}

		builder.setErrorHandler(new org.xml.sax.ErrorHandler() {

			// treat validation errors as fatal
			public void error(SAXParseException e) throws SAXParseException {
				throw e;
			}
			// ignore fatal errors (an exception is guaranteed)
			public void fatalError(SAXParseException exception)
				throws SAXException {
			}

			// dump warnings too
			public void warning(SAXParseException err)
				throws SAXParseException {
				logger.warning(
					"** Warning"
						+ ", line "
						+ err.getLineNumber()
						+ ", uri "
						+ err.getSystemId());
				logger.warning("   " + err.getMessage());
			}
		});
	}

	/**
	 *  Constructor for the XMLObjectReader object
	 *
	 *@param  fin                                    Description of the
	 *      Parameter
	 *@exception  FileNotFoundException              Description of the
	 *      Exception
	 *@exception  TransformerConfigurationException  Description of the
	 *      Exception
	 */
	public XMLObjectReader(File fin)
		throws FileNotFoundException, TransformerConfigurationException {
		this(
			new BufferedInputStream(
				new DataInputStream(new FileInputStream(fin))));
	}

	/**
	 *  Constructor for the XMLObjectReader object
	 *
	 *@param  in                                     Description of the
	 *      Parameter
	 *@exception  TransformerConfigurationException  Description of the
	 *      Exception
	 */
	private XMLObjectReader(InputStream in)
		throws TransformerConfigurationException {
		this();
		if (in instanceof DataInputStream) {
			this.in = new BufferedInputStream(in);
		} else {
			this.in = new BufferedInputStream(new DataInputStream(in));
		}
	}

	/**
	 *  Constructor for the XMLObjectReader object
	 *
	 *@param  reader                                 Description of the
	 *      Parameter
	 *@exception  TransformerConfigurationException  Description of the
	 *      Exception
	 */
	public XMLObjectReader(Reader reader)
		throws TransformerConfigurationException {
		this();
		this.reader = new BufferedReader(reader);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  obj              Description of the Parameter
	 *@param  objClass         Description of the Parameter
	 *@exception  IOException  Description of the Exception
	 */
	private Object correctJOSReadMethod(Object obj, Class objClass) {
		Object new_obj = null;

		if (objClass == java.net.URL.class) {
			try {
				URL old_url = (URL) obj;
				URL new_url =
					new URL(
						old_url.getProtocol(),
						old_url.getHost(),
						old_url.getPort(),
						old_url.getFile());
				new_obj = new_url;
			} catch (java.net.MalformedURLException mue) {
				logger.log(Level.SEVERE, "", mue);
			}
		} else if (
			objClass == org.unicore.User.class
				|| objClass == org.unicore.Vsite.class) {

			new_obj = reserializeJOS(obj);
		}
		/*
		        if(objClass == org.unicore.User.class) {
			    org.unicore.User user = (org.unicore.User)obj;
			    Field field;
		
			    CertificateFactory cf;
			    try {
				field = org.unicore.Ulogin.class.getDeclaredField("cf");
				field.setAccessible(true);
				cf = (CertificateFactory)field.get(obj);
			        if(cf == null) cf = CertificateFactory.getInstance("X.509");
			    }
			    catch(Exception cex) {
				// Rethrow this information as readObject signature asks
				logger.severe("Ulogin certificate instantiation error: "+cex.getMessage());
				return null;
			    }
		
		            try {
				// Adapted from org.unicore.Ulogin.readObject()
				// Now instantiate local certificates using local classes
		
		                byte[][] encoded_chain;
			        try {
				    field = org.unicore.Ulogin.class.getDeclaredField("encoded_chain");
				    field.setAccessible(true);
				    encoded_chain = (byte[][])field.get(obj);
			        }
				catch (Exception e) {
				    logger.warning("Field encoded_chain not found: "+e.getMessage());
				    encoded_chain = null;
				}
		
				// What have we read in? Either an old form with just the
				// end entity certificate or a chain (not necessarily full)
				X509Certificate[] certificate_chain;
				if(encoded_chain == null) {
				    field = org.unicore.Ulogin.class.getDeclaredField("encoded");
				    field.setAccessible(true);
				    byte[] encoded = (byte[])field.get(obj);
				    // Just the certificate
				    certificate_chain = new X509Certificate[] {(X509Certificate)cf.generateCertificate(new ByteArrayInputStream(encoded))};
				}
				else {
				    // A chain
				    certificate_chain = new X509Certificate[encoded_chain.length];
				    for(int i = 0; i < encoded_chain.length; i++) {
					certificate_chain[i] = (X509Certificate)cf.generateCertificate(new ByteArrayInputStream(encoded_chain[i]));
				    }
				}
				user.setCertificateChain(certificate_chain);
				for(int i = 0; i < certificate_chain.length; i++) {
		                    logger.finest("Certificate chain["+i+"]: " + certificate_chain[i].getSubjectDN().getName());
				}
		            }
		            catch(java.security.cert.CertificateException cex) {
		                // Rethrow this information as signature asks
		                logger.severe("Ulogin certificate instantiation error: " + cex.getMessage());
		            }
		            catch(IllegalAccessException iae) {
		                logger.log(Level.SEVERE, "", iae);
		            }
		            catch(NoSuchFieldException nof) {
		                logger.log(Level.SEVERE, "", nof);
		            }
		        }
		*/
		return new_obj;
	}

	/**
	 *  Create a DOM element node for an array field
	 *
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	private Object createOBJArray(Class objClass, Element elem)
		throws IOException {
		Object obj[] = null;
		char x[] = new char[5];

		objClass = objClass.getComponentType();
		int dim = (new Integer(elem.getAttribute(ATTR_DIM))).intValue();
		int length = (new Integer(elem.getAttribute(ATTR_LENGTH))).intValue();

		try {
			obj = (Object[]) Array.newInstance(objClass, length);
		} catch (Exception e) {
		}

		// hash the new object
		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		Integer id = new Integer(idAttr.getNodeValue());
		if (!newHashed(id, obj)) {
			return obj;
		}

		NodeList list = elem.getChildNodes();
		int iObj = 0;
		for (int i = 0; i < list.getLength(); i++) {
			Node listi = list.item(i);
			if (listi.getNodeType() == Node.ELEMENT_NODE) {
				Element elemi = (Element) listi;
				if (iObj
					!= (new Integer(elemi.getAttribute(ATTR_INDEX))).intValue()) {
					logger.severe(
						"ERROR: " + "iObj!=elemIndex" + " in createOBJArray");
				}
				obj[iObj] = createOBJElement(elemi);
				iObj++;
			} else if (listi.getNodeType() == Node.COMMENT_NODE) {
				//System.out.println(indent+"------------- COMMENT_NODE: "+listi.getNodeValue());
			} else if (listi.getNodeType() == Node.TEXT_NODE) {
				String value = listi.getNodeValue();
				if (!value.startsWith("\n") || value.trim().length() > 0) {
					logger.severe("ERROR: Node.TEXT_NODE in createOBJArray");
				}
			} else {
				logger.severe(
					"ERROR: Node."
						+ listi.getNodeType()
						+ "_NODE in createOBJArray");
			}
		}

		if (iObj != length) {
			logger.severe("ERROR: iObj != length in createOBJArray");
		}

		return obj;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  vec              Description of the Parameter
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@param  isSuperClass     Description of the Parameter
	 *@exception  IOException  Description of the Exception
	 */
	private Date createOBJDate(Class objClass, Element elem)
		throws IOException {

		Date date;

		NodeList list = elem.getElementsByTagName("fastTime");
		if (list.getLength() > 0) {
			Element timeElem = (Element) list.item(0);
			Long fastTime = (Long) createOBJElement(timeElem);
			date = new Date(fastTime.longValue());
		} else {
			logger.warning("No fastTime element found in Date element");
			date = new Date();
		}

		// hash new object
		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		Integer id = new Integer(idAttr.getNodeValue());
		if (!newHashed(id, date)) {
			return date;
		}

		return date;
	}

	//------------------------------------------------------------------
	/**
	 *  Create a DOM element node from the obj
	 *
	 *@param  elem             Description of the Parameter
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	private Object createOBJElement(Element elem) throws IOException {
		if (DEBUG >= 1) {
			StringBuffer buf =
				new StringBuffer("createOBJElement(<" + elem.getTagName());
			NamedNodeMap attrMap = elem.getAttributes();
			for (int i = 0; i < attrMap.getLength(); i++) {
				Attr attr = (Attr) attrMap.item(i);
				buf.append(
					" " + attr.getName() + "=\"" + attr.getValue() + "\"");
			}
			buf.append(">)");
			debug.println(buf.toString());
		}

		debug.pushIndent();

		Object obj = null;
		Class objClass;

		String elemTag = elem.getNodeName();
		if (!elem.hasChildNodes() && elemTag.endsWith(NULL_INDICATOR)) {
			debug.popIndent();
			return null;
		}

		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		if (idAttr == null) {
			Attr idrefAttr = elem.getAttributeNode(ATTR_IDREF);
			Integer idref = new Integer(idrefAttr.getNodeValue());
			HashObject hobj = (HashObject) objTable.get(idref);
			obj = hobj.obj;
			debug.popIndent();
			return obj;
		}

		objClass = null;
		try {
			Attr valueType = elem.getAttributeNode(ATTR_VALUETYPE);

			String className;
			if (valueType != null) {
				className = valueType.getNodeValue();
			} else {
				className = elemTag;
			}
			if (className.endsWith(NOTYETIMPL_INDICATOR)) {
				className =
					className.substring(
						0,
						className.lastIndexOf(NOTYETIMPL_INDICATOR));
			}

			try {
				objClass = resolveClass(className);
			} catch (ClassNotFoundException cnfe) {
				objClass = resolveClass(validClassName(className));
			}

		} catch (ClassNotFoundException cnfe) {
			UserMessages.error(cnfe.toString());
			logger.log(Level.SEVERE, "", cnfe);
		}

		if (objClass == null) {
			debug.println(0, "" + elem.getNodeName());
			debug.popIndent();
			return null;
		}

		try {
			// Objects may create DOM elements by themselves
			/*
			 *  Method writeObjectMethod = getDeclaredMethod(objClass,
			 *  "writeObjectXML", OOS_ARGS,
			 *  Modifier.PRIVATE, Modifier.STATIC);
			 *  if (writeObjectMethod != null) {
			 *  writeObjectArglist = new ObjectOutputStream[] {new ObjectOutputStream(out)};
			 *  writeObjectMethod.invoke(obj, writeObjectArglist);
			 *  }
			 */
			obj = createOBJPrimitive(objClass, elem);
			if (obj != null) {
				// continue;
			} else if (objClass.isArray()) {
				obj = createOBJArray(objClass, elem);
			} else if (objClass == Class.class) {
				obj = createOBJNotYetImplemented(objClass, elem);
				if (DEBUG >= 2) {
					UserMessages.error(objClass + NOTYETIMPL_INDICATOR);
					debug.println(2, objClass + NOTYETIMPL_INDICATOR);
				}
				throw new RuntimeException(objClass + NOTYETIMPL_INDICATOR);
			} else if (objClass == Vector.class) {
				obj = createOBJVector(objClass, elem);
			} else if (objClass == Hashtable.class) {
				obj = createOBJHashtable(objClass, elem);
			} else if (objClass == Date.class) {
				obj = createOBJDate(objClass, elem);
			} else if (objClass == File.class) {
				obj = createOBJFile(objClass, elem);
			} else {

				//              if (DEBUG > 1) System.out.println("Generating XML tag " + className);
				//              try {
				/*
				 *  if (objClass.isInstance(Hashtable.class)) {
				 *  try {
				 *  Constructor hashConstruct = objClass.getConstructor(new Class[]{});
				 *  if (hashConstruct != null) {
				 *  hashConstruct.setAccessible(true);
				 *  obj = hashConstruct.newInstance(new Object[]{});
				 *  }
				 *  } catch (Exception e) {
				 *      logger.log(Level.SEVERE, "", e);
				 *  }
				 *  } else {
				 */
				obj = newObjectInstance(objClass);
				//		}
				if (obj instanceof Hashtable) {
					try {
						obj = objClass.newInstance();
					} catch (Exception e) {
						logger.log(Level.SEVERE, "", e);
					}
				}
				/*
				 *  } catch (DOMException ex) {
				 *      logger.log(Level.SEVERE, "", ex);
				 *  className = ex.toString().replace(' ','_');
				 *  if (DEBUG > 1) System.out.println("\nDOMException: Final XML tag " + className);
				 *  elem = doc.createElement(className);
				 *  }
				 */
				// hash the new object
				Integer id = new Integer(idAttr.getNodeValue());
				if (!newHashed(id, obj)) {
					return obj;
				}

				scanFields(elem, obj, objClass);

				Object new_obj = correctJOSReadMethod(obj, objClass);
				if (new_obj != null) {
					obj = new_obj;
				}
			}
		} catch (Exception e) {
			// throw new IOException("error: "+ e);
			logger.log(Level.SEVERE, "ERROR in createOBJElement: ", e);
		}

		debug.popIndent();
		return obj;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  vec              Description of the Parameter
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@param  isSuperClass     Description of the Parameter
	 *@exception  IOException  Description of the Exception
	 */
	private File createOBJFile(Class objClass, Element elem)
		throws IOException {

		File file;

		NodeList list = elem.getElementsByTagName("path");
		if (list.getLength() > 0) {
			Element pathElem = (Element) list.item(0);
			String path = (String) createOBJElement(pathElem);
			file = new File(path);
		} else {
			logger.warning("No path element found in File element");
			file = new File("");
		}

		// hash new object
		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		Integer id = new Integer(idAttr.getNodeValue());
		if (!newHashed(id, file)) {
			return file;
		}

		return file;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	private Hashtable createOBJHashtable(Class objClass, Element elem)
		throws IOException {
		int size = (new Integer(elem.getAttribute(ATTR_SIZE))).intValue();
		Hashtable table = new Hashtable(size);

		boolean isSuperClass = false;
		createOBJHashtable(table, objClass, elem, isSuperClass);

		return table;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  table            Description of the Parameter
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@param  isSuperClass     Description of the Parameter
	 *@exception  IOException  Description of the Exception
	 */
	private void createOBJHashtable(
		Hashtable table,
		Class objClass,
		Element elem,
		boolean isSuperClass)
		throws IOException {
		int size = (new Integer(elem.getAttribute(ATTR_SIZE))).intValue();

		// hash new object
		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		if (!isSuperClass) {
			Integer id = new Integer(idAttr.getNodeValue());
			if (!newHashed(id, table)) {
				return;
			}
		}

		NodeList list = elem.getChildNodes();
		int iTable = 0;
		for (int i = 0; i < list.getLength(); i++) {
			Node listi = list.item(i);
			if (listi.getNodeType() == Node.ELEMENT_NODE) {
				Element keyElem = null;
				Element valueElem = null;
				Element elemi = (Element) listi;
				if (iTable
					!= (new Integer(elemi.getAttribute(ATTR_INDEX))).intValue()) {
					logger.severe(
						"ERROR: " + "iVec!=elemIndex" + "in createOBJHastable");
				}
				NodeList keyval = elemi.getChildNodes();
				for (int j = 0; j < keyval.getLength(); j++) {
					Node keyvalj = keyval.item(j);
					if (keyvalj.getNodeType() == Node.ELEMENT_NODE) {
						Element elemj = (Element) keyvalj;
						String attr = elemj.getAttribute(ATTR_HASHVALUE);
						if (attr != null && attr.length() > 0) {
							if (iTable != (new Integer(attr)).intValue()) {
								logger.severe(
									"ERROR: "
										+ "iTable!=elemIndex"
										+ "in createOBJHastable");
							}
							valueElem = elemj;
							continue;
						}
						attr = elemj.getAttribute(ATTR_HASHKEY);
						if (attr != null && attr.length() > 0) {
							if (iTable != (new Integer(attr)).intValue()) {
								logger.severe(
									"ERROR: "
										+ "iTable!=elemIndex"
										+ "in createOBJHastable");
							}
							keyElem = elemj;
							continue;
						}
					}
				}
				Object key = createOBJElement(keyElem);
				Object value = createOBJElement(valueElem);
				table.put(key, value);
				iTable++;
			} else if (listi.getNodeType() == Node.COMMENT_NODE) {
				//System.out.println(indent+"------------- COMMENT_NODE: "+listi.getNodeValue());
				continue;
			} else if (listi.getNodeType() == Node.TEXT_NODE) {
				String value = listi.getNodeValue();
				if (value.startsWith("\n") && value.trim().length() == 0) {
					continue;
				}
				logger.severe("ERROR: Node.TEXT_NODE in createOBJHashtable");
			} else {
				logger.severe(
					"ERROR: Node."
						+ listi.getNodeType()
						+ "_NODE in createOBJVector");
			}
		}

		if (iTable != size) {
			logger.severe("ERROR: iTable != size");
		}
	}

	/**
	 *  Create a DOM element node for an (array) of primitives or wrappers.
	 *
	 *@param  valueClass     Description of the Parameter
	 *@param  elem           Description of the Parameter
	 *@return                Description of the Return Value
	 *@exception  Exception  Description of the Exception
	 */
	private Object createOBJNotYetImplemented(Class valueClass, Element elem)
		throws Exception {

		Object obj = newObjectInstance(valueClass);

		// hash the new object
		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		Integer id = new Integer(idAttr.getNodeValue());
		if (!newHashed(id, obj)) {
			return obj;
		}

		scanFields(elem, obj, valueClass);

		return obj;
	}

	/**
	 *  Create a DOM element node for an (array) of primitives or wrappers.
	 *
	 *@param  valueClass       Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	private Object createOBJPrimitive(Class valueClass, Element elem)
		throws IOException {

		return createOBJText(valueClass, elem);
		/*
		 *  if (text == null) return null;
		 *  String fName;
		 *  if (fieldName != null) fName = fieldName;
		 *  else                   fName = validXMLTag(value);
		 *  try {
		 *  fieldElem = doc.createElement(fName);
		 *  } catch (DOMException e) {
		 *  logger.log(Level.SEVERE, "", e);
		 *  System.err.println("\nDOMException: wrong XML Tag>"+fName+"<");
		 *  fName = "DOMEXCEPTION";
		 *  if (DEBUG > 1) System.out.println("\nDOMException: Final XML tag " + fName);
		 *  fieldElem = doc.createElement(fName);
		 *  }
		 *  if (!newHashed(fieldElem,value)) return fieldElem;
		 *  if (fieldName != null)
		 *  fieldElem.setAttribute(ATTR_VALUETYPE, value.getClass().getName());
		 *  /        fieldElem.setAttribute("valueType", getTypeName(valueType));
		 *  /        fieldElem.setAttribute("fieldType", getTypeName(fieldType));
		 *  fieldElem.appendChild(text);
		 *  return fieldElem;
		 */
	}

	/**
	 *  Description of the Method
	 *
	 *@param  valueClass  Description of the Parameter
	 *@param  elem        Description of the Parameter
	 *@return             Description of the Return Value
	 */
	private Object createOBJText(Class valueClass, Element elem) {
		Object obj = null;
		String value = null;
		try {
			if (valueClass == Boolean.class) {
				obj = new Boolean(createTEXTString(elem));
			} else if (valueClass == Byte.class) {
				obj = new Byte(createTEXTString(elem));
			} else if (valueClass == Short.class) {
				obj = new Short(createTEXTString(elem));
			} else if (valueClass == Integer.class) {
				obj = new Integer(createTEXTString(elem));
			} else if (valueClass == Long.class) {
				obj = new Long(createTEXTString(elem));
			} else if (valueClass == Double.class) {
				obj = new Double(createTEXTString(elem));
			} else if (valueClass == Character.class) {
				if (USE_CDATA_SECTION) {
					value = createTEXTString(elem);
				} else {
					value = fromvalidXML(createTEXTString(elem));
				}
				if (value.length() > 1) {
					UserMessages.error("ERROR: String too long for Character");
				} else {
					obj = new Character(value.charAt(0));
				}
			} else if (valueClass == String.class) {
				value = createTEXTString(elem);
				if (USE_CDATA_SECTION || value == null) {
					obj = value;
				} else {
					obj = fromvalidXML(value);
				}
			} else if (valueClass.isArray()) {
				valueClass = valueClass.getComponentType();
				if (valueClass == byte.class) {
					value = createTEXTString(elem);
					long timing = System.currentTimeMillis();
					obj = decoder.decodeBuffer(value);
					timing = System.currentTimeMillis() - timing;
					if (TIMING > 1) {
						logger.info(
							"TIMING[2]: BASE64 decoding in "
								+ timing
								+ " milliseconds");
					}
				} else if (valueClass == Byte.class) {
					value = createTEXTString(elem);
					byte[] valbyte = decoder.decodeBuffer(value);

					Byte val[] = new Byte[valbyte.length];
					for (int i = 0; i < valbyte.length; i++) {
						val[i] = new Byte(valbyte[i]);
					}
					obj = val;
				}
			}
		} catch (Exception e) {
			UserMessages.error(e.toString());
			logger.log(Level.SEVERE, "", e);
		}

		if (obj != null) {
			Attr idAttr = elem.getAttributeNode(ATTR_ID);
			// idAttr==null if used outside of the normal XML serialization (no hash entry needed)
			if (idAttr != null) {
				Integer id = new Integer(idAttr.getNodeValue());
				if (!newHashed(id, obj)) {
					return obj;
				}
			}
		}

		return obj;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	private Vector createOBJVector(Class objClass, Element elem)
		throws IOException {
		int size = (new Integer(elem.getAttribute(ATTR_SIZE))).intValue();
		Vector vec = new Vector(size);

		boolean isSuperClass = false;
		createOBJVector(vec, objClass, elem, isSuperClass);

		return vec;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  vec              Description of the Parameter
	 *@param  objClass         Description of the Parameter
	 *@param  elem             Description of the Parameter
	 *@param  isSuperClass     Description of the Parameter
	 *@exception  IOException  Description of the Exception
	 */
	private void createOBJVector(
		Vector vec,
		Class objClass,
		Element elem,
		boolean isSuperClass)
		throws IOException {
		int size = (new Integer(elem.getAttribute(ATTR_SIZE))).intValue();

		// hash new object
		Attr idAttr = elem.getAttributeNode(ATTR_ID);
		if (!isSuperClass) {
			Integer id = new Integer(idAttr.getNodeValue());
			if (!newHashed(id, vec)) {
				return;
			}
		}

		NodeList list = elem.getChildNodes();
		int iVec = 0;
		for (int i = 0; i < list.getLength(); i++) {
			Node listi = list.item(i);
			if (listi.getNodeType() == Node.ELEMENT_NODE) {
				Element elemi = (Element) listi;
				if (iVec
					!= (new Integer(elemi.getAttribute(ATTR_INDEX))).intValue()) {
					logger.severe(
						"ERROR: " + "iVec!=elemIndex" + "in createOBJVector");
				}
				vec.add(iVec, createOBJElement(elemi));
				iVec++;
			} else if (listi.getNodeType() == Node.COMMENT_NODE) {
				//System.out.println(indent+"------------- COMMENT_NODE: "+listi.getNodeValue());
				continue;
			} else if (listi.getNodeType() == Node.TEXT_NODE) {
				String value = listi.getNodeValue();
				if (value.startsWith("\n") && value.trim().length() == 0) {
					continue;
				}
				logger.severe("ERROR: Node.TEXT_NODE in createOBJVector");
			} else {
				logger.severe(
					"ERROR: Node."
						+ listi.getNodeType()
						+ "_NODE in createOBJVector");
			}
		}

		if (iVec != size) {
			logger.severe("ERROR: iVec != size");
		}
	}

	/**
	 *  Description of the Method
	 *
	 *@param  elem  Description of the Parameter
	 *@return       Description of the Return Value
	 */
	private String createTEXTString(Element elem) {
		String returnValue = null;

		NodeList list = elem.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			Node listi = list.item(i);
			if (listi.getNodeType() == Node.ELEMENT_NODE) {
				UserMessages.error("ERROR: ELEMENT_NODE in getTEXTValue");
			} else if (listi.getNodeType() == Node.COMMENT_NODE) {
				//System.out.println(indent+"------------- COMMENT_NODE: "+listi.getNodeValue());
			} else if (listi.getNodeType() == Node.TEXT_NODE) {
				String value = listi.getNodeValue();
				if (!value.startsWith("\n") || value.trim().length() > 0) {
					returnValue = value;
					debug.println(" TEXT_NODE \"" + value + "\"");
				}
			} else if (listi.getNodeType() == Node.CDATA_SECTION_NODE) {
				returnValue = listi.getNodeValue();
				debug.println(" CDATA_SECTION_NODE \"" + returnValue + "\"");
			} else {
				debug.println(0, " UNKNOWN: " + listi.getNodeType());
				UserMessages.error("UNKNOWN: " + listi.getNodeType());
			}
		}

		if (returnValue == null) {
			if (elem.hasChildNodes()) {
				UserMessages.warning("WARNING: no TEXT value found");
			}
			returnValue = new String();
		}
		return returnValue;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  hashcode  Description of the Parameter
	 *@param  obj       Description of the Parameter
	 *@return           Description of the Return Value
	 */
	private boolean newHashed(Integer hashcode, Object obj) {
		if (objTable.containsKey(hashcode)) {
			HashObject prev = (HashObject) objTable.get(hashcode);
			if (obj == prev.obj) {
				debug.println(2, " IDREF=" + prev.objID);
				debug.println(
					2,
					"WARNING: Object already written: " + hashcode);
			} else {
				logger.severe(
					"ERROR in XMLObjectWriter: identical hashCode for distinct objects!!!");
			}
			return false;
		} else {
			objTable.put(hashcode, new HashObject(obj, hashcode.intValue()));
			debug.println(2, " ID=" + hashcode);
			return true;
		}
	}

	//------------------------------------------------------------------
	/**
	 *  read an object
	 *
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	public synchronized Object readObjectXML() throws IOException {
		Object obj = null;
		Object objBinary = null;
		Element elemObj = null;
		Element elemObjBin = null;

		long timing = System.currentTimeMillis();

		// Reset hash table for objects and object ID counter
		objTable.clear();

		try {
			if (in != null) {
				doc = builder.parse(in);
			} else if (reader != null) {
				doc = builder.parse(new InputSource(reader));
			} else {
				throw new Exception("ERROR in XMLObjectReader; neither InputStream nor Reader specified");
			}
		} catch (Exception e) {
			logger.log(Level.SEVERE, "", e);
		}
		//DomEcho04 domtree0 = new DomEcho04(doc);

		long timeparse = System.currentTimeMillis();
		if (TIMING > 1) {
			logger.info(
				"TIMING[2]: XML file parsed in "
					+ (timeparse - timing)
					+ " milliseconds");
		}
		/*
		 *  StreamSource source = null;
		 *  try {
		 *  if (in != null) {
		 *  source = new StreamSource(in);
		 *  } else if (reader != null) {
		 *  source = new StreamSource(reader);
		 *  } else {
		 *  throw new Exception("ERROR in XMLObjectReader; neither InputStream nor Reader specified");
		 *  }
		 *  } catch (Exception e) {
		 *  logger.log(Level.SEVERE, "", e);
		 *  }
		 */
		DOMResult domresult = new DOMResult();
		DOMSource domsource = new DOMSource(doc.getDocumentElement());

		try {
			Transformer transformer = tFactory.newTransformer();

			String filename =
				ResourceManager.getJarDirectory()
					+ File.separator
					+ "whitespace.xsl";
			debug.println(
				2,
				"Using " + filename + " to remove CRLF in XML files");
			File fileCRLF = new File(filename);
			if (!fileCRLF.canRead()) {
				throw new TransformerConfigurationException(
					"Cannot read " + fileCRLF.getName());
			}
			StreamSource stylesource = new StreamSource(fileCRLF);
			transformer = tFactory.newTransformer(stylesource);
			//transformer = tFactory.newTransformer();
			//transformer.setOutputProperty(javax.xml.transform.OutputKeys.INDENT,"no");
			transformer.transform(domsource, domresult);
			//System.out.println(transformer.getOutputProperties());

			if (DEBUG >= 3) {
				DOMSource srcdebug = new DOMSource(domresult.getNode());
				StreamResult resdebug =
					new StreamResult(new File("tttread.xml"));
				Transformer transdebug = tFactory.newTransformer();
				transdebug.transform(srcdebug, resdebug);
				//System.out.println(transdebug.getOutputProperties());
			}

		} catch (TransformerConfigurationException tce) {
			// Error generated by the parser
			logger.severe("\n** Transformer Factory error");
			logger.severe("   " + tce.getMessage());

			// Use the contained exception, if any
			Throwable x = tce;
			if (tce.getException() != null) {
				x = tce.getException();
			}
			logger.log(Level.SEVERE, "", x);

			// indicates failed transformation
			domresult = null;

		} catch (TransformerException te) {
			// Error generated by the parser
			logger.severe("\n** Transformation error");
			logger.severe("   " + te.getMessage());

			// Use the contained exception, if any
			Throwable x = te;
			if (te.getException() != null) {
				x = te.getException();
			}
			logger.log(Level.SEVERE, "", x);
			// indicates failed transformation
			domresult = null;

		} catch (Exception e) {
			logger.log(Level.SEVERE, "", e);
			// indicates failed transformation
			domresult = null;
		}

		long timewhite = System.currentTimeMillis();
		if (TIMING > 1) {
			logger.info(
				"TIMING[2]: XML transformed in "
					+ (timewhite - timeparse)
					+ " milliseconds");
		}

		if (domresult != null) {
			// change to new document if transformation was successful
			doc = (Document) domresult.getNode();
		}
		Element root = doc.getDocumentElement();
		if (root.getTagName().equals(TAG_UNICORE)) {

			NodeList list = root.getChildNodes();
			for (int i = 0; i < list.getLength(); i++) {
				Node listi = list.item(i);
				if (listi.getNodeType() == Node.ELEMENT_NODE) {
					if (listi.getNodeName().startsWith(TAG_BINARY)) {
						elemObjBin = (Element) listi;
					} else {
						elemObj = (Element) listi;
					}
				}
			}

			long checksum =
				Long.valueOf(root.getAttribute(ATTR_CHECKSUM)).longValue();
			long checknew = getCheckSum(elemObj);
			if (checknew != checksum) {
				if (DEBUG >= 2) {
					debug.println(
						2,
						"CHECKSUM stored: "
							+ checksum
							+ " CHECKSUM calculated:  "
							+ checknew);
					UserMessages.warning(res.getString("JOB_MODIFIED"));
				}
			}

		} else {
			UserMessages.warning(res.getString("XML_FORMAT_0"));
			elemObj = root;
		}
		//DomEcho04 domtree = new DomEcho04(doc);

		try {
			debug.println("\n\nSTARTING DOM INPUT of " + root + "\nSTARTED");

			obj = createOBJElement(elemObj);

			debug.println("FINISHED new DOM INPUT of " + root);
		} catch (Exception e) {
			// throw new IOException("error: "+ e);
			logger.log(Level.SEVERE, "error: ", e);
		}

		long timecreate = System.currentTimeMillis();
		if (TIMING > 1) {
			logger.info(
				"TIMING[2]: XML object creation in "
					+ (timecreate - timewhite)
					+ " milliseconds");
		}

		timing = System.currentTimeMillis() - timing;
		if (TIMING > 0) {
			logger.info(
				"TIMING[1]: XML format read in " + timing + " milliseconds");
		}

		if (DEBUG >= 3 && elemObjBin != null) {
			try {
				byte[] bytes = new byte[0];
				bytes = (byte[]) createOBJText(bytes.getClass(), elemObjBin);
				if (bytes != null) {
					PluginObjectInputStream ois = null;
					try {
						ois =
							new PluginObjectInputStream(
								new ByteArrayInputStream(bytes),
								Client.getPluginManager());
						objBinary = ois.readObject();
						ois.close();
					}
					// this might be a ClassNotFoundException when we tried to load a
					// plugin task that is not available
					catch (ClassNotFoundException cnfe) {
						UserMessages.error(
							res.getString("PLUGIN_NOT_AVAILABLE") + cnfe);
						return null;
					} catch (InvalidClassException cnfe) {
						logger.log(Level.SEVERE, "", cnfe);
						UserMessages.error(res.getString("INCOMPATIBLE_JOB"));
						return null;
					} catch (Exception e) {
						// display complete exception in dialog
						UserMessages.error(
							res.getString("ERROR_READING_JOB") + e);
						return null;
					}
				}
			} catch (Exception e) {
				UserMessages.error(e.toString());
				logger.log(Level.SEVERE, "", e);
			}
		}

		// Reset hash table for objects and object ID counter
		objTable.clear();

		return obj;
	}

	//------------------------------------------------------------------
	/**
	 *  read a binary object from the XML file
	 *
	 *@return                  Description of the Return Value
	 *@exception  IOException  Description of the Exception
	 */
	public synchronized Object readObjectXMLbinary() throws IOException {
		if (DEBUG < 3) {
			return null;
		}

		Object objBinary = null;
		Element elemObjBin = null;

		long timing = System.currentTimeMillis();

		try {
			if (in != null) {
				doc = builder.parse(in);
			} else if (reader != null) {
				doc = builder.parse(new InputSource(reader));
			} else {
				throw new Exception("ERROR in XMLObjectReader; neither InputStream nor Reader specified");
			}
		} catch (Exception e) {
			logger.log(Level.SEVERE, "", e);
		}

		Element root = doc.getDocumentElement();
		if (root.getTagName().equals(TAG_UNICORE)) {

			NodeList list = root.getChildNodes();
			for (int i = 0; i < list.getLength(); i++) {
				Node listi = list.item(i);
				if (listi.getNodeType() == Node.ELEMENT_NODE) {
					if (listi.getNodeName().startsWith(TAG_BINARY)) {
						elemObjBin = (Element) listi;
						break;
					}
				}
			}
			if (elemObjBin == null) {
				UserMessages.error("No binary object found in XML file");
			}

		} else {
			UserMessages.error(
				"Loaded old XML format,\nno binary object available in XML file");
		}

		if (elemObjBin != null) {
			try {
				byte[] bytes = new byte[0];
				bytes = (byte[]) createOBJText(bytes.getClass(), elemObjBin);
				if (bytes != null) {
					PluginObjectInputStream ois = null;
					try {
						ois =
							new PluginObjectInputStream(
								new ByteArrayInputStream(bytes),
								Client.getPluginManager());
						objBinary = ois.readObject();
						ois.close();
					}
					// this might be a ClassNotFoundException when we tried to load a
					// plugin task that is not available
					catch (ClassNotFoundException cnfe) {
						UserMessages.error(
							res.getString("PLUGIN_NOT_AVAILABLE") + cnfe);
						return null;
					} catch (InvalidClassException cnfe) {
						logger.log(Level.SEVERE, "", cnfe);
						UserMessages.error(res.getString("INCOMPATIBLE_JOB"));
						return null;
					} catch (Exception e) {
						// display complete exception in dialog
						UserMessages.error(
							res.getString("ERROR_READING_JOB") + e);
						return null;
					}
				}
			} catch (Exception e) {
				UserMessages.error(e.toString());
				logger.log(Level.SEVERE, "", e);
			}
		}

		timing = System.currentTimeMillis() - timing;
		if (TIMING > 2) {
			logger.info(
				"TIMING[2]: binary object read from XML file in "
					+ timing
					+ " milliseconds");
		}

		return objBinary;
	}

	/**
	 *  Pipe object read from XML through JOS to get corrections performed by readObject() methods
	 *
	 *@param  obj              Description of the Parameter
	 *@exception  IOException  Description of the Exception
	 */
	private Object reserializeJOS(Object obj) {
		Object new_obj = null;

		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			ObjectOutputStream oos = new ObjectOutputStream(baos);
			oos.writeObject(obj);

			ByteArrayInputStream bais =
				new ByteArrayInputStream(baos.toByteArray());
			ObjectInputStream ois = new ObjectInputStream(bais);

			new_obj = ois.readObject();
		} catch (IOException ioe) {
			logger.log(Level.SEVERE, "", ioe);
		} catch (ClassNotFoundException cnfe) {
			logger.log(Level.SEVERE, "", cnfe);
		}

		return new_obj;
	}

	//------------------------------------------------------------------
	/**
	 *  Scan over fields of class including all classes of superclasses Generate
	 *  serialized XML from the fields
	 *
	 *@param  elem           the current XML element where to add the fields (in
	 *      XML)
	 *@param  obj            the object to be serialized to XML
	 *@param  objClass       Description of the Parameter
	 *@exception  Exception  Description of the Exception
	 */
	private void scanFields(Element elem, Object obj, Class objClass)
		throws Exception {

		// Return if top of class chain reached
		if (objClass == null || objClass == Object.class) {
			return;
		}

		// get XMLObjectClass which holds the fields of the current class

		XMLObjectClass xmlClass = XMLObjectClass.getClassXML(objClass);

		NodeList list = elem.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			Node listi = list.item(i);

			if (listi.getNodeType() == Node.ELEMENT_NODE) {

				String fieldXMLName = listi.getNodeName();
				if (!listi.hasChildNodes()) {
					if (fieldXMLName.endsWith(NULL_INDICATOR)) {
						debug.println("<" + listi.getNodeName());
						continue;
					}
				}

				if (fieldXMLName.equals("java.util.Hashtable")) {
					boolean isSuperClass = true;
					createOBJHashtable(
						(Hashtable) obj,
						objClass,
						(Element) listi,
						isSuperClass);
					continue;
				}

				// Object has to be created anyway to resolve objects in the corresponding sub-tree
				Object value = createOBJElement((Element) listi);

				Field field = xmlClass.getField(fieldXMLName);
				if (field != null) {
					try {
						field.set(obj, value);
					} catch (Exception e) {
						logger.log(
							Level.SEVERE,
							"ERROR: field "
								+ field.getDeclaringClass()
								+ "."
								+ field.getName(),
							e);
					}
				}

			} else if (listi.getNodeType() == Node.COMMENT_NODE) {
				//System.out.println(indent+"------------- COMMENT_NODE: "+listi.getNodeValue());
			} else if (listi.getNodeType() == Node.TEXT_NODE) {
				String value = listi.getNodeValue();
				if (!value.startsWith("\n") || value.trim().length() > 0) {
					if (DEBUG >= 2) {
						UserMessages.error(
							"ERROR: Node.TEXT_NODE in scanFields");
						debug.println(2, "ERROR: Node.TEXT_NODE in scanFields");
					}
				}
			} else {
				UserMessages.error(
					"ERROR: Node."
						+ listi.getNodeType()
						+ "_NODE in scanFields");
			}
		}
	}
}
