package com.pallas.unicore.container;

import org.unicore.ajo.LinkMapLevel;
import org.unicore.ajo.ListingLevel;
import org.unicore.ajo.OptimisationLevel;
import org.unicore.ajo.Portfolio;
import org.unicore.sets.PortfolioList;

/**
 *  Container needed to import and execute a command on a vsite.
 *
 *@author     Thomas Kentemich
 *@created    August 16, 2001
 *@version    $Id: CompileContainer.java,v 1.2 2003/06/30 06:57:25 rrate Exp $
 */

public abstract class CompileContainer extends ExecuteContainer {

	// field definitions for storing the container in XML format
	private static String[][] persistentXMLFields = {
	};
	final static long serialVersionUID = 6730072481112939306L;
	/**
	 *  Description of the Field
	 */
	protected boolean compileForDebug;
	/**
	 *  Description of the Field
	 */
	protected boolean compileForProfiling;
	/**
	 *  Description of the Field
	 */
	protected String[] includes;
	/**
	 *  Description of the Field
	 */
	protected PortfolioList libraries;
	/**
	 *  Description of the Field
	 */
	protected boolean linkForDebug;
	/**
	 *  Description of the Field
	 */
	protected boolean linkForProfile;
	/**
	 *  Description of the Field
	 */
	protected LinkMapLevel linkmapLevel;
	/**
	 *  Description of the Field
	 */
	protected ListingLevel listingLevel;
	/**
	 *  Description of the Field
	 */
	protected Portfolio listings;

	/**
	 *  Description of the Field
	 */
	protected Portfolio objectPortfolio;
	/**
	 *  Description of the Field
	 */
	protected PortfolioList objects;
	/**
	 *  Description of the Field
	 */
	protected OptimisationLevel optimLevel;

	/**
	 *  Description of the Field
	 */
	protected boolean redirectStdin;

	/**
	 *  Description of the Field
	 */
	protected String[] sources;
	/**
	 *  Description of the Field
	 */
	protected String stdinPath;

	/**
	 *  Constructors
	 *
	 *@param  parentContainer  Description of Parameter
	 */
	public CompileContainer(GroupContainer parentContainer) {
		super(parentContainer);
	}

	/**
	 *  Gets the CompileForDebug attribute of the CompileContainer object
	 *
	 *@return    The CompileForDebug value
	 */
	public boolean getCompileForDebug() {
		return compileForDebug;
	}

	/**
	 *  Gets the CompileForProfiling attribute of the CompileContainer object
	 *
	 *@return    The CompileForProfiling value
	 */
	public boolean getCompileForProfiling() {
		return compileForProfiling;
	}

	/**
	 *  Gets the Includes attribute of the CompileContainer object
	 *
	 *@return    The Includes value
	 */
	public String[] getIncludes() {
		return includes;
	}

	/**
	 *  Gets the Objects attribute of the CompileContainer object
	 *
	 *@return    The Objects value
	 */
	public PortfolioList getLibraries() {
		return libraries;
	}

	/**
	 *  Gets the LinkForDebug attribute of the CompileContainer object
	 *
	 *@return    The LinkForDebug value
	 */
	public boolean getLinkForDebug() {
		return linkForDebug;
	}

	/**
	 *  Gets the LinkForProfiling attribute of the CompileContainer object
	 *
	 *@return    The LinkForProfiling value
	 */
	public boolean getLinkForProfiling() {
		return linkForProfile;
	}

	/**
	 *  Gets the LinkMapLevel attribute of the CompileContainer object
	 *
	 *@return    The LinkMapLevel value
	 */
	public LinkMapLevel getLinkMapLevel() {
		return linkmapLevel;
	}

	/**
	 *  Gets the ListingLevel attribute of the CompileContainer object
	 *
	 *@return    The ListingLevel value
	 */
	public ListingLevel getListingLevel() {
		return listingLevel;
	}

	/**
	 *  Gets the Listings attribute of the CompileContainer object
	 *
	 *@return    The Listings value
	 */
	public Portfolio getListings() {
		return listings;
	}

	/**
	 *  Gets the portfolio containing the objects generated by the CompileTask
	 *
	 *@return    The Objects value
	 */
	public Portfolio getObjectPortfolio() {
		return objectPortfolio;
	}

	/**
	 *  Gets the Objects attribute of the CompileContainer object
	 *
	 *@return    The Objects value
	 */
	public PortfolioList getObjects() {
		return objects;
	}

	/**
	 *  Gets the OptimisationLevel attribute of the CompileContainer object
	 *
	 *@return    The OptimisationLevel value
	 */
	public OptimisationLevel getOptimisationLevel() {
		return optimLevel;
	}

	/**
	 *  Gets the RedirectStdin attribute of the CompileContainer object
	 *
	 *@return    The RedirectStdin value
	 */
	public boolean getRedirectStdin() {
		return redirectStdin;
	}

	/**
	 *  Gets the Sources attribute of the CompileContainer object
	 *
	 *@return    The Sources value
	 */
	public String[] getSources() {
		return sources;
	}

	/**
	 *  Gets the Stdin attribute of the CompileContainer object
	 *
	 *@return    The Stdin value
	 */
	public String getStdin() {
		return stdinPath;
	}

	/**
	 *  Sets the CompileForDebug attribute of the CompileContainer object
	 *
	 *@param  debug  The new CompileForDebug value
	 */
	public void setCompileForDebug(boolean debug) {
		this.compileForDebug = debug;
	}

	/**
	 *  Sets the CompileForProfile attribute of the CompileContainer object
	 *
	 *@param  profiling  The new CompileForProfile value
	 */
	public void setCompileForProfile(boolean profiling) {
		this.compileForProfiling = profiling;
	}

	/**
	 *  Sets the Includes attribute of the CompileContainer object
	 *
	 *@param  includes  The new Includes value
	 */
	public void setIncludes(String[] includes) {
		this.includes = includes;
	}

	/**
	 *  Sets the Objects attribute of the CompileContainer object
	 *
	 *@param  libraries  The new Libraries value
	 */
	public void setLibraries(PortfolioList libraries) {
		this.libraries = libraries;
	}

	/**
	 *  Sets the LinkForDebug attribute of the CompileContainer object
	 *
	 *@param  debug  The new LinkForDebug value
	 */
	public void setLinkForDebug(boolean debug) {
		this.linkForDebug = debug;
	}

	/**
	 *  Sets the LinkForProfile attribute of the CompileContainer object
	 *
	 *@param  profiling  The new LinkForProfile value
	 */
	public void setLinkForProfile(boolean profiling) {
		this.linkForProfile = profiling;
	}

	/**
	 *  Sets the LinkMapLevel attribute of the CompileContainer object
	 *
	 *@param  linkmapLevel  The new LinkMapLevel value
	 */
	public void setLinkMapLevel(LinkMapLevel linkmapLevel) {
		this.linkmapLevel = linkmapLevel;
	}

	/**
	 *  Sets the ListingLevel attribute of the CompileContainer object
	 *
	 *@param  level  The new ListingLevel value
	 */
	public void setListingLevel(ListingLevel level) {
		this.listingLevel = level;
	}

	/**
	 *  Sets the Listings attribute of the CompileContainer object
	 *
	 *@param  listings  The new Listings value
	 */
	public void setListings(Portfolio listings) {
		this.listings = listings;
	}

	/**
	 *  Sets the Objects attribute of the CompileContainer object
	 *
	 *@param  objects  The new Objects value
	 */
	public void setObjects(PortfolioList objects) {
		this.objects = objects;
	}

	/**
	 *  Sets the portfolio returned by the CompileTask, containing the object files
	 *  generated
	 *
	 *@param  objectPortfolio  The new ObjectsPortfolio value
	 */
	public void setObjectsPortfolio(Portfolio objectPortfolio) {
		this.objectPortfolio = objectPortfolio;
	}

	/**
	 *  Sets the OptimisationLevel attribute of the CompileContainer object
	 *
	 *@param  optimLevel  The new OptimisationLevel value
	 */
	public void setOptimisationLevel(OptimisationLevel optimLevel) {
		this.optimLevel = optimLevel;
	}

	/**
	 *  Sets the RedirectStdin attribute of the CompileContainer object
	 *
	 *@param  what  The new RedirectStdin value
	 */
	public void setRedirectStdin(boolean what) {
		this.redirectStdin = what;
	}

	/**
	 *  Sets the Sources attribute of the CompileContainer object
	 *
	 *@param  sources  The new Sources value
	 */
	public void setSources(String[] sources) {
		this.sources = sources;
	}

	/**
	 *  Sets the Stdin attribute of the CompileContainer object
	 *
	 *@param  stdin  The new Stdin value
	 */
	public void setStdin(String stdin) {
		this.stdinPath = stdin;
	}

}
