package com.pallas.unicore.container;

/**
 *  Strings for container classes
 *
 *@author     Ralf Ratering
 *@created    27. September 2001
 *@version    $Id: ResourceStrings.java,v 1.4 2003/07/09 08:55:21 rrate Exp $
 */
public class ResourceStrings extends java.util.ListResourceBundle {
	final static Object[][] contents =
		new String[][] {
			{
				"LOCAL_MKDIR",
				"Cannot create local directory from job on virtual site." },
			{
			"NO_RESOURCES", "No resources were set." }, {
			"NO_VSITE", "Missing destination virtual site for task." }, {
			"CANNOT_LOAD", "Cannot load default resources from " }, {
			"REQUESTED", "Requested " }, {
			"STORAGE", "Storage location " }, {
			"NOT_AVAILABLE", " not available at site " }, {
			"MULTIPLE_PRIORITIES", "Found more than one Priority: " }, {
			"LOCAL_FILE", "Local file <" }, {
			"INCOMPLETE_FILE_IMPORT", "Incomplete file import <" }, {
			"INCOMPLETE_FILE_EXPORT", "Incomplete file export <" }, {
			"INCOMPLETE_FILE_OPERATION", "Incomplete file operation <" }, {
			"INCOMPLETE_FILE_TRANSFER", "Incomplete file transfer <" }, {
			"AT_ROW", "> at row " }, {
			"FOR_IMPORT", "> for import to job directory does not exist" }, {
			"FOR_IMPORT_OF", "> for import of file <" }, {
			"EXPORT_FROM_DIR_TO_FILE",
				"Export from directory to existing file " },
				{
			"ALREADY_EXISTS", "> already exists." }, {
			"USPACE_NAME", "Name in job directory <" }, {
			"NO_IMPORTS", "No operation was selected for import task." }, {
			"NO_EXPORTS", "No operation was selected for export task." }, {
			"NO_OPERATIONS",
				"No operation was selected for file system operation task." },
				{
			"NO_TRANSFERS", "No operation was selected for transfer task." }, {
			"DESTJOB_MISSING", "Destination job group does not exist: " }, {
			"NO_USITE", "Missing entry for UNICORE Site." }, {
			"CANNOT_LOAD_VSITES", "Unable to load virtual sites from " }, {
			"NO_VSITE_ENTRY", "Missing entry for virtual site." }, {
			"EMPTY_GROUP", "No tasks have been added to group." }, {
			"NO_EMAIL_ENTRY", "Missing entry for email." }, {
			"SUBMIT_FAILED", "Submitting job failed!" }, {
			"RESOLVED_MULTIPLE",
				"Resolved multiple priorities in resource request!\nSave job to avoid "
					+ "future problems." },
				{
			"NOT_INTEGER",
				"The value in the following field must be an integer value: " },
				{
			"MANDATORY",
				"The value in the following field is an mandatory value: " },
				{
			"NOT_CORRECT",
				"The value in the following field is not correct, it must be between " }
	};

	/**
	 *  Gets the Contents attribute of the ResourceStrings object
	 *
	 *@return    The Contents value
	 */
	public Object[][] getContents() {
		return contents;
	}
}
