package com.pallas.unicore.container.errorspec;

import java.util.NoSuchElementException;

/**
 *  An interface to a type-safe Enumeration type for <tt>UError</tt> s.
 *
 *@author     Michel Drescher, pallas GmbH
 *@created    17. September 2001
 *@version    $Id: ErrorSetEnumeration.java,v 1.2 2003/06/30 07:00:20 rrate Exp $
 */
public class ErrorSetEnumeration {
	int count;

	ErrorSet errorSet;

	/**
	 *  Constructor for the ErrorSetEnumeration object
	 *
	 *@param  set  Description of Parameter
	 */
	public ErrorSetEnumeration(ErrorSet set) {
		errorSet = set;
		count = 0;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public boolean hasMoreElements() {
		return count < errorSet.getSize();
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public UError nextElement() {
		synchronized (errorSet) {
			if (count < errorSet.getSize()) {
				return (UError) errorSet.getAt(count++);
			}
		}
		throw new NoSuchElementException("ErrorSetEnumeration");
	}

}
