package com.pallas.unicore.container.errorspec;

import org.unicore.Identifier;

/**
 *  Class describing UNICOREpro errors by task name and error string.
 *
 *@author     Ralf Ratering
 *@created    17. September 2001
 *@version    $Id: UError.java,v 1.3 2003/06/30 07:00:20 rrate Exp $
 */
public class UError {

	// error string to be displayed
	private String errorString;

	/**
	 *  Constructor
	 *
	 *@param  taskId        Identifier for error task
	 *@param  errorMessage  String that describes error
	 */
	public UError(Identifier taskId, String errorMessage) {
		String taskName;
		if (taskId == null
			|| taskId.getName() == null
			|| taskId.getName().equals("")) {
			taskName = "Unknown task";
		} else {
			taskName = taskId.getName();
		}

		if (errorMessage == null || errorMessage.equals("")) {
			errorMessage = "Unknown error";
		}

		errorString = taskName + ": " + errorMessage;
	}

	/**
	 *  The toString method generates a String that informs the user about what went wrong in a certain
	 *  task
	 *
	 *@return    error string
	 */
	public String toString() {
		return errorString;
	}
}
