package com.pallas.unicore.extensions;

import java.io.Serializable;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.pallas.unicore.container.ActionContainer;
import com.pallas.unicore.container.errorspec.ErrorSet;

/**
 *@author     Ralf Ratering
 *@created    17. Juli 2002
 *@version    $Id: AbstractTest.java,v 1.2 2003/06/30 06:58:23 rrate Exp $
 */

public abstract class AbstractTest implements Serializable, Cloneable {

	/**
	 *  Description of the Field
	 */
	public final static TestType DISABLED = new TestType(TestType.DISABLED);
	/**
	 *  Description of the Field
	 */
	protected static Logger logger =
		Logger.getLogger("com.pallas.unicore.extensions");

	final static long serialVersionUID = -5723566594933932785L;

	/**
	 *  Description of the Field
	 */
	protected TestType type = DISABLED;

	/**
	 *  Description of the Method
	 *
	 *@param  errorSet   Description of the Parameter
	 *@param  container  Description of the Parameter
	 *@return            Description of the Return Value
	 */
	public ErrorSet checkContents(
		ErrorSet errorSet,
		ActionContainer container) {
		return errorSet;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  object  Description of the Parameter
	 *@return         Description of the Return Value
	 */
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			logger.log(Level.SEVERE, "Cloning " + this +" failed.", e);
			return null;
		}
	}

	/**
	 *  Gets the value attribute of the FileTest object
	 *
	 *@return    The value value
	 */
	public TestType getType() {
		return type;
	}

	/**
	 *  Gets the enabled attribute of the AbstractTest object
	 *
	 *@return    The enabled value
	 */
	public boolean isEnabled() {
		return !type.equals(DISABLED);
	}

	/**
	 *  Sets the value attribute of the FileTest object
	 *
	 *@param  type  The new type value
	 */
	public void setType(TestType type) {
		this.type = type;
	}

}
