package com.pallas.unicore.extensions;

import java.util.Vector;
import java.util.logging.Logger;

import org.unicore.ajo.ActionGroup;

import com.pallas.unicore.container.TaskContainer;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *  Base class for file operation factories
 *
 *@author     Ralf Ratering
 *@created    5. September 2001
 *@version    $Id: FileOperationFactory.java,v 1.3 2003/06/30 06:58:21 rrate Exp $
 */
public class FileOperationFactory {
	/**
	 *  Description of the Field
	 */
	protected static Logger logger =
		Logger.getLogger("com.pallas.unicore.extensions");
	/**
	 *  Description of the Field
	 */
	protected ActionGroup actionGroup;
	/**
	 *  Description of the Field
	 */
	protected TaskContainer container;

	/**
	 *  Description of the Field
	 */
	protected Vector fileOps;

	/**
	 *  Constructor
	 *
	 *@param  fileOpsArray  Description of Parameter
	 *@param  actionGroup   Description of Parameter
	 *@param  container     Description of Parameter
	 */
	public FileOperationFactory(
		FileOperation[] fileOpsArray,
		ActionGroup actionGroup,
		TaskContainer container) {

		// put array into vector
		fileOps = new Vector();
		for (int i = 0; i < fileOpsArray.length; i++) {
			fileOps.add(fileOpsArray[i]);
		}
		this.actionGroup = actionGroup;
		this.container = container;
	}

	/**
	 *  Generate a unique task name (e.g. used in Import/Export factories)
	 *
	 *@param  declarative  Declarative part of the final name
	 *@return              A unique task name based on the container name, the
	 *      declarative input, and an internal counter
	 */
	protected String createActionName(String declarative) {
		return container.getName()
			+ "_"
			+ declarative
			+ "_"
			+ ResourceManager.getNextObjectIdentifier();
	}
}
