package com.pallas.unicore.extensions;

import java.util.Date;
import java.util.Vector;

import com.pallas.unicore.container.ActionContainer;
import com.pallas.unicore.container.errorspec.ErrorSet;

/**
 *@author     Ralf Ratering
 *@created    17. Juli 2002
 *@version    $Id: HoldJobTest.java,v 1.2 2003/06/30 06:58:18 rrate Exp $
 */

public class HoldJobTest extends AbstractTest {

	/**
	 *  Description of the Field
	 */
	public final static HoldJobTestType FOREVER =
		new HoldJobTestType(HoldJobTestType.FOREVER),
		UNTIL = new HoldJobTestType(HoldJobTestType.UNTIL);

	final static long serialVersionUID = -5802782047852301472L;

	private static Vector types;

	/**
	 *  Gets the types attribute of the FileTest class
	 *
	 *@return    The types value
	 */
	public static Vector getTypes() {
		if (types == null) {
			types = new Vector();
			types.add(DISABLED);
			types.add(FOREVER);
			types.add(UNTIL);
		}
		return types;
	}

	private Date date = new Date();

	private boolean useToday;

	/**
	 *  Constructor for the HoldJobTest object
	 */
	public HoldJobTest() {
		// intially set "wait until"
		this.type = UNTIL;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  errorSet   Description of the Parameter
	 *@param  container  Description of the Parameter
	 *@return            Description of the Return Value
	 */
	public ErrorSet checkContents(
		ErrorSet errorSet,
		ActionContainer container) {
		super.checkContents(errorSet, container);
		return errorSet;
	}

	/**
	 *  Gets the file attribute of the FileTest object
	 *
	 *@return    The file value
	 */
	public Date getDate() {
		return date;
	}

	/**
	 *  Gets the useToday attribute of the HoldJobTest object
	 *
	 *@return    The useToday value
	 */
	public boolean getUseToday() {
		return useToday;
	}

	/**
	 *  Sets the file attribute of the FileTest object
	 *
	 *@param  date  The new date value
	 */
	public void setDate(Date date) {
		this.date = date;
	}

	/**
	 *  Sets the useToday attribute of the HoldJobTest object
	 *
	 *@param  useToday  The new useToday value
	 */
	public void setUseToday(boolean useToday) {
		this.useToday = useToday;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		return "Wait " + type + " " + date;
	}

}
