package com.pallas.unicore.extensions;

/**
 *@author     Ralf Ratering
 *@created    17. Juli 2002
 *@version    $Id: ReturnCodeTestType.java,v 1.2 2003/06/30 06:58:16 rrate Exp $
 */

public class ReturnCodeTestType extends TestType {

	/**
	 *  Description of the Field
	 */
	public final static int EQUAL = 1,
		NOT_EQUAL = 2,
		GREATER = 3,
		LESS = 4,
		GREATER_OR_EQUAL = 5,
		LESS_OR_EQUAL = 6,
		SUCCESSFUL = 7,
		NOT_SUCCESSFUL = 8;

	final static long serialVersionUID = 8990223471661011489L;

	/**
	 *  Constructor for the FileTest object
	 *
	 *@param  value  Description of the Parameter
	 */
	public ReturnCodeTestType(int value) {
		super(value);
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		switch (value) {
			case 0 :
				return "disabled";
			case 1 :
				return "return code equals";
			case 2 :
				return "return code not equal";
			case 3 :
				return "return code greater";
			case 4 :
				return "return code less";
			case 5 :
				return "return code greater or equal";
			case 6 :
				return "return code less or equal";
			case 7 :
				return "successful";
			case 8 :
				return "not successful";
		}
		return "";
	}

}
