package com.pallas.unicore.extensions;

import java.io.Serializable;

/**
 *@author     Ralf Ratering
 *@created    17. Juli 2002
 *@version    $Id: TestType.java,v 1.2 2003/06/30 06:58:16 rrate Exp $
 */

public class TestType implements Serializable {

	/**
	 *  Description of the Field
	 */
	public final static int DISABLED = 0;

	final static long serialVersionUID = -8311768292345513144L;

	/**
	 *  Description of the Field
	 */
	protected int value = DISABLED;

	/**
	 *  Constructor for the FileTest object
	 *
	 *@param  value  Description of the Parameter
	 */
	public TestType(int value) {
		this.value = value;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  object  Description of the Parameter
	 *@return         Description of the Return Value
	 */
	public boolean equals(Object object) {
		if (object == null) {
			return false;
		}
		TestType type = (TestType) object;
		return type.getValue() == getValue();
	}

	/**
	 *  Gets the value attribute of the FileTest object
	 *
	 *@return    The value value
	 */
	public int getValue() {
		return value;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public int hashCode() {
		return getValue();
	}

	/**
	 *  Gets the enabled attribute of the TestType object
	 *
	 *@return    The enabled value
	 */
	public boolean isEnabled() {
		return value != DISABLED;
	}

	/**
	 *  Sets the value attribute of the FileTest object
	 *
	 *@param  value  The new value value
	 */
	public void setValue(int value) {
		this.value = value;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		return "disabled";
	}
}
