package com.pallas.unicore.extensions;

import java.util.Date;
import java.util.Vector;

import com.pallas.unicore.container.ActionContainer;
import com.pallas.unicore.container.errorspec.ErrorSet;

/**
 *@author     Ralf Ratering
 *@created    17. Juli 2002
 *@version    $Id: TimeTest.java,v 1.2 2003/06/30 06:58:15 rrate Exp $
 */

public class TimeTest extends AbstractTest {

	/**
	 *  Description of the Field
	 */
	public final static TimeTestType AFTER =
		new TimeTestType(TimeTestType.AFTER);

	final static long serialVersionUID = 48806018642675515L;

	private static Vector types;

	/**
	 *  Gets the types attribute of the FileTest class
	 *
	 *@return    The types value
	 */
	public static Vector getTypes() {
		if (types == null) {
			types = new Vector();
			types.add(DISABLED);
			types.add(AFTER);
		}
		return types;
	}

	private Date date = new Date();

	private boolean useToday;

	/**
	 *  Description of the Method
	 *
	 *@param  errorSet   Description of the Parameter
	 *@param  container  Description of the Parameter
	 *@return            Description of the Return Value
	 */
	public ErrorSet checkContents(
		ErrorSet errorSet,
		ActionContainer container) {
		super.checkContents(errorSet, container);
		return errorSet;
	}

	/**
	 *  Gets the file attribute of the FileTest object
	 *
	 *@return    The file value
	 */
	public Date getDate() {
		// prevent null date object when copying task from JMC,
		// that had a disabled time test.
		if (date == null) {
			date = new Date();
		}
		return date;
	}

	/**
	 *  Gets the useToday attribute of the TimeTest object
	 *
	 *@return    The useToday value
	 */
	public boolean getUseToday() {
		return useToday;
	}

	/**
	 *  Sets the file attribute of the FileTest object
	 *
	 *@param  date  The new date value
	 */
	public void setDate(Date date) {
		this.date = date;
	}

	/**
	 *  Sets the useToday attribute of the TimeTest object
	 *
	 *@param  useToday  The new useToday value
	 */
	public void setUseToday(boolean useToday) {
		this.useToday = useToday;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		return "Test if time is expired: " + date;
	}

}
