package com.pallas.unicore.requests;

import org.unicore.Vsite;

import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Ralf Ratering
 *@created    28. Mrz 2002
 *@version    $Id: GetResources.java,v 1.2 2003/06/30 06:57:59 rrate Exp $
 */

public class GetResources extends ObservableThread {

	private Vsite vsite;

	/**
	 *  Constructor for the AutoGetViste object
	 *
	 *@param  vsite  Description of the Parameter
	 */
	public GetResources(Vsite vsite) {
		this.vsite = vsite;
	}

	/**
	 *  Gets the vsite attribute of the GetResources object
	 *
	 *@return    The vsite value
	 */
	public Vsite getVsite() {
		return vsite;
	}

	/**
	 *  Description of the Method
	 */
	public void run() {
		logger.info("Detecting resources for vsite " + vsite.getName());

		ResourceManager.loadResources(vsite);
		notifyObservers(this, ResourceManager.getResourceSet(vsite));
	}
}
