package com.pallas.unicore.requests;

import com.pallas.unicore.extensions.Usite;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Ralf Ratering
 *@created    17. September 2001
 *@version    $Id: GetVsites.java,v 1.2 2003/06/30 06:57:58 rrate Exp $
 */
public class GetVsites extends ObservableThread {

	private Usite usite;

	/**
	 *  Constructor for the AutoGetViste object
	 *
	 *@param  usite  Description of Parameter
	 */
	public GetVsites(Usite usite) {
		this.usite = usite;
	}

	/**
	 *  Gets the usite attribute of the GetVsites object
	 *
	 *@return    The usite value
	 */
	public Usite getUsite() {
		return this.usite;
	}

	/**
	 *  Description of the Method
	 */
	public void run() {
		logger.info("Detecting vsites for usite " + usite.getName());
		ResourceManager.loadVsites(usite);
		notifyObservers(this, ResourceManager.getVsites(usite));
	}
}
