package com.pallas.unicore.requests;

import com.pallas.unicore.client.trees.PanelNode;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Ralf Ratering
 *@created    August 15, 2001
 *@version    $Id: ObservableNodeThread.java,v 1.2 2003/06/30 06:57:57 rrate Exp $
 */
public abstract class ObservableNodeThread extends ObservableRequestThread {
	private PanelNode node;
	/**
	 *  Description of the Field
	 */
	protected final String servicePrefix = ResourceManager.getServicePrefix();

	/**
	 *  Constructor for the ObservableNodeThread object
	 *
	 *@param  node  Description of the Parameter
	 */
	public ObservableNodeThread(PanelNode node) {
		this.node = node;
	}

	/**
	 *  Gets the node attribute of the ObservableNodeThread object
	 *
	 *@return    The node value
	 */
	public PanelNode getNode() {
		return node;
	}

	/**
	 *  Sets the node attribute of the ObservableNodeThread object
	 *
	 *@param  node  The new node value
	 */
	public void setNode(PanelNode node) {
		this.node = node;
	}

}
