package com.pallas.unicore.requests;

import java.util.logging.Logger;

import com.pallas.unicore.threadpool.GenericObservable;
import com.pallas.unicore.threadpool.IObservable;
import com.pallas.unicore.threadpool.IObserver;

/**
 *@author     Ralf Ratering
 *@created    August 15, 2001
 *@version    $Id: ObservableThread.java,v 1.4 2003/06/30 06:57:57 rrate Exp $
 */
public abstract class ObservableThread extends Thread implements IObservable {
	/**
	 *  Description of the Field
	 */
	protected static Logger logger =
		Logger.getLogger("com.pallas.unicore.requests");

	/**
	 *  Description of the Field
	 */
	protected GenericObservable theGenericObservable = new GenericObservable();

	/**
	 *  Adds a feature to the Observer attribute of the UpdateObject object
	 *
	 *@param  anObserver  The feature to be added to the Observer attribute
	 */
	public void addObserver(IObserver anObserver) {
		this.theGenericObservable.addObserver(anObserver);
	}

	/**
	 *  Description of the Method
	 */
	public void deleteAllObservers() {
		this.theGenericObservable.deleteAllObservers();
	}

	/**
	 *  Description of the Method
	 *
	 *@param  anObserver  Description of Parameter
	 */
	public void deleteObserver(IObserver anObserver) {
		this.theGenericObservable.deleteObserver(anObserver);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  theObserved  Description of Parameter
	 *@param  changeCode   Description of Parameter
	 */
	public void notifyObservers(Object theObserved, Object changeCode) {
		theGenericObservable.notifyObservers(theObserved, changeCode);
	}
}
