package com.pallas.unicore.requests;

import java.util.logging.Level;

import com.pallas.unicore.container.ActionContainer;
import com.pallas.unicore.container.JobContainer;

/**
 *@author     Thomas Kentemich
 *@author     Ralf Ratering
 *@created    August 15, 2001
 *@version    $Id: SubmitJob.java,v 1.3 2003/06/30 06:57:56 rrate Exp $
 */
public class SubmitJob extends ObservableThread {
	private JobContainer jobContainer;

	/**
	 *  Creates new SubmitJob
	 *
	 *@param  jobContainer  Description of the Parameter
	 */
	public SubmitJob(JobContainer jobContainer) {
		this.jobContainer = jobContainer;
	}

	/**
	 *  Description of the Method
	 */
	public void run() {
		try {
			if (jobContainer == null) {
				throw new Exception(
					"Submission of not existing job "
						+ jobContainer
						+ " failed.");
			}
			if (!jobContainer.isComplete()) {
				throw new Exception(
					"Cannot submit incorrect job: " + jobContainer);
			}

			jobContainer.setState(ActionContainer.STATE_SUBMITTING);
			jobContainer.run();
		} catch (Exception e) {
			logger.log(Level.SEVERE, "Error submitting job " + jobContainer, e);
		}
		jobContainer.setState(ActionContainer.STATE_SUBMITTED);

		// notify all my observers on task end
		notifyObservers(this, jobContainer);
	}

}
