package com.pallas.unicore.requests;

import java.util.logging.Level;

import com.pallas.unicore.container.ActionContainer;
import com.pallas.unicore.container.ServiceContainer;

/**
 *@author     Ralf Ratering
 *@created    17. Januar 2002
 *@version    $Id: SubmitServiceContainer.java,v 1.3 2003/06/30 06:57:55 rrate Exp $
 */
public class SubmitServiceContainer extends ObservableThread {

	private ServiceContainer container;

	/**
	 *  Constructor
	 *
	 *@param  container  Description of the Parameter
	 */
	public SubmitServiceContainer(ServiceContainer container) {
		this.container = container;
	}

	/**
	 *  Description of the Method
	 */
	public void run() {
		try {
			container.setState(ActionContainer.STATE_SUBMITTING);
			container.run();
			container.setState(ActionContainer.STATE_SUBMITTED);
		} catch (Exception e) {
			logger.log(
				Level.SEVERE,
				"Error submitting service container " + container,
				e);
		}
		// notify all my observers on task end
		notifyObservers(this, container);
	}

}
