package com.pallas.unicore.security;

import java.util.ListResourceBundle;

/**
 *  Strings for security classes
 *
 *@author     Ralf Ratering
 *@created    28. September 2001
 *@version $Id: ResourceStrings.java,v 1.2 2003/06/30 06:58:46 rrate Exp $
 */
public class ResourceStrings extends ListResourceBundle {
	final static Object[][] contents = new String[][]{
    	{"NO_PRIVATE", "Cannot extract private key."},
			{"CANT_LOAD", "Unable to load one or more certificate(s)."},
			{"NEW_KEYSTORE", "Generated new keystore:  \n"},
			{"CHECK_FAILED", "Keystore integrity check failed."},
			{"NO_KEYSTORE", "Keystore not found: "},
			{"CANT_OPEN", "Cannot open:"},
			{"K_CHECK_FAILED", "Keystore check failed:  "},
			{"CANT_SIGN", "Cannot sign AJO with user\'s private key!"},
			{"EMPTY_KS", "Empty keystore!"},
			{"NO_USER", "No user certificates found!"},
			{"NO_CA", "No CA certificates found!"},
			{"MISSING_KEYSTORE", "Invalid or missing keystore."},
			{"CERT_FOR", "Certificate for: "},
			{"EXPIRED", " is expired."},
			{"NOT_VALID", " is not yet valid."},
			{"WRONG_ALG", "Unsupported signature algorithm."},
			{"INVALID_PUBLIC", "Invalid public key."},
			{"NO_PROVIDER", "No default provider."},
			{"INVALID_SIGN", "Invalid signature (CA)."},
			{"INVALID_CERT", "Invalid certificate."},
			{"NO_VALID_USER", "No valid user certificates found!"},
			{"NO_VALID_CA", "No valid CA certificates found!"},
			{"INTEGRITY_FAILED", "KeyStore integrity check failed."},
			{"EMPTY_KEYSTORE", "Empty keystore."},
			{"BLANK", " "},
			{"CERTS_INVALID", "One or more certificates in the keystore are invalid!!"},
			{"MISSING_ALG", "Encryption algorithm(s) not available"},
			{"ALIAS", "Alias: "},
			{"NOT_IN_KS", " not found in keystore"},
			{"NO_NEW_KS", "Cannot generate new keystore."},
			{"CANT_STORE", "Cannot write keystore."},
			{"WRONG_TYPE", "Wrong keystore type selected."},
			{"UNKNOWN_FORMAT", "Unknown keystore format."},
			{"NO_USER_CERT", "User certificate not found"},
			{"CRL_OUTDATED", "CRL is outdated."},
			{"CRL_SIGNER", "Cannot verify CRL signer"},
			{"CRL_SIGNATURE", "Cannot verify CRL signature"},
			{"CRL_KEY", "Cannot obtain CRL signer\'s key"},
			{"BAD_CRL", "Invalid CRL"},
			{"INVALID_SIGNATURE", "Invalid signature."},
			{"NO_CLASSES", "Can\'t define sun/java classes"},
			{"EMPTY_KEYSTORE", "Empty keystore"},
			{"INVALID_KS", "Invalid keystore"}};


	/**
	 *  Gets the Contents attribute of the ResourceStrings object
	 *
	 *@return    The Contents value
	 */
	public Object[][] getContents() {
		return contents;
	}
}
