package com.pallas.unicore.threadpool;

import java.util.Enumeration;
import java.util.Vector;

/**
 *@author     Thomas Kentemich
 *@created    17. September 2001
 *@version    $Id: GenericObservable.java,v 1.2 2003/06/30 06:58:56 rrate Exp $
 */
public class GenericObservable extends Object implements IObservable {

	/**
	 *  holds all registered observers
	 */
	private Vector myObservers = new Vector();

	/**
	 *  Creates new GenericObservable
	 */
	public GenericObservable() {
	}

	/**
	 *  add an observer
	 *
	 *@param  theObserver  The feature to be added to the Observer attribute
	 */
	public void addObserver(IObserver theObserver) {
		this.myObservers.addElement(theObserver);
	}

	/**
	 *  delete all registered Observers
	 */
	public void deleteAllObservers() {
		this.myObservers.removeAllElements();
	}

	/**
	 *  delete an observer
	 *
	 *@param  theObserver  Description of Parameter
	 */
	public void deleteObserver(IObserver theObserver) {
		this.myObservers.removeElement(theObserver);
	}

	/**
	 *  iterate through the list of observers and notify them
	 *
	 *@param  theObserved  Description of Parameter
	 *@param  changeCode   Description of Parameter
	 */
	public void notifyObservers(Object theObserved, Object changeCode) {
		Enumeration myObserversList = this.myObservers.elements();
		while (myObserversList.hasMoreElements()) {
			IObserver theObserver = (IObserver) myObserversList.nextElement();
			theObserver.observableUpdate(theObserved, changeCode);
		}
	}
}
