package com.pallas.unicore.utility;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 *@author     Thomas Kentemich
 *@created    17. September 2001
 *@version    $Id: DeleteAll.java,v 1.2 2003/06/30 06:59:39 rrate Exp $
 */

public class DeleteAll {

	/**
	 *  Recursivley deletes all subdirectories and files in
	 *
	 *@param  what                       Description of Parameter
	 *@return                            Description of the Returned Value
	 *@exception  FileNotFoundException  Description of Exception
	 *@exception  IOException            Description of Exception
	 */
	public final static boolean deleteAll(File what)
		throws FileNotFoundException, IOException {
		if (what == null) {
			return false;
		}
		if (what.isDirectory()) {
			// recursively call deleteAll
			File[] files = what.listFiles();
			for (int i = 0; i < files.length; i++) {
				deleteAll(files[i]);
			}
		}
		return what.delete();
	}

	/**
	 *  Constructor for the DeleteAll object
	 */
	public DeleteAll() {
	}
}
