package com.pallas.unicore.utility;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.util.Vector;

/**
 *@author     Ralf Ratering
 *@created    29. August 2001
 *@version    $Id: TransferableVector.java,v 1.2 2003/06/30 06:59:37 rrate Exp $
 */
public class TransferableVector implements Transferable {
	private DataFlavor flavor;
	private Vector vector;

	/**
	 *  Constructor for the TransferableVector object
	 *
	 *@param  flavor  Description of the Parameter
	 */
	public TransferableVector(DataFlavor flavor) {
		this.flavor = flavor;
		this.vector = new Vector();
	}

	/**
	 *  Description of the Method
	 *
	 *@param  transferable  Description of the Parameter
	 */
	public void add(Transferable transferable)
		throws UnsupportedFlavorException {
		if (!transferable.isDataFlavorSupported(flavor)) {
			throw new UnsupportedFlavorException(flavor);
		}
		vector.add(transferable);

	}

	/**
	 *  Description of the Method
	 *
	 *@param  i  Description of the Parameter
	 *@return    Description of the Return Value
	 */
	public Transferable elementAt(int i) {
		return (Transferable) vector.elementAt(i);
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public Transferable firstElement() {
		return (Transferable) vector.firstElement();
	}

	/**
	 *  Transferable interface:
	 *
	 *@param  flavor                          Description of Parameter
	 *@return                                 The TransferData value
	 *@exception  UnsupportedFlavorException  Description of Exception
	 */
	public synchronized Object getTransferData(DataFlavor flavor)
		throws UnsupportedFlavorException {

		if (this.flavor.equals(flavor)) {
			return this;
		} else {
			throw new UnsupportedFlavorException(flavor);
		}
	}

	/**
	 *  Transferable interface:
	 *
	 *@return    The TransferDataFlavors value
	 */
	public synchronized DataFlavor[] getTransferDataFlavors() {
		DataFlavor[] flavors = { flavor };
		return flavors;
	}

	/**
	 *  Transferable interface:
	 *
	 *@param  flavor  Description of Parameter
	 *@return         The DataFlavorSupported value
	 */
	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return this.flavor.equals(flavor);
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public int size() {
		return vector.size();
	}

}
