package com.pallas.unicore.utility;

import java.math.BigInteger;


/**
 *  <p>
 *
 *  Title: </p> <p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: </p>
 *
 *@author     unascribed
 *@created    May 21, 2002
 *@version    1.0
 */
public class UrlEncoder {
    private static String unsafeString;
    private final static String[] hexVals = {
        "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", 
        "E", "F"
    };

    public UrlEncoder() {

        //      char data[] = {'\"', '<', '>', '$', '\\', '^', '[', ']', '`', '+', '$', ',' }; // full blown
        char[] data = { '\"', '<', '>', '$', '^', '[', ']', '`', '+', '$', ',' }; // adapted
        unsafeString = new String(data);
    }

    public String encodeURL(String val) {
        String newStr = new String();
        for (int i = 0; i < val.length(); i++) {
            if (val.substring(i, i + 1).charAt(0) < 255) { // hack to eliminate the rest of unicode from this
                if (isUnsafe(val.charAt(i)) == false) {
                    newStr = newStr + val.substring(i, i + 1);
                } else {
                    newStr = newStr + convert(val.substring(i, i + 1));
                }
            } // woopsie! restore. 
            else {
            }
        }
        return newStr;
    }


    public static String decodeURL(String val) { 
        int backlen = val.length();
	int lastpercent = -1;
        String newStr = "";
        String frag = "";
        String encval = "";
        while (backlen > 0) {
            lastpercent = val.lastIndexOf("%");
            if (lastpercent != -1) { // we found a % char. Need to handle

                // everything *after* the %
                frag = val.substring(lastpercent + 1, val.length());

                // re-assign val to everything *before* the %
                val = val.substring(0, lastpercent);
                if (frag.length() >= 2) { // end contains unencoded

                    //  alert ("frag is greater than or equal to 2");
                    encval = frag.substring(0, 2);
                    newStr = frag.substring(2, frag.length()) + newStr;

                    //convert the char here. for now it just doesn't add it.
                    if ("01234567890abcdefABCDEF".indexOf(encval.substring(0, 
                                                                           1)) != -1 && 
                        "01234567890abcdefABCDEF".indexOf(encval.substring(1, 
                                                                           2)) != -1) {
			BigInteger bI= new BigInteger(encval, 16);
			encval = (new Character((char)bI.intValue()).toString());										   
                        // encval = String.fromCharCode(parseInt(encval, 16)); // hex to base 10
                        newStr = encval + newStr; // prepend the char in
                    }

                    // if so, convert. Else, ignore it.
                }

                // adjust length of the string to be examined
                backlen = lastpercent;

                // alert ("backlen at the end of the found % if is: " + backlen);
            } else { // if there is no %, just leave the value as-is
                newStr = val + newStr;
                backlen = 0;
            }
        } // end while
	return newStr;
    }


    private static String convert(String val) {
        int num = val.charAt(0);
        int temp = 0;
        String hexString = new String();
        while (num >= 16) {
            temp = num % 16;
            num = (int)java.lang.Math.floor(num / 16);
            hexString += hexVals[temp];
        }
        hexString += hexVals[num];
        String reverse = new String();
        int len = hexString.length();
        for (int i = 0; i < len; i++) {
            reverse = reverse + hexString.substring(len - i - 1, len - i);
        }
        return "%" + reverse;
    }


    private boolean isUnsafe(char compare) {
        if (unsafeString.indexOf(compare) == -1 && compare > 32 && 
            compare < 123) {
            return false;
        } else {
            return true;
        }
    }
}
