package com.pallas.unicore.utility;

import java.util.logging.Logger;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

import com.pallas.unicore.client.Client;
import com.pallas.unicore.resourcemanager.ResourceManager;

/**
 *@author     Ralf Ratering
 *@created    7. September 2001
 *@version    $Id: UserMessages.java,v 1.3 2003/06/30 06:59:36 rrate Exp $
 */
public class UserMessages {
	private static Logger logger =
		Logger.getLogger("com.pallas.unicore.utility");

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void error(final String message) {
		if (!Client.getRunningMode()) {
			if (SwingUtilities.isEventDispatchThread()) {
				showError(message);
			} else {
				Runnable doUpgrade = new Runnable() {
					/**
					 *  Main processing method for the UserMessages object
					 */
					public void run() {
						showError(message);
					}
				};
				try {
					SwingUtilities.invokeAndWait(doUpgrade);
				} catch (java.lang.reflect.InvocationTargetException e) {
				} catch (java.lang.InterruptedException e) {
				}
			}
		}
		logger.severe(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of the Parameter
	 *@param  reason   Description of the Parameter
	 */
	public static void error(String message, String reason) {
		if (reason != null && !reason.equals("")) {
			message += "\nReason: " + reason;
		}
		error(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void info(final String message) {
		if (!Client.getRunningMode()) {
			if (SwingUtilities.isEventDispatchThread()) {
				showInfo(message);
			} else {
				Runnable doUpgrade = new Runnable() {
					/**
					 *  Main processing method for the UserMessages object
					 */
					public void run() {
						showInfo(message);
					}
				};
				try {
					SwingUtilities.invokeAndWait(doUpgrade);
				} catch (java.lang.reflect.InvocationTargetException e) {
				} catch (java.lang.InterruptedException e) {
				}

			}
		}
		logger.info(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of the Parameter
	 *@param  reason   Description of the Parameter
	 */
	public static void info(String message, String reason) {
		if (reason != null && !reason.equals("")) {
			message += "\nReason: " + reason;
		}
		info(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void print(String message) {
		logger.fine(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of the Parameter
	 *@param  reason   Description of the Parameter
	 */
	public static void print(String message, String reason) {
		if (reason != null && !reason.equals("")) {
			message += "\nReason: " + reason;
		}
		print(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void showError(String message) {
		JOptionPane.showMessageDialog(
			ResourceManager.getCurrentInstance(),
			message,
			"UNICOREpro: Error",
			JOptionPane.ERROR_MESSAGE);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void showInfo(String message) {
		JOptionPane.showMessageDialog(
			ResourceManager.getCurrentInstance(),
			message,
			"UNICOREpro: Information",
			JOptionPane.INFORMATION_MESSAGE);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void showWarning(String message) {
		JOptionPane.showMessageDialog(
			ResourceManager.getCurrentInstance(),
			message,
			"UNICOREpro: Warning",
			JOptionPane.WARNING_MESSAGE);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of Parameter
	 */
	public static void warning(final String message) {
		if (!Client.getRunningMode()) {
			if (SwingUtilities.isEventDispatchThread()) {
				showWarning(message);
			} else {
				Runnable doUpgrade = new Runnable() {
					/**
					 *  Main processing method for the UserMessages object
					 */
					public void run() {
						showWarning(message);
					}
				};
				try {
					SwingUtilities.invokeAndWait(doUpgrade);
				} catch (java.lang.reflect.InvocationTargetException e) {
				} catch (java.lang.InterruptedException e) {
				}
			}
		}

		logger.warning(message);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  message  Description of the Parameter
	 *@param  reason   Description of the Parameter
	 */
	public static void warning(String message, String reason) {
		if (reason != null && !reason.equals("")) {
			message += "\nReason: " + reason;
		}
		warning(message);
	}

	/**
	 *  Constructor for the UserMessages object
	 */
	private UserMessages() {
	}
}
