package com.pallas.util.queues;

import java.util.logging.Logger;

/**
 *  Description of the Class
 *
 *@author     Thomas Kentemich
 *@created    17. Februar 2003
 *@version    $Id: Dispatcher.java,v 1.3 2003/06/30 06:59:59 rrate Exp $
 */
public class Dispatcher {

	/**
	 *  Description of the Class
	 *
	 *@created    17. Februar 2003
	 */
	public class SomeWork implements IWork {

		private int count = 0;

		/**
		 *  Description of the Method
		 */
		public void performTask() {

			logger.info(
				">>>> Yuck " + count++ +Thread.currentThread().getName());
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				logger.info("Work interrupted");
			}
		}

		/**
		 *  Description of the Method
		 *
		 *@return    Description of the Return Value
		 */
		public String toSTring() {
			return "SomeWork";
		}
	}

	/**
	 *  Description of the Field
	 */
	protected static Logger logger = Logger.getLogger("com.pallas.util.queues");

	/**
	 *  The main program for the Dispatcher class
	 *
	 *@param  args  The command line arguments
	 */
	public static void main(String[] args) {
		Dispatcher dispatcher = new Dispatcher();
		dispatcher.createThreads(10);

		dispatcher.doWork();

		dispatcher.stopThreads();

	}
	private int runningThreads;
	private RequestQueue serviceRequests = new RequestQueue();
	private ThreadGroup workers = new ThreadGroup("Worker");

	/**
	 *  Constructor for the Dispatcher object
	 */
	public Dispatcher() {
	}

	/**
	 *  Description of the Method
	 *
	 *@param  numberOfThreads  Description of the Parameter
	 *@return                  Description of the Return Value
	 */
	public int createThreads(int numberOfThreads) {
		for (int i = 0; i < numberOfThreads; i++) {
			try {
				WorkerThread worker =
					WorkerThread.getInstance(
						workers,
						("Worker_" + i),
						serviceRequests);
				worker.start();
				runningThreads++;
			} catch (InterruptedException e) {
				logger.severe("Thread creation interrupted");
			}
		}
		logger.info("Created " + runningThreads + " threads");
		return runningThreads;
	}

	/**
	 *  Description of the Method
	 */
	private void doWork() {
		SomeWork work = new SomeWork();
		for (int i = 0; i < 15; i++) {

			serviceRequests.enqueue(work);
		}
		System.out.println(serviceRequests);
	}

	/**
	 *  Description of the Method
	 *
	 *@param  request  Description of the Parameter
	 */
	public void pushRequest(IWork request) {
		logger.fine("Push new request.");
		serviceRequests.enqueue(request);
	}

	/**
	 *  Description of the Method
	 */
	public void stopThreads() {
		Thread[] actives = new Thread[runningThreads];
		int activeCount = workers.enumerate(actives);
		StopObject stopper = new StopObject();
		for (int i = 0; i < activeCount; i++) {
			WorkerThread next = (WorkerThread) actives[i];
			serviceRequests.enqueue(stopper);

		}
		for (int i = 0; i < activeCount; i++) {
			WorkerThread next = (WorkerThread) actives[i];
			try {
				next.join(30000);
			} catch (InterruptedException e) {
				logger.fine("Thread stop  interrupted");
			}
		}
	}

}
