package com.pallas.util.queues;

import java.util.ArrayList;

/**
 *  Description of the Class
 *
 *@author     Thomas Kentemich
 *@author     Ralf Ratering
 *@created    17. Februar 2003
 *@version    $Id: Fifo.java,v 1.2 2003/06/30 06:59:59 rrate Exp $
 */
public class Fifo {
	/**
	 *  Description of the Field
	 */
	protected ArrayList data;

	/**
	 *  Constructs an empty queue.
	 */
	public Fifo() {
		data = new ArrayList();
	}

	/**
	 *  Constructs an empty queue of appropriate size
	 *
	 *@param  size  initial size
	 */
	public Fifo(int size) {
		data = new ArrayList(size);
	}

	/**
	 *  removes all elements from the queue.
	 */
	public void clear() {
		data.clear();
	}

	/**
	 *  Returns true if the queue is empty
	 *
	 *@return    true if empty
	 */
	public boolean isEmpty() {
		return data.isEmpty();
	}

	/**
	 *  if the queue is not empty, the element at the head of the queue is
	 *  returned
	 *
	 *@return    head of the queue
	 */
	public Object peek() {
		return data.get(0);
	}

	/**
	 *  if the queue is not empty, the element at the head of the queue is
	 *  removed and returned
	 *
	 *@return    head of the queue
	 */
	public Object pop() {
		Object result = data.iterator().next();
		data.remove(0);
		return result;
	}

	/**
	 *  An Object value is added to the tail of the structure
	 *
	 *@param  value  Object to be added
	 */
	public void push(Object value) {
		data.add(value);
	}

	/**
	 *  returns the number of elements in the queue.
	 *
	 *@return    number of elements in the queue.
	 */
	public int size() {
		return data.size();
	}

}
