package com.pallas.util.queues;

import java.util.NoSuchElementException;
import java.util.logging.Logger;

/**
 *  Description of the Class
 *
 *@author     Thomas Kentemich
 *@created    17. Februar 2003
 *@version    $Id: RequestQueue.java,v 1.3 2003/06/30 06:59:58 rrate Exp $
 */
public class RequestQueue {

	/**
	 *  Description of the Class
	 *
	 *@author     rrate
	 *@created    17. Februar 2003
	 */
	private class Semaphore {
		private int semaphore = 0;

		/**
		 *  Description of the Method
		 */
		public synchronized void sendSignal() {
			semaphore++;
			this.notify();
		}

		/**
		 *  Description of the Method
		 *
		 *@exception  InterruptedException  Description of the Exception
		 */
		public synchronized void waitForSignal() throws InterruptedException {
			if (semaphore > 0) {
				semaphore--;
			} else {
				while (semaphore < 1) {
					this.wait();
				}
				semaphore--;
			}
		}
	}
	/**
	 *  Description of the Field
	 */
	protected static Logger logger = Logger.getLogger("com.pallas.util.queues");

	private Fifo fifo = new Fifo();
	private Semaphore semaphore = new Semaphore();

	int waitingThreads = 0;

	/**
	 *  Adds a feature to the Thread attribute of the RequestQueue object
	 */
	private synchronized void addThread() {
		waitingThreads++;
	}

	/**
	 *  Description of the Method
	 *
	 *@return                             Description of the Return Value
	 *@exception  NoSuchElementException  Description of the Exception
	 *@exception  InterruptedException    Description of the Exception
	 */
	public IWork dequeue()
		throws NoSuchElementException, InterruptedException {
		addThread();
		//		logger.info("Pause thread: "+ Thread.currentThread().getName());
		semaphore.waitForSignal();
		removeThread();
		//		logger.info("Wakeup thread."+ Thread.currentThread().getName());
		IWork request = null;
		//	synchronized (this) {
		request = (IWork) fifo.pop();
		//		logger.info("Pop object");
		//	}
		return request;
	}

	/**
	 *  Description of the Method
	 *
	 *@param  request  Description of the Parameter
	 *@return          Description of the Return Value
	 */
	public synchronized int enqueue(IWork request) {
		logger.fine("Push object");
		fifo.push(request);
		semaphore.sendSignal();
		return waitingThreads;
	}

	/**
	 *  Description of the Method
	 */
	private synchronized void removeThread() {
		waitingThreads--;
	}

	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Return Value
	 */
	public String toString() {
		return fifo.toString();
	}

}
