package org.unicore;

/**
 * The Identifier of an AbstractJob
 *
 * @see org.unicore.ajo.AbstractJob
 *
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 3
 *
 * @version AJOIdentifier.java 1.5 05/13/02
 * 
 **/
public final class AJOIdentifier extends AAIdentifier {

    public AJOIdentifier() {
        this("");
    }

    /**
     * Create a new AbstractJob Identifier with a unique value.
     *
     * @param name The name of the AbstractJob Identifier (convenience only).
     *
     **/
    public AJOIdentifier(String name) {
        super(name);
    }

    public AJOIdentifier(String name, int value) {
        super(name, value);
    }

    static final long serialVersionUID = 8193803822404957653L;
}
//
// Change history:
//          15 Mar 2002 SvdB V4, no arg constructor
//           4 May 2000 SvdB Created 
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
