package org.unicore;

/**
 * The Identifier of a Portfolio
 *
 * @see org.unicore.ajo.Portfolio
 *
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 3
 *
 * @version PortfolioIdentifier.java 1.6 05/13/02 <br>
 * 
 **/
public final class PortfolioIdentifier extends Identifier {

    public PortfolioIdentifier() {
        super("");
    }

    /**
     * Create a new Portfolio Identifier with a unique value.
     *
     * @param name The name of the Portfolio Identifier (convenience only).
     *
     **/
    public PortfolioIdentifier(String name) {
        super(name);
    }

    /**
     * Create a new Portfolio Identifier with the given value.
     *
     * @param name The name of the Portfolio Identifier (convenience only).
     * @param value The value for this Identifier.
     *
     **/
    public PortfolioIdentifier(String name, int value) {
        super(name, value);
    }

    static final long serialVersionUID = 1390579505632560633L;

}
//
// Change history:
//          15 Mar 2002 SvdB V4, no arg constructor
//           4 May 2000 SvdB Created
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
