package org.unicore.ajo;

import org.unicore.sets.ResourceSet;
import org.unicore.ajo.TaskResourceDAG;

/**
 * Test if the resources are available at the Vsite.
 * 
 * @author D. Snelling (fecit)
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 3.6
 *
 * @version CheckResources.java 1.8 09/09/02
 *
 * @see org.unicore.outcome.CheckResources_Outcome
 *
 **/
public class CheckResources extends QueryService {

    static final long serialVersionUID = -5471970151320447776L;

    protected TaskResourceDAG dag = null;

    /**
     * Create a new CheckResources.
     * <p>
     * @param name The name of the CheckResources
     * @param extra_information Client supplied extra information about the CheckResources
     * @param dag TaskResourceDag
     *
     **/
    public CheckResources(String name, byte[] extra_information, TaskResourceDAG dag) {
        super(name,extra_information);
        this.dag = dag;
    }

    /**
     * Create a new CheckResources.
     * <p>
     * @param name The name of the CheckResources
     * @param dag TaskResourceDag
     *
     **/
    public CheckResources(String name, TaskResourceDAG dag) {
        super(name,(byte []) null);
        this.dag = dag;
    }

    /**
     * Create a new CheckResources.
     * <p>
     * @param name The name of the CheckResources
     *
     **/
    public CheckResources(String name) {
        this(name,(byte[]) null, (TaskResourceDAG) null);
    }
    
    public CheckResources() {
        this("");
    }
    
    /** 
     * Sets the TaskResourceDAG for this ResourceCheckTask.
     * @param dag TaskResourceDAG
     *
     */
   public void setTaskResourceDag(TaskResourceDAG dag) {
        this.dag =  dag;
    }
    
    /**
     * Returns the TaskResourceDAG for this ResourceCheckTask.
     * @return TaskResourceDAG
     *
     */
   public TaskResourceDAG getTaskResourceDag() {
        if(dag == null) dag = new TaskResourceDAG();
        return this.dag;
    }
}
//
// Change history:
//          18 Mar 2002 SvdB V4 no arg constructor
//          11 Dec 2001 DFS Created
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
