package org.unicore.ajo;

/**
 * Dummy AbstractAction will execute and finish with the selected status.
 *
 * @author S. van den Berghe (Fujitsu Laboratories of Europe)
 *
 * @since AJO 4.0
 *
 * @version Dummy.java 1.8 10/30/02
 *
 * @see org.unicore.outcome.Dummy_Outcome
 *
 **/
public class Dummy extends AbstractAction {

    static final long serialVersionUID = 400;

    /**
     * Create a new Dummy.
     * <p>
     * @param name The name of the Dummy
     * @param extra_information Client supplied extra information about the Dummy
     *
     **/
    public Dummy(String name, byte[] extra_information) {
        super(name, extra_information);
    }

    public Dummy() {
        this(null,null);
    }

    public Dummy(String name) {
        this(name,null);
    }

    public Dummy(String name, boolean end_successful) {
        this(name,null);
        this.end_successful = end_successful;
    }

    boolean end_successful = true;

    /**
     * If set to true, then the execution of this AbstractAction
     * get a final status of {@link org.unicore.outcome.AbstractActionStatus}.SUCCESSFUL,
     * otherwise the final status is {@link org.unicore.outcome.AbstractActionStatus}.NOT_SUCCESSFUL.
     *
     **/
    public void setEndSuccessful(boolean b) {end_successful = b;}

    public boolean endSuccessful() {return end_successful;}

}
//
// Change history:
//           8 Aug 2002 SvdB Created 
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
