package org.unicore.ajo;

import java.util.Enumeration;

/**
 * Compilers can produce listings containing various information
 * about the compilation and this may occur at different
 * levels of detail.
 *
 * @see CompileTask#getListingLevel
 *
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 1
 *
 * @version ListingLevel.java 1.4 05/13/02 
 *
 **/
public final class ListingLevel extends Enum {

    static final long serialVersionUID = -6728726552347182590L;

    /**
     * No List data
     *
     **/
    public final static ListingLevel NONE = new ListingLevel(0,"No source listing");

    /**
     * Sensible size.
     *
     **/
    public final static ListingLevel ON = new ListingLevel(1,"source listing");

    /**
     * Go to town.
     *
     **/
    public final static ListingLevel FULL = new ListingLevel(2,"Full source listing");


    /**
     * Constructor for this Class.
     *
     **/
    private ListingLevel(int aValue, String aName) {
        super(aValue,aName);
    }

    /**
     * Return a enumeration over the instances of ListingLevel
     *
     **/
    public static Enumeration elements() {
        return Enum.elements( NONE.getClass() );
    }

}
//
// Change history:
//           5 May 2000 SvdB V3.0 
//           7 Dec 1998 SvdB Second release to Unicore 
//          24 Feb 1998 SvdB created 
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
