package org.unicore.ajo;

import java.util.Enumeration;

/**
 * Possible values of the Fortran preprocessing level.
 *
 * @see FortranTask
 * 
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 3
 *
 * @version PreprocessLevel.java 1.4 05/13/02 
 *
 **/
public final class PreprocessLevel extends Enum {

    static final long serialVersionUID = -8820541719250061163L;

    /**
     * None
     *
     **/
    public final static PreprocessLevel NONE = new PreprocessLevel(0,"None");

    /**
     * Preprocess
     *
     **/
    public final static PreprocessLevel PREPROCESS  = new PreprocessLevel(1,"Preprocess");

    /**
     * Preprocess only
     *
     **/
    public final static PreprocessLevel PREPROCESS_ONLY  = new PreprocessLevel(2,"Preprocess Only");

    /**
     * Constructor for this Class.
     *
     **/
    private PreprocessLevel(int aValue, String aName) {
        super(aValue,aName);
    }

    /**
     * Return a enumeration over the instances of PreprocessLevel
     *
     **/
    public static Enumeration elements() {
        return Enum.elements( NONE.getClass() );
    }

}
//
// Change history:
//           6 Dec 1999, SvdB created
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
