package org.unicore.outcome;

import org.unicore.ajo.AbstractService;

/**
 * The status and logs of the execution of an {@link org.unicore.ajo.AbstractService}
 *
 * @see org.unicore.ajo.ControlService
 * 
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 2
 *
 * @version AbstractService_Outcome.java 1.5 05/13/02 
 * 
 **/
public abstract class AbstractService_Outcome extends Outcome {

    static final long serialVersionUID = 9074126707447421709L;

    /**
     * Create a new AbstractService_Outcome.
     * <p>
     * @param source The AbstractService for which this Outcome will hold the results.
     * @param initial The status of the AbstractService at the time that the Outcome is created.
     *
     **/
    protected AbstractService_Outcome( AbstractService      source,
                                       AbstractActionStatus initial_status
                            ) {
        super(source, initial_status);
    }

}
//
// Change history:
//           5 May 2000 SvdB V3.0 
//          10 Dec 1998 SvdB Made abstract class 
//           7 Dec 1998 SvdB Second release to Unicore 
//           6 Nov 1998 SvdB Created 
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
