package org.unicore.outcome;

import org.unicore.ajo.DeleteFile;

/**
 * The status and logs of executing a {@link org.unicore.ajo.DeleteFile}.
 * <p>
 * This task deletes a file on a Vsite 
 * and so the Outcome reports only on the success or
 * failure of the delete.
 *
 * @see org.unicore.ajo.DeleteFile
 *
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 3
 *
 * @version DeleteFile_Outcome.java 1.6 05/13/02 
 * 
 **/
public class DeleteFile_Outcome extends AbstractTask_Outcome {

    static final long serialVersionUID = -8066803452212111032L;

    public DeleteFile_Outcome() {
        this(null,null);
    }

    /**
     * Create a new DeleteFile_Outcome.
     * <p>
     * This will hold the standard information from {@link Outcome}.
     *
     * @param source The DeleteFile for which this Outcome will hold the results.
     * @param initial The status of the DeleteFile at the time that the Outcome is created.
     *
     **/
    public DeleteFile_Outcome( DeleteFile source, AbstractActionStatus initial) {
        super(source, initial);
    }

}
//
// Change history:
//          18 Mar 2002 SvdB V4 no arg constructor
//          26 Jun 2000 SvdB Renamed from Delete
//           5 May 2000 SvdB Created
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
