package org.unicore.outcome;

import org.unicore.ajo.Dummy;

/**
 * The status and logs of executing a {@link org.unicore.ajo.Dummy}.
 *
 * @see org.unicore.ajo.Dummy
 *
 * @author S. van den Berghe (Fujitsu Laboratories of Europe)
 *
 * @since AJO 4.0
 *
 * @version Dummy_Outcome.java 1.2 08/13/02
 * 
 **/
public class Dummy_Outcome extends Outcome {

    static final long serialVersionUID = 400;

    public Dummy_Outcome() {
        this(null,null);
    }

    /**
     * Create a new Dummy_Outcome.
     * <p>
     * This will hold the standard information from {@link Outcome}.
     *
     * @param source The Dummy for which this Outcome will hold the results.
     * @param initial The status of the RenameFile at the time that the Outcome is created.
     *
     **/
    public Dummy_Outcome(Dummy source, AbstractActionStatus initial) {
        super(source, initial);
    }

}
//
// Change history:
//           8 Aug 2002 SvdB Created
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
