package org.unicore.resources;

/**
 * Class to advertise brokering capability. 
 *
 * @author D. Snelling (fecit)
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 4.0
 *
 * @version Broker.java 1.1 05/13/02
 *
 **/
public final class Broker extends Resource {

    static final long serialVersionUID = 0;

    /**
     * Create a new Broker
     *
     * @param description A description of the Broker
     *
     **/
    public Broker(String description) {
        super (description);
    }

    /**
     * Create a new Broker
     *
     **/
    public Broker() {
        this("Broker");
    }

    /**
     * All Brokers are equal. 
     * <p>
     * <em> This may not be expected behaviour.</em>
     *
     **/
    public boolean equals(Object o) {
        try {
            return ( o.getClass() == getClass() );
        }
        catch(NullPointerException nex) {
            return false;
        }
    }

    /**
     * Return a hash code for this Broker. Returns the same hash code
     * for all instances.
     *
     **/
    public int hashCode() {
        return 668290393;
    }

    public String toString() {
        return "Broker ";
    }

}
//
// Change history:
//          13 May 202 SvdB Created
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
