package org.unicore.resources;

/**
 * Provides numerical information about a Vsite.
 *
 * @author D. Snelling (fecit)
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 3
 *
 * @version NumericInfoResource.java 1.12 05/13/02
 *
 **/
public final class NumericInfoResource extends InformationResource {

    static final long serialVersionUID = 7306155610979524382L;

    /**
     * Create a new NumericInfoResource
     *
     * @param description A description of the NumericInfoResource
     * @param tag Identifies the nature of the information
     * @param value The supplied information
     *
     **/
    public NumericInfoResource(String description, String tag, double value) {
        super (description, tag);
        this.value = value;
    }

    /**
     * Create a new NumericInfoResource
     *
     **/
    public NumericInfoResource() {
        this("undescribed NumericInfoResource","untagged NumericInfoResource", 0.0);
    }

    private double value;
    /**
     * Get the information.
     *
     **/
    public  double getValue ()             { return value; }

    /**
     * Set the information.
     *
     **/
    public  void   setValue (double value) { this.value = value; }

    /**
     * NumericInfoResources are equal if both tag and value are equal
     *
     **/
    public boolean equals(Object o) {
        if(super.equals(o)) {
            return getValue() == ((NumericInfoResource)o).getValue();
        }
        else {
            return false;
        }
    }

    public String toString() {
        return getTag() + ": " + getValue();
    }

}
//
// Change history:
//          21 Jan 2000  DFS  First release with V3.0 resource model.
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
