package org.unicore.resources;

/**
 * Resource for access to the file whole file system.
 * <p>
 * The storage root file path component is (usually) /
 *
 * @author D. Snelling (fecit)
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 4.0
 *
 * @version Root.java 1.3 09/09/02
 *
 **/
public final class Root extends PathedStorage {

    static final long serialVersionUID = 0;

    public Root() {
        this("",0.0,0.0,0.0,null);
    }

    /**
     * Create a new Root.
     *
     * @param description A description of the Root
     * @param maxrequest Maximum amount of storage allowed (in megabytes)
     * @param defaultrequest Amount of storage granted if no specific request received (in megabytes)
     * @param minrequest Minimum amount of storage allowed (in megabytes)
     * @param path Path to a subdirectory within the filesystem (relative to "/")
     *
     **/
    public Root (String description,
                 double maxrequest,
                 double defaultrequest, 
                 double minrequest,
                 String path) {
        super(description, maxrequest, defaultrequest, minrequest, path);
        setName("Root");
    }

}
//
// Change history:
//          19 Apr 2002 SvdB Created
//
//             Copyright (c) UNICORE Forum e.V. 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
