package org.unicore.sets;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.unicore.*;
import org.unicore.ajo.*;
import org.unicore.outcome.*;
import org.unicore.resources.*;
import org.unicore.upl.*;

/**
 * An interface to a type-safe Enumeration type for <tt>TaskIDStatus</tt>s. 
 *
 * @author S. van den Berghe (fecit)
 *
 * @since AJO 1
 *
 * @version  enumerationTemplate 1.9 09/09/02
 * 
 **/
public class TaskIDStatusEnumeration extends Unicore {

    Enumeration e;

    public TaskIDStatusEnumeration(Hashtable in) {
        e = in.elements();
    }

    public TaskIDStatusEnumeration(Vector in) {
        e = in.elements();
    }

    public boolean hasMoreElements() {return e.hasMoreElements();}

    public TaskIDStatus nextElement() {return (TaskIDStatus)e.nextElement();}

    static final long serialVersionUID = 1L;

}
//
// Change history:
//           4 Oct 2001 SvdB Unfinalised
//           5 May 2000 SvdB V3.0 
//          11 Mar 1999 SvdB Includes serialVersionUID 
//          11 Mar 1999 SvdB Constructed from Hashtable too (constructors public) 
//           7 Dec 1998 SvdB Second release to Unicore 
//          12 Jun 1998 SvdB Initial release to Unicore 
//
//             Copyright (c) UNICORE Forum e.V. 2000 - 2002
//
//     Use and distribution is subject to the Community Source Licence.
//     A copy of the Community Source Licence came with this distribution.
//
//     Further information can be obtained from www.unicore.org
